/* AT&T DSP32, 8th order IIR, 4-mult. Direct Form II SOSs  Sep 29, 1988 */
/*									*/
/* 8th order IIR realized with 4-multiply Direct Form II second		*/
/* order sections (SOSs) for DSP32/DSP32C.	4iir8.s			*/
/* Execution requires 19 cycles per sample including I/0:		*/
/*									*/
/*	DSP32 (160ns) = 19 x 160ns = 3.04us;  328.9 kHz sample rate	*/
/*	DSP32C (80ns) = 19 x 80ns = 1.52us;  657.9 kHz sample rate	*/
/* Memory requirements:							*/
/*	Program:  24 words						*/
/*	Data:	  24 words (8 state variables + 16 coefficients)	*/
/* All instructions are single-cycle. Each line is a a single		*/
/*     assembly language instruction.					*/



	 r2 = coef	/* r3 points to table of coefficients.	*/
	 r3 = data	/* r3 and r4 point to state variables	*/
	 r4 = data
	r17 = -28	/* Used to re-initialize state var pointer.	*/
	r16 = -60	/* Used to re-initialize coefficient pointer.	*/

loop:	a0 = float(ibuf)	/* Input sample and convert to 32-bits.	*/

	a0 = a0 - *r3++ * *r2++		/* d1(1) term	*/
*r4++ = a0 = a0 - *r3-- * *r2++		/* d2(1) term	*/
	a0 = a0 + (*r4++=*r3++) * *r2++	/* n1(1) term	*/
	a0 = a0 + *r3++ * *r2++		/* n2(1) term	*/

	a0 = a0 - *r3++ * *r2++		/* d1(1) term	*/
*r4++ = a0 = a0 - *r3-- * *r2++		/* d2(1) term	*/
	a0 = a0 + (*r4++=*r3++) * *r2++	/* n1(1) term	*/
	a0 = a0 + *r3++ * *r2++		/* n2(1) term	*/

	a0 = a0 - *r3++ * *r2++		/* d1(1) term	*/
*r4++ = a0 = a0 - *r3-- * *r2++		/* d2(1) term	*/
	a0 = a0 + (*r4++=*r3++) * *r2++	/* n1(1) term	*/
	a0 = a0 + *r3++ * *r2++		/* n2(1) term	*/

	a0 = a0 - *r3++ * *r2++			/* d1(4) term	*/
*r4++ = a0 = a0 - *r3-- * *r2++			/* d2(4) term	*/
	a0 = a0 + (*r4++r17=*r3++) * *r2++	/* n1(4) term	*/
	a0 = a0 + *r3++r17 * *r2++r16		/* n2(4) term	*/

	goto loop
	obuf = a0 = int(a0)	/* Latent instruction; convert result	*/
				/* to 16-bits and output.		*/

	/* coefficients stored as: d1, d2, n1, n2 */
coef:	float	-1.022403, 0.3256819, 1.452737, 1.002347
	float	-1.022403, 0.3256819, 1.452737, 1.002347
	float	-1.022403, 0.3256819, 1.452737, 1.002347
	float	-1.022403, 0.3256819, 1.452737, 1.002347

.rsect ".hi_ram"

data:	8*float	0.0

