/* AT&T DSP32, 8th order IIR, 5-mult. Direct Form II SOSs  Sep 29, 1988 */
/*									*/
/* 8th order IIR realized with 5-multiply Direct Form II 		*/
/* second order sections (SOSs) for DSP32/DSP32C.	5iir8.s		*/
/* Execution requires 27 cycles per sample including I/0:		*/
/*									*/
/*	DSP32 (160ns) = 27 x 160ns = 4.32us;  231.5 kHz sample rate	*/
/*	DSP32C (80ns) = 27 x 80ns = 2.16us;  463.0 kHz sample rate	*/
/* Memory requirements:							*/
/*	Program:  20 words						*/
/*	Data:	  28 words (8 state variables + 20 coefficients)	*/
/* All instructions are single-cycle. Each line is a a single		*/
/*     assembly language instruction.					*/



         r2 = coef           /* r2 points to coefficients    */
         r3 = data           /* r3 points to state variables */
         r4 = data           /* r4 points to state variables */
        r15 = -28            /* Used to re-initialize state var ptr   */
        r16 = -76            /* Used to re-initialize coefficient ptr */

loop:    obuf=a0=int(a0)     /* Convert previous result and output. */
         a0 = float(ibuf)    /* Input new sample & conv to 32b */
         r1 = 1              /* r1 = no. of sections - 3     */

loop1:   a0 = a0 - *r3 * *r2++                /* d[i,2] term */
         a1 = *r3++ * *r2++                   /* n[i,2] term */
         a0 = a0 - *r3 * *r2++                /* d[i,1] term */
         a1 = a1 + (*r4++ = *r3++) * *r2++    /* n[i,1] term */
         if (r1-- >=0) goto loop1
         a0 = a1 + (*r4++ = a0) * *r2++       /* n[i,0] term */

         a0 = a0 - *r3 * *r2++                /* d[4,2] term */
         a1 = *r3++ * *r2++                   /* n[4,2] term */
         a0 = a0 - *r3 * *r2++                /* d[4,1] term */
         a1 = a1 + (*r4++ = *r3++r15) * *r2++ /* n[4,1] term */
         goto loop
         a0 = a1 + (*r4++r15 = a0) * *r2++r16 /* n[4,0] term */

 /* -------------------------------------------------------- */

coef:          /* filter coefficients: d2, n2, d1, n1, n0 */
	float 0.3256819, .08783738, -1.022403, 0.1276046, .08783738
	float 0.7197602, .3002430, -1.072848, 0.04345912, .3002430
	float 0.7197602, .3002430, -1.072848, 0.04345912, .3002430
	float 0.7197602, .3002430, -1.072848, 0.04345912, .3002430

.rsect ".hi_ram"	/* assembler directive	*/

data: 8*float 0.0

