/* AT&T DSP32, 8th order IIR, 5-mult. Direct Form I SOSs  Sep 29, 1988  */
/*									*/
/* 8th order IIR realized with 5-multiply Direct Form I (transposed)	*/
/* second order sections (SOSs) for DSP32/DSP32C.	5iirt8.s	*/
/* Execution requires 23 cycles per sample including I/0:		*/
/*									*/
/*	DSP32 (160ns) = 23 x 160ns = 3.68us;  271.7 kHz sample rate	*/
/*	DSP32C (80ns) = 23 x 80ns = 1.84us;  543.5 kHz sample rate	*/
/* Memory requirements:							*/
/*	Program:  29 words						*/
/*	Data:	  28 words (8 state variables + 20 coefficients)	*/
/* All instructions are single-cycle. Each line is a a single		*/
/*     assembly language instruction.					*/


	r2 = coef	/* r2 points to table of coefficients.	*/
	r3 = data	/* r3 and r4 point to state variables	*/
	r4 = data
	a3 = float(ibuf)	/* Input 1st sample and conv to 32-bit.	*/

	r15 = -28	/* Used to re-initialize state var pointer.	*/
	r16 = -76	/* Used to re-initialize coefficient pointer.	*/


loop: 	      a0 = *r3++ + a3 * *r2++       /* n[1,0] term */
	      a1 = *r3++ + a0 * *r2++       /* n[1,1] term */
	      a2 = a0 * *r2++               /* n[1,2] term */
	*r4++ = a1 = a1 - a0 * *r2++        /* d[1,1] term */
	*r4++ = a2 = a2 - a0 * *r2++        /* d[1,2] term */

	      a0 = *r3++ + a0 * *r2++       /* n[2,0] term */
	      a1 = *r3++ + a0 * *r2++       /* n[2,1] term */
	      a2 = a0 * *r2++               /* n[2,2] term */
	*r4++ = a1 = a1 - a0 * *r2++        /* d[2,1] term */
	*r4++ = a2 = a2 - a0 * *r2++        /* d[2,2] term */

	      a0 = *r3++ + a0 * *r2++       /* n[3,0] term */
	      a1 = *r3++ + a0 * *r2++       /* n[3,1] term */
	      a2 = a0 * *r2++               /* n[3,2] term */
	*r4++ = a1 = a1 - a0 * *r2++        /* d[3,1] term */
	*r4++ = a2 = a2 - a0 * *r2++        /* d[3,2] term */

		/* last section re-initializes r2, r3, and r4.	*/

	      a0 = *r3++ + a0 * *r2++       /* n[4,0] term */
	      a1 = *r3++r15 + a0 * *r2++    /* n[4,1] term */
	      a2 = a0 * *r2++               /* n[4,2] term */
	*r4++ = a1 = a1 - a0 * *r2++        /* d[4,1] term */
     *r4++r15 = a2 = a2 - a0 * *r2++r16     /* d[4,2] term */

	a3 = float(ibuf)   /* Input new sample and convert to 32-bit.	*/

	goto loop
	obuf=a0=int(a0)		/* Latent instruction; convert a0 to	*/
				/* 16-bits and output.			*/


 /* -------------------------------------------------------- */

 coef:      /*  filter coefficients: n0, n1, n2, d1, d2 */
	float  .0782742, -.08490043, .07811783, -1.3749360, .9656292
	float  .1508416, -.2470395, .1506358, -1.4056120, .9663574
	float  .2285870, -.2946279, .2285569, -1.3692910, .9865379
	float  .3928364, -.5974924, .3927925, -1.439385, .9871888

 .rsect ".hi_ram"

 data: 8*float 0.0

