/****************************************************************/
/*   INTERFACING THE WE(R) DSP16 DIGITAL SIGNAL PROCESSOR	*/
/*   TO MULTIPLE A/D AND D/A CONVERTERS				*/
/*   November, 1989  Doc# AP89-015DMOS				*/
/****************************************************************/
/*	 Copyright (c) 1989 AT&T -- All Rights Reserved		*/
/*   WE is a registered trademark of AT&T. AT&T reserves the	*/
/*   right to make changes to  the software described herein	*/
/*   without notice.  No liability is assumed as a result of	*/
/*   their  use or  application.  No rights under any patent	*/
/*   accompany the sale of product.				*/
/****************************************************************/
/*			avrg4.s					*/
/****************************************************************/
/* This program will read the values of all four A/Ds, average	*/
/* them, and write the average to all four D/As.		*/

#define  ADDR_PORT	pdx0
#define  DATA_PORT	pdx1
#define  PORT_0		0x001		/* bit A0 */
#define  PORT_1		0x002		/* bit A1 */
#define  PORT_2		0x004		/* bit A2 */
#define  PORT_3		0x008		/* bit A3 */
#define  PORT_CS	0x010		/* bit A4 */
#define  NOP		a0=a1		/* used to separate PIO read/writes */

.ram
partsum: int		/* partial sum	*/
.endram

rst:	goto start			/* jump to main program		*/

intdriver: /* init */
	r0 = partsum			/* pointer to temp value	*/
	a0 = p				/* clear a0 (sum)		*/
	a0 = a0-p

	ADDR_PORT = PORT_0		/* select channel 0		*/
	NOP
	a1 = DATA_PORT			/* a1 = dummy, D0 in buffer	*/
	NOP

	ADDR_PORT = PORT_1		/* select channel 1		*/
	NOP
	*r0 = DATA_PORT			/* partsum = D0, D1 in buffer	*/
		 y = *r0		/* y = D0			*/

	ADDR_PORT = PORT_2		/* select channel 2		*/
	NOP
	*r0 = DATA_PORT			/* partsum = D1, D2 in buffer	*/
	a0=a0+y  y=*r0  x=*pt++		/* a0 = sum, y = D1, x = dummy	*/

	ADDR_PORT = PORT_3		/* select channel 3		*/
	NOP
	*r0 = DATA_PORT			/* partsum = D2, D3 in buffer	*/
	a0=a0+y  y=*r0  x=*pt++		/* a0 = sum, y = D2, x = dummy	*/

	*r0 = DATA_PORT			/* finish D3			*/
	a0=a0+y  y=*r0  x=*pt++		/* a0 = sum, y = D3, x = dummy	*/
	a0=a0+y  y=*r0  x=*pt++		/* a0 = sum, y = x = dummy	*/

	a0 = a0 >> 1			/* scale down by factor of 4	*/
	a0 = a0 >> 1

/*	Now, send average to all ports		*/

	ADDR_PORT = PORT_0		/* select channel 0		*/
	NOP
	DATA_PORT = a0
	NOP

	ADDR_PORT = PORT_1		/* select channel 1		*/
	NOP
	DATA_PORT = a0
	NOP

	ADDR_PORT = PORT_2		/* select channel 2		*/
	NOP
	DATA_PORT = a0
	NOP

	ADDR_PORT = PORT_3		/* select channel 3		*/
	NOP
	DATA_PORT = a0
	NOP

	ireturn

start:	pioc = 0x3820		/* pids, pods active, int active	*/
	auc = 0x00

noploop: a0 = a1
	goto noploop

