.module/boot=2        decode_parameters; 

#include "lpc.h"

{ DECODE.DSP - decompresses the lpc parameters.

  INPUT:
     /dm      k
     /dm      pitch
     /dm      gain     
  
  OUTPUT:
     /dm      k       unpacked
     /dm      pitch
     /dm      gain     
  
  The log coeded parameters are decompressed using:

     k[i] = (10^(g[i]*4)+1)/(10^(g[i]*4)-1)

}
.const POLY_ORDER = 16; 
.var/pm coeffs[2*POLY_ORDER]; {Ci lsb, Ci msb, Ci-1 lsb .....}
.init coeffs: <dec.cff>; {scaled down by 1024 = 2^10}

.entry    decode;

.external poly_approx;

.external k;
.external gain;
.external pitch;

decode:

  {decode }
    si = dm(pitch);
    se = -9;
    sr = lshift si (lo);
    dm(pitch) = sr0;

    ax0 = dm(gain);
    dm(gain) = ax0;

    i1 = ^k ;    l1 = 0;
    cntr = 2 {N};  
    do dec_k until ce;
      my0 = 0x0000;    {k lsb}
      my1 = dm(i1,m0); {k msb}
      ax0 = POLY_ORDER - 1;
      i6  = ^coeffs;   l6 = 0;
      call poly_approx;  {log area ratio function}
      si = mx0;
      sr = lshift si by 10 (lo);  {scale up by 1024}
      sr = sr or ashift ar by 10 (hi);
    dec_k:  dm(i1,m1) = sr1;
    
rts;
     
.endmod;