.module/boot=1/boot=2        de_emphasize_speech; 

{ DEEMP.DSP - deemphasizes a speech frame. (filters it)

  INPUT:
    i0 -> frame of speech
    l0 =  0
  
  OUTPUT:  speech deemphasized

  FUNCTIONS CALLED:
    None

  DESCRIPTION:
    Filters speech using : H(z) = 1/(1 - 0.75)
}

{Include constant definitions}
#include "lpc.h"

.entry    de_emph;

.external overflow;

.var/dm/ram   delay;

de_emph:
  
  {deemphasize}
  mx0 = 0x6000;       {a1 = 0.75}
  cntr = FRAME_LENGTH;
  do filt_speech until ce;
    mr  = 0;
    mr1 = dm(i0,m0);  {x(n)}
    my0 = dm(delay);  {y(n-1)}
    mr = mr + mx0*my0 (ss);
      if mv call overflow;
    dm(delay) = mr1;  {update delay with y(n)}
  filt_speech: dm(i0,m1) = mr1;
rts;
  
.endmod;