.MODULE/RAM/BOOT=0     double_precision_goertzel; 
 
              { goertzel with 32-bit feedback and 16-bit coefs } 
 
.CONST                 N=10;         { 10 goertzels } 
 
.VAR/DM/CIRC           q[4*N];       { define q buffer for double precision } 
.VAR/DM                tmp_q_ptr;    { temp storage for q buffer pointer } 
.VAR/PM                cos_coef[N];  { coefficient table } 
 
.INIT     cos_coef:    <cosine.dat>; { initialize buffer for boot PROM } 
 
.ENTRY    init_q_zero, calc_goertzel; 
 
init_q_zero:                         { clear q buffer } 
 
         I0=^q; 
         L0=%q; 
         M1=1; 
         CNTR=%q; 
         DO clr_q UNTIL CE; 
clr_q:        DM(I0,M1)=0; 
         DM(tmp_q_ptr)=I0; 
         RTS; 
 
calc_goertzel:                       { calculate Goertzel filter } 
 
                    { computation time = 19 + 8*(N-1) + 10 } 
 
 
         I0=DM(tmp_q_ptr);                       { set up adr ptr } 
         L0=%q; 
         M0=-1; 
         M1=1; 
         M2=7; 
         M3=-7; 
         I4=^cos_coef; 
         L4=0; 
         M5=1; 
         AX1=0; 
 
         SR=ASHIFT SI BY -7 (HI);                { scale sample in reg SI } 
         AY1=SR1;                                { store to AY1 } 
         SI=1; 
 
         SR0=DM(I0,M1);                          { temp store last goerztel } 
         SR1=DM(I0,M1);                          { q(n-2) lsw, msw          } 
 
         MX0=DM(I0,M1), MY0=PM(I4,M5);           { rd q(n-1)lsw, coef } 
         MR=MX0*MY0(US), MX1=DM(I0,M1);          { mult lsw*coef,rd q(n-1)msw} 
 
         CNTR=N-1;                               { set up main loop } 
         DO goertzel UNTIL CE; 
              MY1=MR1, MR=MX1*MY0(SS);           { my1=msw of lower product} 
                                                 { mult msw*coef } 
              MR=MR+MX1*MY0(SS), MX0=SI;         { again, 1-bit shift effect } 
              MR=MR+MX0*MY1(US), AY0=DM(I0,M1);  { add in my1 w/1-bit shift } 
              AR=MR0-AY0, AY0=DM(I0,M1);         { subtract q(n-2), rd msw } 
              AF=MR1-AY0+C-1, MX0=DM(I0,M1);     { sub msw, rd next q(n-1)lsw} 
              AR=AR+AY1, MX1=DM(I0,M3), MY0=PM(I4,M5); 
                                                 { add x(n), rd next msw,coef} 
              DM(I0,M1)=AR, AR=AX1+AF+C;         { store new q lsw, add carry} 
goertzel:     DM(I0,M2)=AR, MR=MX0*MY0(US);      { store new q msw, mult next} 
 
         MY1=MR1, MR=MX1*MY0(SS); 
         MR=MR+MX1*MY0(SS), MX0=SI; 
         MR=MR+MX0*MY1(US), AY0=SR0; 
         AR=MR0-AY0, AY0=SR1; 
         AF=MR1-AY0+C-1; 
         AR=AR+AY1; 
         DM(I0,M1)=AR, AR=AX1+AF+C; 
         DM(I0,M2)=AR, MR=MX0*MY0(US); 
         DM(tmp_q_ptr)=I0;                       { store new pointer } 
 
         RTS;                                    { return from sub } 
 
.ENDMOD;