/****************************************************************/
/*   DIGITAL ECHO CANCELLOR and COMPLEX ADAPTIVE EQUALIZERS	*/
/*   Using The WE(R) DSP16/DSP16A DIGITAL SIGNAL PROCESSOR	*/
/*   June, 1989 Doc# AP89-009DMOS				*/
/****************************************************************/
/*	 Copyright (c) 1989 AT&T -- All Rights Reserved		*/
/*   WE is a registered trademark of AT&T. AT&T reserves the	*/
/*   right to make changes to  the software described herein	*/
/*   without notice.  No liability is assumed as a result of	*/
/*   their  use or  application.  No rights under any patent	*/
/*   accompany the sale of product.				*/
/****************************************************************/
/*								*/
/*	Program Listing 1.		echo-sp.s		*/
/*	Digital Echo Canceler for Two-Wire Data			*/
/*	Transmission - Single Precision Coefficients		*/
/*								*/
/*  by S. Tu, AT&T Bell Laboratories, Allentown, PA  10/28/88	*/
/*								*/

.ram
  dat1:   11*int	/* allocate 12 ram spaces for 12-tap	*/
 dat12:      int	/* delay lines				*/
   cf1:   12*int	/* 12 coef. for sub-canceler 1		*/
   cf2:   12*int	/* 12 coef. for sub-canceler 2		*/
   cf3:   12*int	/* 12 coef. for sub-canceler 3		*/
   cf4:   12*int	/* 12 coef. for sub-canceler 4		*/
    rx:      int
.endram

start: auc=0x02				/* set alignment for Q14 format	*/
	pt=CF1				/* pt - coef. in rom		*/
	r2=cf1				/* r2 - coef. in ram		*/

  do 48  {				/* transfer start-up coef.	*/
		y=a0	x=*pt++		/* from rom to ram (y=a0 is a	*/
	*r2++=x				/* dummy fetch)			*/
	}

	r1=dat12
	r3=rx
	rb=dat1			/* rb points to beginning, re	*/
	re=dat12		/* to end of modulo.		*/
	j=-12
	i=0
	c0=0			/* initialize counter c0 to 0	*/

loop:	*r3=sdx			/* read s(n)+e(n) from SIO	*/

	if c0lt goto cnvl	/* read a(n) from PIO every	*/
	*r1++=pdx0		/* 4th loop.			*/
	c0=-3			/* set c0 to -3			*/
	r2=cf1
				/* start convolution routine	*/
cnvl:	a0=p		x=*r2++	/* load x, y and clear a0.	*/
	a0=a0-p	y=*r1++
 do 11  {			/* perform convolution to	*/
		p=x*y	x=*r2++	/* obtain echo estimate.	*/
	a0=a0+p	y=*r1++
	}

		p=x*y
	a0=a0+p	*r2++j		/* end of convolution routine	*/

	y=*r3			/* subtract estimated echo	*/
	a0=a0-y			/* from received signal then	*/
	a0=-a0			/* output the result to SIO	*/
	a0=rnd(a0)		/* after rounding		*/
	sdx=a0
				  /* start tap adaptation routine */
lms:		y=a0	x=*pt++i  /* scale a0 by the factor mu	*/
		p=x*y		  /* then load to y for tap	*/
	a0=p		x=*r1++	  /* update calculation		*/
	a0=rnd(a0)
	y=a0

  do 11  {			/* update filter coefficients	*/
		p=x*y	a0=*r2
	a0=a0+p	x=*r1++
	a0=rnd(a0)
	*r2++=a0
	}
		p=x*y	a0=*r2
	a0=a0+p
	a0=rnd(a0)
	*r2++=a0		/* end of adaptation routine	*/

end:	goto loop

			/* filter final coef. settings */
CF1:	int	0.00043
	int	-0.00098
	int	0.00177
	int	0.00360
	int	0.00592
	int	0.00879
	int	-0.00037
	int	0.14478
	int	0.01013
	int	-0.00085
	int	-0.00079
	int	0.0
	int	0.00055
	int	-0.00220
	int	0.00153
	int	0.00323
	int	0.00500
	int	0.00983
	int	0.02832
	int	0.30933
	int	0.01343
	int	-0.00128
	int	-0.00110
	int	0.00043
	int	0.00055
	int	-0.00189
	int	0.00116
	int	0.00269
	int	0.00421
	int	0.00885
	int	0.03125
	int	0.24213
	int	-0.03455
	int	-0.00446
	int	-0.00098
	int	0.00031
	int	0.00012
	int	-0.00049
	int	0.00055
	int	0.00256
	int	0.00378
	int	0.00757
	int	0.01325
	int	0.06293
	int	-0.02692
	int	-0.00574
	int	0.0
	int	0.00037
U:	int	0.01

