/****************************************************************/
/*   INTERFACING EXTERNAL RAM TO THE				*/
/*   WE(R) DSP16 FAMILY OF DIGITAL SIGNAL PROCESSORS		*/
/*   March, 1989 Doc# AP88-20DMOS				*/
/****************************************************************/
/*	 Copyright (c) 1989 AT&T -- All Rights Reserved		*/
/*   WE is a registered trademark of AT&T. AT&T reserves the	*/
/*   right to make changes to  the software described herein	*/
/*   without notice.  No liability is assumed as a result of	*/
/*   their  use or  application.  No rights under any patent	*/
/*   accompany the sale of product.				*/
/****************************************************************/
/*								*/
/*			exm16.s					*/
/*								*/
/* This routine multiplies two arrays, B and A.  The values	*/
/* for the two arrays are assumed to already exist in external	*/
/* memory.  The arrays are transferred form external memory	*/
/* into the on-chip RAM and then multiplied.  The results are	*/
/* transferred back to the external RAM.			*/
/****************************************************************/

.ram
A:	64*int			/* Temporary variable space for array A	*/
B:	64*int			/* Temporary variable space for array B	*/
C:	64*int			/* Temporary variable space for array C	*/
.endram

	move c1=-7
	move c0=-7
	move auc=0x00
	pioc=0x1800		/* Active mode, minimum access time	*/

	pdx1=0xFFFF		/* Address external RAM loc 0xFFFF	*/
	pdx0=0x01		/* Initialize to up-count mode		*/
	pdx1=0x00		/* First location of ext RAM to address	*/
	move a0=pdx0		/* Initial buffer no good; read & discard */
	move r0=A		/* r0 points to 1st on-chip space of A	*/

	do 64 {
		move a0=pdx0
		*r0++=a0
	}
	do 64 {
		move a0=pdx0
		*r0++=a0
	}
	rb=A			/* Initialize pointer registers		*/
	re=A+7
	r1=A
		
		/**  MAIN PROGRAM LOOP  **/
loop:	r0=B
	j=8
		y=*r0++j
			x=*r1++
loop2:
		p=x*y	y=*r0++j
	a0=p		x=*r1++
		p=x*y	y=*r0++j
	a0=a0+p		x=*r1++
		p=x*y	y=*r0++j
	a0=a0+p		x=*r1++
		p=x*y	y=*r0++j
	a0=a0+p		x=*r1++
		p=x*y	y=*r0++j
	a0=a0+p		x=*r1++
		p=x*y	y=*r0++j
	a0=a0+p		x=*r1++
	j=-55
		p=x*y	y=*r0++j
	a0=a0+p		x=*r1++
	j=8
		p=x*y	y=*r0++j
	a0=a0+p		x=*r1++
	a0=a0<<16
	pdx0=a0			/* Write data to external RAM	*/
				/* autoincrement the address	*/
	if c0lt goto loop2
	c0=-7
	j=7
			*r1++j
	a0=r1
	rb=a0
			*r1++j
	a0=r1
	re=a0
			*r1++
	if c1lt goto loop
stop:	goto stop
end:

