/* AT&T DSP16, 1K point FFT           jkf  Oct 14, 1988 */
/*							*/
/* This is a 1024-point DSP16A fft program with		*/
/*  dynamic scaling for each butterfly process.		*/
/* The input data is  <real0>,<imag0>;<real2>,<imag1>;  */
/*  .... with the start address in A, and the amplitude	*/
/*  of input data (Q14) will be limited in (-2.0, 2.0).	*/
/* After running this program, the input data will be	*/
/*  replaced by output values.				*/
/* This program uses 3436 words of ROM and 2048 words	*/
/*  of RAM (requires DSP16A).				*/
/* The execution time is 102383 instruction cycles.	*/
/* June 2, 1988						*/

start:	auc=0x2
	i=-1

/* un-comment following line to include input	*/
/* from parallel port (routine follows label "stop.")	*/

/*	call 1024io	*/

level0:	r0=0x0
	r1=1024
	r2=1023
	pt=W0
	a0=*r0++		/* a0=A(0)r		*/
	a1=*r2			/* a1=A(n/2-1)i		*/
	x=*pt++ y=*r1++		/* x=Ur; y=A(n/2)r	*/
	do 100 {
	p=x*y x=*pt++i y=*r1--	/* p=Ur*A(k+n/2)r, x=Ui, y=A(k+n/2)i	*/
	a1=a0-p *r2++=a1	/* a1=A(k)r-Ur*A(k+n/2)r	*/
	a0=a0+p	p=x*y		/* a0=A(k)r+Ur*A(k+n/2)r,p=Ui*A(k+n/2)i	*/
	a0=a0-p y=*r1++		/* a0=A(k)r+Ur*A(k+n/2)r-Ui*A(k+n/2)i	*/
	a0=a0>>1		/* a0=a0/2, y=A(k+n/2)r		*/
	a1=a1+p p=x*y *r0m2:a0	/* a1=A(k)r-Ur*A(k+n/2)r+Ui*A(k+n/2)i	*/
	x=*pt++ y=*r1++		/* p=Ui*A(k+n/2)r,x=Ur,y=A(k+n/2)i	*/
	a1=a1>>1		/* a1=a1/2, x=Ur, y=A(k+n/2)i	*/
	a1=a0-p *r2++=a1	/* a1=A(k)i-Ui*A(k+n/2)r	*/
	a0=a0+p p=x*y		/* a0=A(k)i+Ui*A(k+n/2)r,p=Ur*A(k+n/2)i	*/
	a0=a0+p y=*r1++		/* a0=A(k)i+Ui*A(k+n/2)r+Ur*A(k+n/2)i	*/
	a0=a0>>1		/* a0=a0/2, y=A(k+1+n/2)r	*/
	a1=a1-p *r0m2:a0 	/* a1=A(k)i-Ui*A(k+n/2)r-Ur*A(k+n/2)i	*/
	a1=a1>>1		/* a1=a1/2, x=Ur		*/
	}
	redo 100
	redo 100
	redo 100
	redo 100
	redo 12
	*r2=a1

level1:	r0=0x0
	r1=512
	r2=511
	pt=W0
	a0=*r0++		/* a0=A(0)r		*/
	a1=*r2			/* a1=A(n/2-1)i		*/
	x=*pt++ y=*r1++		/* x=Ur; y=A(n/2)r	*/
	redo 100
	redo 100
	redo 56
	*r2=a1
	r0=1024
	r1=1536
	r2=1535
	pt=W256
	a0=*r0++		/* a0=A(0)r		*/
	a1=*r2			/* a1=A(n/2-1)i		*/
	x=*pt++ y=*r1++		/* x=Ur; y=A(n/2)r	*/
	redo 100
	redo 100
	redo 56
	*r2=a1

level2:	r0=0x0
	r1=256
	r2=255
	pt=W0
	a0=*r0++		/* a0=A(0)r		*/
	a1=*r2			/* a1=A(n/2-1)i		*/
	x=*pt++ y=*r1++		/* x=Ur; y=A(n/2)r	*/
	redo 64
	redo 64
	*r2=a1
	r0=512
	r1=768
	r2=767
	pt=W256
	a0=*r0++		/* a0=A(0)r		*/
	a1=*r2			/* a1=A(n/2-1)i		*/
	x=*pt++ y=*r1++		/* x=Ur; y=A(n/2)r	*/
	redo 64
	redo 64
	*r2=a1
	r0=1024
	r1=1280
	r2=1279
	pt=W128
	a0=*r0++		/* a0=A(0)r		*/
	a1=*r2			/* a1=A(n/2-1)i		*/
	x=*pt++ y=*r1++		/* x=Ur; y=A(n/2)r	*/
	redo 64
	redo 64
	*r2=a1
	r0=1536
	r1=1792
	r2=1791
	pt=W384
	a0=*r0++		/* a0=A(0)r		*/
	a1=*r2			/* a1=A(n/2-1)i		*/
	x=*pt++ y=*r1++		/* x=Ur; y=A(n/2)r	*/
	redo 64
	redo 64
	*r2=a1

level3:	r0=0x0
	r1=128
	r2=127
	pt=W0
	a0=*r0++		/* a0=A(0)r		*/
	a1=*r2			/* a1=A(n/2-1)i		*/
	x=*pt++ y=*r1++		/* x=Ur; y=A(n/2)r	*/
	redo 64
	*r2=a1
	r0=256
	r1=384
	r2=383
	pt=W256
	a0=*r0++		/* a0=A(0)r		*/
	a1=*r2			/* a1=A(n/2-1)i		*/
	x=*pt++ y=*r1++		/* x=Ur; y=A(n/2)r	*/
	redo 64
	*r2=a1
	r0=512
	r1=640
	r2=639
	pt=W128
	a0=*r0++		/* a0=A(0)r		*/
	a1=*r2			/* a1=A(n/2-1)i		*/
	x=*pt++ y=*r1++		/* x=Ur; y=A(n/2)r	*/
	redo 64
	*r2=a1
	r0=768
	r1=896
	r2=895
	pt=W384
	a0=*r0++		/* a0=A(0)r		*/
	a1=*r2			/* a1=A(n/2-1)i		*/
	x=*pt++ y=*r1++		/* x=Ur; y=A(n/2)r	*/
	redo 64
	*r2=a1
	r0=1024
	r1=1152
	r2=1151
	pt=W64
	a0=*r0++		/* a0=A(0)r		*/
	a1=*r2			/* a1=A(n/2-1)i		*/
	x=*pt++ y=*r1++		/* x=Ur; y=A(n/2)r	*/
	redo 64
	*r2=a1
	r0=1280
	r1=1408
	r2=1407
	pt=W320
	a0=*r0++		/* a0=A(0)r		*/
	a1=*r2			/* a1=A(n/2-1)i		*/
	x=*pt++ y=*r1++		/* x=Ur; y=A(n/2)r	*/
	redo 64
	*r2=a1
	r0=1536
	r1=1664
	r2=1663
	pt=W192
	a0=*r0++		/* a0=A(0)r		*/
	a1=*r2			/* a1=A(n/2-1)i		*/
	x=*pt++ y=*r1++		/* x=Ur; y=A(n/2)r	*/
	redo 64
	*r2=a1
	r0=1792
	r1=1920
	r2=1919
	pt=W448
	a0=*r0++		/* a0=A(0)r		*/
	a1=*r2			/* a1=A(n/2-1)i		*/
	x=*pt++ y=*r1++		/* x=Ur; y=A(n/2)r	*/
	redo 64
	*r2=a1

level4:	r0=0x0
	r1=64
	r2=63
	pt=W0
	a0=*r0++		/* a0=A(0)r		*/
	a1=*r2			/* a1=A(n/2-1)i		*/
	x=*pt++ y=*r1++		/* x=Ur; y=A(n/2)r	*/
	redo 32
	*r2=a1
	r0=128
	r1=192
	r2=191
	pt=W256
	a0=*r0++		/* a0=A(0)r		*/
	a1=*r2			/* a1=A(n/2-1)i		*/
	x=*pt++ y=*r1++		/* x=Ur; y=A(n/2)r	*/
	redo 32
	*r2=a1
	r0=256
	r1=320
	r2=319
	pt=W128
	a0=*r0++		/* a0=A(0)r		*/
	a1=*r2			/* a1=A(n/2-1)i		*/
	x=*pt++ y=*r1++		/* x=Ur; y=A(n/2)r	*/
	redo 32
	*r2=a1
	r0=384
	r1=448
	r2=447
	pt=W384
	a0=*r0++		/* a0=A(0)r		*/
	a1=*r2			/* a1=A(n/2-1)i		*/
	x=*pt++ y=*r1++		/* x=Ur; y=A(n/2)r	*/
	redo 32
	*r2=a1
	r0=512
	r1=576
	r2=575
	pt=W64
	a0=*r0++		/* a0=A(0)r		*/
	a1=*r2			/* a1=A(n/2-1)i		*/
	x=*pt++ y=*r1++		/* x=Ur; y=A(n/2)r	*/
	redo 32
	*r2=a1
	r0=640
	r1=704
	r2=703
	pt=W320
	a0=*r0++		/* a0=A(0)r		*/
	a1=*r2			/* a1=A(n/2-1)i		*/
	x=*pt++ y=*r1++		/* x=Ur; y=A(n/2)r	*/
	redo 32
	*r2=a1
	r0=768
	r1=832
	r2=831
	pt=W192
	a0=*r0++		/* a0=A(0)r		*/
	a1=*r2			/* a1=A(n/2-1)i		*/
	x=*pt++ y=*r1++		/* x=Ur; y=A(n/2)r	*/
	redo 32
	*r2=a1
	r0=896
	r1=960
	r2=959
	pt=W448
	a0=*r0++		/* a0=A(0)r		*/
	a1=*r2			/* a1=A(n/2-1)i		*/
	x=*pt++ y=*r1++		/* x=Ur; y=A(n/2)r	*/
	redo 32
	*r2=a1
	r0=1024
	r1=1088
	r2=1087
	pt=W32
	a0=*r0++		/* a0=A(0)r		*/
	a1=*r2			/* a1=A(n/2-1)i		*/
	x=*pt++ y=*r1++		/* x=Ur; y=A(n/2)r	*/
	redo 32
	*r2=a1
	r0=1152
	r1=1216
	r2=1215
	pt=W288
	a0=*r0++		/* a0=A(0)r		*/
	a1=*r2			/* a1=A(n/2-1)i		*/
	x=*pt++ y=*r1++		/* x=Ur; y=A(n/2)r	*/
	redo 32
	*r2=a1
	r0=1280
	r1=1344
	r2=1343
	pt=W160
	a0=*r0++		/* a0=A(0)r		*/
	a1=*r2			/* a1=A(n/2-1)i		*/
	x=*pt++ y=*r1++		/* x=Ur; y=A(n/2)r	*/
	redo 32
	*r2=a1
	r0=1408
	r1=1472
	r2=1471
	pt=W416
	a0=*r0++		/* a0=A(0)r		*/
	a1=*r2			/* a1=A(n/2-1)i		*/
	x=*pt++ y=*r1++		/* x=Ur; y=A(n/2)r	*/
	redo 32
	*r2=a1
	r0=1536
	r1=1600
	r2=1599
	pt=W96
	a0=*r0++		/* a0=A(0)r		*/
	a1=*r2			/* a1=A(n/2-1)i		*/
	x=*pt++ y=*r1++		/* x=Ur; y=A(n/2)r	*/
	redo 32
	*r2=a1
	r0=1664
	r1=1728
	r2=1727
	pt=W352
	a0=*r0++		/* a0=A(0)r		*/
	a1=*r2			/* a1=A(n/2-1)i		*/
	x=*pt++ y=*r1++		/* x=Ur; y=A(n/2)r	*/
	redo 32
	*r2=a1
	r0=1792
	r1=1856
	r2=1855
	pt=W224
	a0=*r0++		/* a0=A(0)r		*/
	a1=*r2			/* a1=A(n/2-1)i		*/
	x=*pt++ y=*r1++		/* x=Ur; y=A(n/2)r	*/
	redo 32
	*r2=a1
	r0=1920
	r1=1984
	r2=1983
	pt=W480
	a0=*r0++		/* a0=A(0)r		*/
	a1=*r2			/* a1=A(n/2-1)i		*/
	x=*pt++ y=*r1++		/* x=Ur; y=A(n/2)r	*/
	redo 32
	*r2=a1

level5:	r0=0x0
	r1=32
	r2=31
	pt=W0
	a0=*r0++		/* a0=A(0)r		*/
	a1=*r2			/* a1=A(n/2-1)i		*/
	x=*pt++ y=*r1++		/* x=Ur; y=A(n/2)r	*/
	redo 16
	*r2=a1
	r0=64
	r1=96
	r2=95
	pt=W256
	a0=*r0++		/* a0=A(0)r		*/
	a1=*r2			/* a1=A(n/2-1)i		*/
	x=*pt++ y=*r1++		/* x=Ur; y=A(n/2)r	*/
	redo 16
	*r2=a1
	r0=128
	r1=160
	r2=159
	pt=W128
	a0=*r0++		/* a0=A(0)r		*/
	a1=*r2			/* a1=A(n/2-1)i		*/
	x=*pt++ y=*r1++		/* x=Ur; y=A(n/2)r	*/
	redo 16
	*r2=a1
	r0=192
	r1=224
	r2=223
	pt=W384
	a0=*r0++		/* a0=A(0)r		*/
	a1=*r2			/* a1=A(n/2-1)i		*/
	x=*pt++ y=*r1++		/* x=Ur; y=A(n/2)r	*/
	redo 16
	*r2=a1
	r0=256
	r1=288
	r2=287
	pt=W64
	a0=*r0++		/* a0=A(0)r		*/
	a1=*r2			/* a1=A(n/2-1)i		*/
	x=*pt++ y=*r1++		/* x=Ur; y=A(n/2)r	*/
	redo 16
	*r2=a1
	r0=320
	r1=352
	r2=351
	pt=W320
	a0=*r0++		/* a0=A(0)r		*/
	a1=*r2			/* a1=A(n/2-1)i		*/
	x=*pt++ y=*r1++		/* x=Ur; y=A(n/2)r	*/
	redo 16
	*r2=a1
	r0=384
	r1=416
	r2=415
	pt=W192
	a0=*r0++		/* a0=A(0)r		*/
	a1=*r2			/* a1=A(n/2-1)i		*/
	x=*pt++ y=*r1++		/* x=Ur; y=A(n/2)r	*/
	redo 16
	*r2=a1
	r0=448
	r1=480
	r2=479
	pt=W448
	a0=*r0++		/* a0=A(0)r		*/
	a1=*r2			/* a1=A(n/2-1)i		*/
	x=*pt++ y=*r1++		/* x=Ur; y=A(n/2)r	*/
	redo 16
	*r2=a1
	r0=512
	r1=544
	r2=543
	pt=W32
	a0=*r0++		/* a0=A(0)r		*/
	a1=*r2			/* a1=A(n/2-1)i		*/
	x=*pt++ y=*r1++		/* x=Ur; y=A(n/2)r	*/
	redo 16
	*r2=a1
	r0=576
	r1=608
	r2=607
	pt=W288
	a0=*r0++		/* a0=A(0)r		*/
	a1=*r2			/* a1=A(n/2-1)i		*/
	x=*pt++ y=*r1++		/* x=Ur; y=A(n/2)r	*/
	redo 16
	*r2=a1
	r0=640
	r1=672
	r2=671
	pt=W160
	a0=*r0++		/* a0=A(0)r		*/
	a1=*r2			/* a1=A(n/2-1)i		*/
	x=*pt++ y=*r1++		/* x=Ur; y=A(n/2)r	*/
	redo 16
	*r2=a1
	r0=704
	r1=736
	r2=735
	pt=W416
	a0=*r0++		/* a0=A(0)r		*/
	a1=*r2			/* a1=A(n/2-1)i		*/
	x=*pt++ y=*r1++		/* x=Ur; y=A(n/2)r	*/
	redo 16
	*r2=a1
	r0=768
	r1=800
	r2=799
	pt=W96
	a0=*r0++		/* a0=A(0)r		*/
	a1=*r2			/* a1=A(n/2-1)i		*/
	x=*pt++ y=*r1++		/* x=Ur; y=A(n/2)r	*/
	redo 16
	*r2=a1
	r0=832
	r1=864
	r2=863
	pt=W352
	a0=*r0++		/* a0=A(0)r		*/
	a1=*r2			/* a1=A(n/2-1)i		*/
	x=*pt++ y=*r1++		/* x=Ur; y=A(n/2)r	*/
	redo 16
	*r2=a1
	r0=896
	r1=928
	r2=927
	pt=W224
	a0=*r0++		/* a0=A(0)r		*/
	a1=*r2			/* a1=A(n/2-1)i		*/
	x=*pt++ y=*r1++		/* x=Ur; y=A(n/2)r	*/
	redo 16
	*r2=a1
	r0=960
	r1=992
	r2=991
	pt=W480
	a0=*r0++		/* a0=A(0)r		*/
	a1=*r2			/* a1=A(n/2-1)i		*/
	x=*pt++ y=*r1++		/* x=Ur; y=A(n/2)r	*/
	redo 16
	*r2=a1
	r0=1024
	r1=1056
	r2=1055
	pt=W16
	a0=*r0++		/* a0=A(0)r		*/
	a1=*r2			/* a1=A(n/2-1)i		*/
	x=*pt++ y=*r1++		/* x=Ur; y=A(n/2)r	*/
	redo 16
	*r2=a1
	r0=1088
	r1=1120
	r2=1119
	pt=W272
	a0=*r0++		/* a0=A(0)r		*/
	a1=*r2			/* a1=A(n/2-1)i		*/
	x=*pt++ y=*r1++		/* x=Ur; y=A(n/2)r	*/
	redo 16
	*r2=a1
	r0=1152
	r1=1184
	r2=1183
	pt=W144
	a0=*r0++		/* a0=A(0)r		*/
	a1=*r2			/* a1=A(n/2-1)i		*/
	x=*pt++ y=*r1++		/* x=Ur; y=A(n/2)r	*/
	redo 16
	*r2=a1
	r0=1216
	r1=1248
	r2=1247
	pt=W400
	a0=*r0++		/* a0=A(0)r		*/
	a1=*r2			/* a1=A(n/2-1)i		*/
	x=*pt++ y=*r1++		/* x=Ur; y=A(n/2)r	*/
	redo 16
	*r2=a1
	r0=1280
	r1=1312
	r2=1311
	pt=W80
	a0=*r0++		/* a0=A(0)r		*/
	a1=*r2			/* a1=A(n/2-1)i		*/
	x=*pt++ y=*r1++		/* x=Ur; y=A(n/2)r	*/
	redo 16
	*r2=a1
	r0=1344
	r1=1376
	r2=1375
	pt=W336
	a0=*r0++		/* a0=A(0)r		*/
	a1=*r2			/* a1=A(n/2-1)i		*/
	x=*pt++ y=*r1++		/* x=Ur; y=A(n/2)r	*/
	redo 16
	*r2=a1
	r0=1408
	r1=1440
	r2=1439
	pt=W208
	a0=*r0++		/* a0=A(0)r		*/
	a1=*r2			/* a1=A(n/2-1)i		*/
	x=*pt++ y=*r1++		/* x=Ur; y=A(n/2)r	*/
	redo 16
	*r2=a1
	r0=1472
	r1=1504
	r2=1503
	pt=W464
	a0=*r0++		/* a0=A(0)r		*/
	a1=*r2			/* a1=A(n/2-1)i		*/
	x=*pt++ y=*r1++		/* x=Ur; y=A(n/2)r	*/
	redo 16
	*r2=a1
	r0=1536
	r1=1568
	r2=1567
	pt=W48
	a0=*r0++		/* a0=A(0)r		*/
	a1=*r2			/* a1=A(n/2-1)i		*/
	x=*pt++ y=*r1++		/* x=Ur; y=A(n/2)r	*/
	redo 16
	*r2=a1
	r0=1600
	r1=1632
	r2=1631
	pt=W304
	a0=*r0++		/* a0=A(0)r		*/
	a1=*r2			/* a1=A(n/2-1)i		*/
	x=*pt++ y=*r1++		/* x=Ur; y=A(n/2)r	*/
	redo 16
	*r2=a1
	r0=1664
	r1=1696
	r2=1695
	pt=W176
	a0=*r0++		/* a0=A(0)r		*/
	a1=*r2			/* a1=A(n/2-1)i		*/
	x=*pt++ y=*r1++		/* x=Ur; y=A(n/2)r	*/
	redo 16
	*r2=a1
	r0=1728
	r1=1760
	r2=1759
	pt=W432
	a0=*r0++		/* a0=A(0)r		*/
	a1=*r2			/* a1=A(n/2-1)i		*/
	x=*pt++ y=*r1++		/* x=Ur; y=A(n/2)r	*/
	redo 16
	*r2=a1
	r0=1792
	r1=1824
	r2=1823
	pt=W112
	a0=*r0++		/* a0=A(0)r		*/
	a1=*r2			/* a1=A(n/2-1)i		*/
	x=*pt++ y=*r1++		/* x=Ur; y=A(n/2)r	*/
	redo 16
	*r2=a1
	r0=1856
	r1=1888
	r2=1887
	pt=W368
	a0=*r0++		/* a0=A(0)r		*/
	a1=*r2			/* a1=A(n/2-1)i		*/
	x=*pt++ y=*r1++		/* x=Ur; y=A(n/2)r	*/
	redo 16
	*r2=a1
	r0=1920
	r1=1952
	r2=1951
	pt=W240
	a0=*r0++		/* a0=A(0)r		*/
	a1=*r2			/* a1=A(n/2-1)i		*/
	x=*pt++ y=*r1++		/* x=Ur; y=A(n/2)r	*/
	redo 16
	*r2=a1
	r0=1984
	r1=2016
	r2=2015
	pt=W496
	a0=*r0++		/* a0=A(0)r		*/
	a1=*r2			/* a1=A(n/2-1)i		*/
	x=*pt++ y=*r1++		/* x=Ur; y=A(n/2)r	*/
	redo 16
	*r2=a1

level6:	r0=0x0
	r1=16
	r2=15
	pt=W0
	a0=*r0++		/* a0=A(0)r		*/
	a1=*r2			/* a1=A(n/2-1)i		*/
	x=*pt++ y=*r1++		/* x=Ur; y=A(n/2)r	*/
	redo 8
	*r2=a1
	r0=32
	r1=48
	r2=47
	pt=W256
	a0=*r0++		/* a0=A(0)r		*/
	a1=*r2			/* a1=A(n/2-1)i		*/
	x=*pt++ y=*r1++		/* x=Ur; y=A(n/2)r	*/
	redo 8
	*r2=a1
	r0=64
	r1=80
	r2=79
	pt=W128
	a0=*r0++		/* a0=A(0)r		*/
	a1=*r2			/* a1=A(n/2-1)i		*/
	x=*pt++ y=*r1++		/* x=Ur; y=A(n/2)r	*/
	redo 8
	*r2=a1
	r0=96
	r1=112
	r2=111
	pt=W384
	a0=*r0++		/* a0=A(0)r		*/
	a1=*r2			/* a1=A(n/2-1)i		*/
	x=*pt++ y=*r1++		/* x=Ur; y=A(n/2)r	*/
	redo 8
	*r2=a1
	r0=128
	r1=144
	r2=143
	pt=W64
	a0=*r0++		/* a0=A(0)r		*/
	a1=*r2			/* a1=A(n/2-1)i		*/
	x=*pt++ y=*r1++		/* x=Ur; y=A(n/2)r	*/
	redo 8
	*r2=a1
	r0=160
	r1=176
	r2=175
	pt=W320
	a0=*r0++		/* a0=A(0)r		*/
	a1=*r2			/* a1=A(n/2-1)i		*/
	x=*pt++ y=*r1++		/* x=Ur; y=A(n/2)r	*/
	redo 8
	*r2=a1
	r0=192
	r1=208
	r2=207
	pt=W192
	a0=*r0++		/* a0=A(0)r		*/
	a1=*r2			/* a1=A(n/2-1)i		*/
	x=*pt++ y=*r1++		/* x=Ur; y=A(n/2)r	*/
	redo 8
	*r2=a1
	r0=224
	r1=240
	r2=239
	pt=W448
	a0=*r0++		/* a0=A(0)r		*/
	a1=*r2			/* a1=A(n/2-1)i		*/
	x=*pt++ y=*r1++		/* x=Ur; y=A(n/2)r	*/
	redo 8
	*r2=a1
	r0=256
	r1=272
	r2=271
	pt=W32
	a0=*r0++		/* a0=A(0)r		*/
	a1=*r2			/* a1=A(n/2-1)i		*/
	x=*pt++ y=*r1++		/* x=Ur; y=A(n/2)r	*/
	redo 8
	*r2=a1
	r0=288
	r1=304
	r2=303
	pt=W288
	a0=*r0++		/* a0=A(0)r		*/
	a1=*r2			/* a1=A(n/2-1)i		*/
	x=*pt++ y=*r1++		/* x=Ur; y=A(n/2)r	*/
	redo 8
	*r2=a1
	r0=320
	r1=336
	r2=335
	pt=W160
	a0=*r0++		/* a0=A(0)r		*/
	a1=*r2			/* a1=A(n/2-1)i		*/
	x=*pt++ y=*r1++		/* x=Ur; y=A(n/2)r	*/
	redo 8
	*r2=a1
	r0=352
	r1=368
	r2=367
	pt=W416
	a0=*r0++		/* a0=A(0)r		*/
	a1=*r2			/* a1=A(n/2-1)i		*/
	x=*pt++ y=*r1++		/* x=Ur; y=A(n/2)r	*/
	redo 8
	*r2=a1
	r0=384
	r1=400
	r2=399
	pt=W96
	a0=*r0++		/* a0=A(0)r		*/
	a1=*r2			/* a1=A(n/2-1)i		*/
	x=*pt++ y=*r1++		/* x=Ur; y=A(n/2)r	*/
	redo 8
	*r2=a1
	r0=416
	r1=432
	r2=431
	pt=W352
	a0=*r0++		/* a0=A(0)r		*/
	a1=*r2			/* a1=A(n/2-1)i		*/
	x=*pt++ y=*r1++		/* x=Ur; y=A(n/2)r	*/
	redo 8
	*r2=a1
	r0=448
	r1=464
	r2=463
	pt=W224
	a0=*r0++		/* a0=A(0)r		*/
	a1=*r2			/* a1=A(n/2-1)i		*/
	x=*pt++ y=*r1++		/* x=Ur; y=A(n/2)r	*/
	redo 8
	*r2=a1
	r0=480
	r1=496
	r2=495
	pt=W480
	a0=*r0++		/* a0=A(0)r		*/
	a1=*r2			/* a1=A(n/2-1)i		*/
	x=*pt++ y=*r1++		/* x=Ur; y=A(n/2)r	*/
	redo 8
	*r2=a1
	r0=512
	r1=528
	r2=527
	pt=W16
	a0=*r0++		/* a0=A(0)r		*/
	a1=*r2			/* a1=A(n/2-1)i		*/
	x=*pt++ y=*r1++		/* x=Ur; y=A(n/2)r	*/
	redo 8
	*r2=a1
	r0=544
	r1=560
	r2=559
	pt=W272
	a0=*r0++		/* a0=A(0)r		*/
	a1=*r2			/* a1=A(n/2-1)i		*/
	x=*pt++ y=*r1++		/* x=Ur; y=A(n/2)r	*/
	redo 8
	*r2=a1
	r0=576
	r1=592
	r2=591
	pt=W144
	a0=*r0++		/* a0=A(0)r		*/
	a1=*r2			/* a1=A(n/2-1)i		*/
	x=*pt++ y=*r1++		/* x=Ur; y=A(n/2)r	*/
	redo 8
	*r2=a1
	r0=608
	r1=624
	r2=623
	pt=W400
	a0=*r0++		/* a0=A(0)r		*/
	a1=*r2			/* a1=A(n/2-1)i		*/
	x=*pt++ y=*r1++		/* x=Ur; y=A(n/2)r	*/
	redo 8
	*r2=a1
	r0=640
	r1=656
	r2=655
	pt=W80
	a0=*r0++		/* a0=A(0)r		*/
	a1=*r2			/* a1=A(n/2-1)i		*/
	x=*pt++ y=*r1++		/* x=Ur; y=A(n/2)r	*/
	redo 8
	*r2=a1
	r0=672
	r1=688
	r2=687
	pt=W336
	a0=*r0++		/* a0=A(0)r		*/
	a1=*r2			/* a1=A(n/2-1)i		*/
	x=*pt++ y=*r1++		/* x=Ur; y=A(n/2)r	*/
	redo 8
	*r2=a1
	r0=704
	r1=720
	r2=719
	pt=W208
	a0=*r0++		/* a0=A(0)r		*/
	a1=*r2			/* a1=A(n/2-1)i		*/
	x=*pt++ y=*r1++		/* x=Ur; y=A(n/2)r	*/
	redo 8
	*r2=a1
	r0=736
	r1=752
	r2=751
	pt=W464
	a0=*r0++		/* a0=A(0)r		*/
	a1=*r2			/* a1=A(n/2-1)i		*/
	x=*pt++ y=*r1++		/* x=Ur; y=A(n/2)r	*/
	redo 8
	*r2=a1
	r0=768
	r1=784
	r2=783
	pt=W48
	a0=*r0++		/* a0=A(0)r		*/
	a1=*r2			/* a1=A(n/2-1)i		*/
	x=*pt++ y=*r1++		/* x=Ur; y=A(n/2)r	*/
	redo 8
	*r2=a1
	r0=800
	r1=816
	r2=815
	pt=W304
	a0=*r0++		/* a0=A(0)r		*/
	a1=*r2			/* a1=A(n/2-1)i		*/
	x=*pt++ y=*r1++		/* x=Ur; y=A(n/2)r	*/
	redo 8
	*r2=a1
	r0=832
	r1=848
	r2=847
	pt=W176
	a0=*r0++		/* a0=A(0)r		*/
	a1=*r2			/* a1=A(n/2-1)i		*/
	x=*pt++ y=*r1++		/* x=Ur; y=A(n/2)r	*/
	redo 8
	*r2=a1
	r0=864
	r1=880
	r2=879
	pt=W432
	a0=*r0++		/* a0=A(0)r		*/
	a1=*r2			/* a1=A(n/2-1)i		*/
	x=*pt++ y=*r1++		/* x=Ur; y=A(n/2)r	*/
	redo 8
	*r2=a1
	r0=896
	r1=912
	r2=911
	pt=W112
	a0=*r0++		/* a0=A(0)r		*/
	a1=*r2			/* a1=A(n/2-1)i		*/
	x=*pt++ y=*r1++		/* x=Ur; y=A(n/2)r	*/
	redo 8
	*r2=a1
	r0=928
	r1=944
	r2=943
	pt=W368
	a0=*r0++		/* a0=A(0)r		*/
	a1=*r2			/* a1=A(n/2-1)i		*/
	x=*pt++ y=*r1++		/* x=Ur; y=A(n/2)r	*/
	redo 8
	*r2=a1
	r0=960
	r1=976
	r2=975
	pt=W240
	a0=*r0++		/* a0=A(0)r		*/
	a1=*r2			/* a1=A(n/2-1)i		*/
	x=*pt++ y=*r1++		/* x=Ur; y=A(n/2)r	*/
	redo 8
	*r2=a1
	r0=992
	r1=1008
	r2=1007
	pt=W496
	a0=*r0++		/* a0=A(0)r		*/
	a1=*r2			/* a1=A(n/2-1)i		*/
	x=*pt++ y=*r1++		/* x=Ur; y=A(n/2)r	*/
	redo 8
	*r2=a1
	r0=1024
	r1=1040
	r2=1039
	pt=W8
	a0=*r0++		/* a0=A(0)r		*/
	a1=*r2			/* a1=A(n/2-1)i		*/
	x=*pt++ y=*r1++		/* x=Ur; y=A(n/2)r	*/
	redo 8
	*r2=a1
	r0=1056
	r1=1072
	r2=1071
	pt=W264
	a0=*r0++		/* a0=A(0)r		*/
	a1=*r2			/* a1=A(n/2-1)i		*/
	x=*pt++ y=*r1++		/* x=Ur; y=A(n/2)r	*/
	redo 8
	*r2=a1
	r0=1088
	r1=1104
	r2=1103
	pt=W136
	a0=*r0++		/* a0=A(0)r		*/
	a1=*r2			/* a1=A(n/2-1)i		*/
	x=*pt++ y=*r1++		/* x=Ur; y=A(n/2)r	*/
	redo 8
	*r2=a1
	r0=1120
	r1=1136
	r2=1135
	pt=W392
	a0=*r0++		/* a0=A(0)r		*/
	a1=*r2			/* a1=A(n/2-1)i		*/
	x=*pt++ y=*r1++		/* x=Ur; y=A(n/2)r	*/
	redo 8
	*r2=a1
	r0=1152
	r1=1168
	r2=1167
	pt=W72
	a0=*r0++		/* a0=A(0)r		*/
	a1=*r2			/* a1=A(n/2-1)i		*/
	x=*pt++ y=*r1++		/* x=Ur; y=A(n/2)r	*/
	redo 8
	*r2=a1
	r0=1184
	r1=1200
	r2=1199
	pt=W328
	a0=*r0++		/* a0=A(0)r		*/
	a1=*r2			/* a1=A(n/2-1)i		*/
	x=*pt++ y=*r1++		/* x=Ur; y=A(n/2)r	*/
	redo 8
	*r2=a1
	r0=1216
	r1=1232
	r2=1231
	pt=W200
	a0=*r0++		/* a0=A(0)r		*/
	a1=*r2			/* a1=A(n/2-1)i		*/
	x=*pt++ y=*r1++		/* x=Ur; y=A(n/2)r	*/
	redo 8
	*r2=a1
	r0=1248
	r1=1264
	r2=1263
	pt=W456
	a0=*r0++		/* a0=A(0)r		*/
	a1=*r2			/* a1=A(n/2-1)i		*/
	x=*pt++ y=*r1++		/* x=Ur; y=A(n/2)r	*/
	redo 8
	*r2=a1
	r0=1280
	r1=1296
	r2=1295
	pt=W40
	a0=*r0++		/* a0=A(0)r		*/
	a1=*r2			/* a1=A(n/2-1)i		*/
	x=*pt++ y=*r1++		/* x=Ur; y=A(n/2)r	*/
	redo 8
	*r2=a1
	r0=1312
	r1=1328
	r2=1327
	pt=W296
	a0=*r0++		/* a0=A(0)r		*/
	a1=*r2			/* a1=A(n/2-1)i		*/
	x=*pt++ y=*r1++		/* x=Ur; y=A(n/2)r	*/
	redo 8
	*r2=a1
	r0=1344
	r1=1360
	r2=1359
	pt=W168
	a0=*r0++		/* a0=A(0)r		*/
	a1=*r2			/* a1=A(n/2-1)i		*/
	x=*pt++ y=*r1++		/* x=Ur; y=A(n/2)r	*/
	redo 8
	*r2=a1
	r0=1376
	r1=1392
	r2=1391
	pt=W424
	a0=*r0++		/* a0=A(0)r		*/
	a1=*r2			/* a1=A(n/2-1)i		*/
	x=*pt++ y=*r1++		/* x=Ur; y=A(n/2)r	*/
	redo 8
	*r2=a1
	r0=1408
	r1=1424
	r2=1423
	pt=W104
	a0=*r0++		/* a0=A(0)r		*/
	a1=*r2			/* a1=A(n/2-1)i		*/
	x=*pt++ y=*r1++		/* x=Ur; y=A(n/2)r	*/
	redo 8
	*r2=a1
	r0=1440
	r1=1456
	r2=1455
	pt=W360
	a0=*r0++		/* a0=A(0)r		*/
	a1=*r2			/* a1=A(n/2-1)i		*/
	x=*pt++ y=*r1++		/* x=Ur; y=A(n/2)r	*/
	redo 8
	*r2=a1
	r0=1472
	r1=1488
	r2=1487
	pt=W232
	a0=*r0++		/* a0=A(0)r		*/
	a1=*r2			/* a1=A(n/2-1)i		*/
	x=*pt++ y=*r1++		/* x=Ur; y=A(n/2)r	*/
	redo 8
	*r2=a1
	r0=1504
	r1=1520
	r2=1519
	pt=W488
	a0=*r0++		/* a0=A(0)r		*/
	a1=*r2			/* a1=A(n/2-1)i		*/
	x=*pt++ y=*r1++		/* x=Ur; y=A(n/2)r	*/
	redo 8
	*r2=a1
	r0=1536
	r1=1552
	r2=1551
	pt=W24
	a0=*r0++		/* a0=A(0)r		*/
	a1=*r2			/* a1=A(n/2-1)i		*/
	x=*pt++ y=*r1++		/* x=Ur; y=A(n/2)r	*/
	redo 8
	*r2=a1
	r0=1568
	r1=1584
	r2=1583
	pt=W280
	a0=*r0++		/* a0=A(0)r		*/
	a1=*r2			/* a1=A(n/2-1)i		*/
	x=*pt++ y=*r1++		/* x=Ur; y=A(n/2)r	*/
	redo 8
	*r2=a1
	r0=1600
	r1=1616
	r2=1615
	pt=W152
	a0=*r0++		/* a0=A(0)r		*/
	a1=*r2			/* a1=A(n/2-1)i		*/
	x=*pt++ y=*r1++		/* x=Ur; y=A(n/2)r	*/
	redo 8
	*r2=a1
	r0=1632
	r1=1648
	r2=1647
	pt=W408
	a0=*r0++		/* a0=A(0)r		*/
	a1=*r2			/* a1=A(n/2-1)i		*/
	x=*pt++ y=*r1++		/* x=Ur; y=A(n/2)r	*/
	redo 8
	*r2=a1
	r0=1664
	r1=1680
	r2=1679
	pt=W88
	a0=*r0++		/* a0=A(0)r		*/
	a1=*r2			/* a1=A(n/2-1)i		*/
	x=*pt++ y=*r1++		/* x=Ur; y=A(n/2)r	*/
	redo 8
	*r2=a1
	r0=1696
	r1=1712
	r2=1711
	pt=W344
	a0=*r0++		/* a0=A(0)r		*/
	a1=*r2			/* a1=A(n/2-1)i		*/
	x=*pt++ y=*r1++		/* x=Ur; y=A(n/2)r	*/
	redo 8
	*r2=a1
	r0=1728
	r1=1744
	r2=1743
	pt=W216
	a0=*r0++		/* a0=A(0)r		*/
	a1=*r2			/* a1=A(n/2-1)i		*/
	x=*pt++ y=*r1++		/* x=Ur; y=A(n/2)r	*/
	redo 8
	*r2=a1
	r0=1760
	r1=1776
	r2=1775
	pt=W472
	a0=*r0++		/* a0=A(0)r		*/
	a1=*r2			/* a1=A(n/2-1)i		*/
	x=*pt++ y=*r1++		/* x=Ur; y=A(n/2)r	*/
	redo 8
	*r2=a1
	r0=1792
	r1=1808
	r2=1807
	pt=W56
	a0=*r0++		/* a0=A(0)r		*/
	a1=*r2			/* a1=A(n/2-1)i		*/
	x=*pt++ y=*r1++		/* x=Ur; y=A(n/2)r	*/
	redo 8
	*r2=a1
	r0=1824
	r1=1840
	r2=1839
	pt=W312
	a0=*r0++		/* a0=A(0)r		*/
	a1=*r2			/* a1=A(n/2-1)i		*/
	x=*pt++ y=*r1++		/* x=Ur; y=A(n/2)r	*/
	redo 8
	*r2=a1
	r0=1856
	r1=1872
	r2=1871
	pt=W184
	a0=*r0++		/* a0=A(0)r		*/
	a1=*r2			/* a1=A(n/2-1)i		*/
	x=*pt++ y=*r1++		/* x=Ur; y=A(n/2)r	*/
	redo 8
	*r2=a1
	r0=1888
	r1=1904
	r2=1903
	pt=W440
	a0=*r0++		/* a0=A(0)r		*/
	a1=*r2			/* a1=A(n/2-1)i		*/
	x=*pt++ y=*r1++		/* x=Ur; y=A(n/2)r	*/
	redo 8
	*r2=a1
	r0=1920
	r1=1936
	r2=1935
	pt=W120
	a0=*r0++		/* a0=A(0)r		*/
	a1=*r2			/* a1=A(n/2-1)i		*/
	x=*pt++ y=*r1++		/* x=Ur; y=A(n/2)r	*/
	redo 8
	*r2=a1
	r0=1952
	r1=1968
	r2=1967
	pt=W376
	a0=*r0++		/* a0=A(0)r		*/
	a1=*r2			/* a1=A(n/2-1)i		*/
	x=*pt++ y=*r1++		/* x=Ur; y=A(n/2)r	*/
	redo 8
	*r2=a1
	r0=1984
	r1=2000
	r2=1999
	pt=W248
	a0=*r0++		/* a0=A(0)r		*/
	a1=*r2			/* a1=A(n/2-1)i		*/
	x=*pt++ y=*r1++		/* x=Ur; y=A(n/2)r	*/
	redo 8
	*r2=a1
	r0=2016
	r1=2032
	r2=2031
	pt=W504
	a0=*r0++		/* a0=A(0)r		*/
	a1=*r2			/* a1=A(n/2-1)i		*/
	x=*pt++ y=*r1++		/* x=Ur; y=A(n/2)r	*/
	redo 8
	*r2=a1

level7:	r0=0
	r1=8
	r2=7
	pt=W0
	c0=-127
loop1:	a0=*r0++		/* a0=A(0)r		*/
	a1=*r2			/* a1=A(n/2-1)i		*/
	x=*pt++ y=*r1++		/* x=Ur; y=A(n/2)r	*/
	redo 4
	*r2++=a1
	a0=r2
	r0=a0
	y=8
	a0=a0+y
	r1=a0
	r2=a0
	y=*r2-- x=*pt++
	if c0lt goto loop1

level8:	r0=0
	r1=4
	r2=3
	pt=W0
	c0=-255
loop2:	a0=*r0++		/* a0=A(0)r		*/
	a1=*r2			/* a1=A(n/2-1)i		*/
	x=*pt++ y=*r1++		/* x=Ur; y=A(n/2)r	*/
	redo 2
	*r2++=a1
	a0=r2
	r0=a0
	y=4
	a0=a0+y
	r1=a0
	r2=a0
	y=*r2-- x=*pt++
	if c0lt goto loop2

divid:	r0=0x0			/* Divide all the data by 2	*/
	a0=*r0++
	do 120 {
	a0=a0>>1
	*r0m2:a0
	a0=a0>>1
	*r0m2:a0
	a0=a0>>1
	*r0m2:a0
	a0=a0>>1
	*r0m2:a0
	a0=a0>>1
	*r0m2:a0
	a0=a0>>1
	*r0m2:a0
	a0=a0>>1
	*r0m2:a0
	}
	redo 120
	redo 52
	a0=a0>>1
	*r0m2:a0
	a0=a0>>1
	*r0m2:a0
	a0=a0>>1
	*r0m2:a0
	a0=a0>>1
	*r0m2:a0

level9:	r0=0x0
	r1=0x2
	r2=0x2
	pt=W0
	a0=*r0			/* a0=A(k)r		*/
	x=*pt++ y=*r1++		/* x=Ur, y=A(k+1)r		*/
	p=x*y y=*r1-- x=*pt++i	/* p=Ur*A(k+1)r,x=Ui,y=A(k+1)i	*/
	j=3
	do 100 {
	a1=a0-p		/* a1=A(k)r-Ur*A(k+1)r		*/
	a0=a0+p p=x*y	/* a0=A(k)r+Ur*A(k+1)r,p=Ui*A(k+1)i	*/
	a0=a0-p y=*r1++	/* a0=A(k)r+Ur*A(k+1)r-Ui*A(k+1)i,y=A(k+1)r	*/
	a1=a1+p p=x*y *r0++=a0	/* p=Ui*A(k+1)r		*/
	x=*pt++ y=*r1++j		/* x=Ur, y=A(k+1)i	*/
	a0=*r0			/* a0=A(k)i		*/
	a1=a0-p *r2++=a1	/* a1=a(k)i-Ui*A(k+1)r	*/
	a0=a0+p p=x*y y=*r1 x=*pt++	/* p=Ur*A(k+1)i,x=Ui,y=A(k+2)r	*/
	a0=a0+p y=*r1++ x=*pt++	/* x=Ur', y=A(k+3)r	*/
	a1=a1-p p=x*y *r0++j=a0	/* p=Ur'*A(k+3)r	*/
	y=*r1-- x=*pt++i	/* x=Ui', y=A(k+3)i	*/
	a0=*r0			/* a0=A(k+2)r		*/
	*r2++j=a1
	}
	redo 100
	redo 100
	redo 100
	redo 100
	redo 12

/* Bit reverse		*/

	pt=bitrev
	y=a0 x=*pt++
	a0=x
	y=a0 x=*pt++
	do 125 {
	r0=a0
	a1=x
	r1=a1
	y=*r0++ x=*pt++
	a0=x
	a1=*r0--
	*r1zp:y x=*pt++
	*r1zp:a1
	*r0++=y
	*r0=a1
	}
	redo 125
	redo 125
	redo 121

stop:	;
	goto stop

/* Subroutine to perform I/O for DSP16 1024pt complex FFT.	*/
/* Subroutine requires 26 words of memory and executes in	*/
/* 4104 instruction cycles.					*/

1024io:	r0=0
	y=0
	do 100	{
		*r0++=pdx0
		*r0++=y
		*r0++=pdx0
		*r0++=y
		*r0++=pdx0
		*r0++=y
		*r0++=pdx0
		*r0++=y
		*r0++=pdx0
		*r0++=y
		*r0++=pdx0
		*r0++=y
		}

	redo 70

		*r0++=pdx0
		*r0++=y
		*r0++=pdx0
		*r0++=y
		*r0++=pdx0
		*r0++=y
		*r0++=pdx0
		*r0++=y

	return

W0:	int	1.0
	int	0.0
W256:	int	0.0
	int	-1.0
W128:	int	0.7071068
	int	-0.7071068
W384:	int	-0.7071068
	int	-0.7071068
W64:	int	0.9238795	/* cos (-pi/512 * 64)	*/
	int	-0.3826834	/* sin (-pi/512 * 64)	*/
W320:	int	-0.3826834	/* cos (-pi/512 * 320)	*/
	int	-0.9238795	/* sin (-pi/512 * 320)	*/
W192:	int	0.3826834
	int	-0.9238795
W448:	int	-0.9238795
	int	-0.3826834
W32:	int	0.9807853
	int	-0.1950903
W288:	int	-0.1950903
	int	-0.9807853
W160:	int	0.5555702
	int	-0.8314696
W416:	int	-0.8314696
	int	-0.5555702
W96:	int	0.8314696
	int	-0.5555702
W352:	int	-0.5555702
	int	-0.8314696
W224:	int	0.1950903	/* cos (-pi/512 * 224)	*/
	int	-0.9807853	/* sin (-pi/512 * 224)	*/
W480:	int	-0.9807853
	int	-0.1950903
W16:	int	0.9951847
	int	-0.0980171
W272:	int	-0.0980171
	int	-0.9951847
W144:	int	0.6343933
	int	-0.7730105
W400:	int	-0.7730105
	int	-0.6343933
W80:	int	0.8819213
	int	-0.4713967
W336:	int	-0.4713967
	int	-0.8819213
W208:	int	0.2902847	/* cos (-pi/512 * 208)	*/
	int	-0.9569403	/* sin (-pi/512 * 208)	*/
W464:	int	-0.9569403
	int	-0.2902846
W48:	int	0.9569403
	int	-0.2902847
W304:	int	-0.2902847
	int	-0.9569403
W176:	int	0.4713967
	int	-0.8819213
W432:	int	-0.8819213
	int	-0.4713967
W112:	int	0.7730105
	int	-0.6343933
W368:	int	-0.6343933
	int	-0.7730105
W240:	int	0.0980171	/* cos (-pi/512 * 240)	*/
	int	-0.9951847	/* sin (-pi/512 * 240)	*/
W496:	int	-0.9951847
	int	-0.0980171
W8:	int	0.9987955
	int	-0.0490677
W264:	int	-0.0490677
	int	-0.9987955
W136:	int	0.6715590
	int	-0.7409511
W392:	int	-0.7409511
	int	-0.6715590
W72:	int	0.9039893
	int	-0.4275551
W328:	int	-0.4275551
	int	-0.9030893
W200:	int	0.3368899
	int	-0.9415441
W456:	int	-0.9415441
	int	-0.3368899
W40:	int	0.9700313
	int	-0.2429802
W296:	int	-0.2429802
	int	-0.9700313
W168:	int	0.5141027
	int	-0.8577286
W424:	int	-0.8577286
	int	-0.5141027
W104:	int	0.8032075	/* cos (-pi/512 * 104)	*/
	int	-0.5956993	/* sin (-pi/512 * 104)	*/
W360:	int	-0.5956993
	int	-0.8032075
W232:	int	0.1467305
	int	-0.9891765
W488:	int	-0.9891765
	int	-0.1467305
W24:	int	0.9891765
	int	-0.1467305
W280:	int	-0.1467305
	int	-0.9891765
W152:	int	0.5956993
	int	-0.8032075
W408:	int	-0.8032075
	int	-0.5956993
W88:	int	0.8577286
	int	-0.5141027
W344:	int	-0.5141027
	int	-0.8577286
W216:	int	0.2429802
	int	-0.9700313
W472:	int	-0.9700313
	int	-0.2429802
W56:	int	0.9415441	/* cos (-pi/512 * 56)	*/
	int	-0.3368899	/* sin (-pi/512 * 56)	*/
W312:	int	-0.3368899
	int	-0.9415441
W184:	int	0.4275551
	int	-0.9039893
W440:	int	-0.9039893
	int	-0.4275551
W120:	int	0.7409511
	int	-0.6715590
W376:	int	-0.6715590
	int	-0.7409511
W248:	int	0.0490677
	int	-0.9987955
W504:	int	-0.9987955
	int	-0.0490677
W4:	int	0.9996988
	int	-0.0245412
W260:	int	-0.0245412
	int	-0.9996988
W132:	int	0.6895405	/* cos (-pi/512 * 132)	*/
	int	-0.7242471	/* sin (-pi/512 * 132)	*/
W388:	int	-0.7242471
	int	-0.6895405
W68:	int	0.9142098
	int	-0.4052413
W324:	int	-0.4052413
	int	-0.9142098
W196:	int	0.3598950
	int	-0.9329928
W452:	int	-0.9329928
	int	-0.3598950
W36:	int	0.9757021
	int	-0.2191012
W292:	int	-0.2191012
	int	-0.9757021
W164:	int	0.5349976
	int	-0.8448536
W420:	int	-0.8448536
	int	-0.5349976
W100:	int	0.8175848
	int	-0.5758082
W356:	int	-0.5758082	/* cos (-pi/512 * 356)	*/
	int	-0.8175848	/* sin (-pi/512 * 356)	*/
W228:	int	0.1709619
	int	-0.9852776
W484:	int	-0.9852776
	int	-0.1709619
W20:	int	0.9924795
	int	-0.1224107
W276:	int	-0.1224107
	int	-0.9924795
W148:	int	0.6152316
	int	-0.7883464
W404:	int	-0.7883464
	int	-0.6152316
W84:	int	0.8700870
	int	-0.4928982
W340:	int	-0.4928982
	int	-0.8700870
W212:	int	0.2667128
	int	-0.9637761
W468:	int	-0.9637761
	int	-0.2667128
W52:	int	0.9495282
	int	-0.3136827
W308:	int	-0.3136827	/* cos (-pi/512 * 308)	*/
	int	-0.9495282	/* sin (-pi/512 * 308)	*/
W180:	int	0.44961133
	int	-0.8932243
W436:	int	-0.8932243
	int	-0.4496113
W116:	int	0.7572088
	int	-0.6531728
W372:	int	-0.6531728
	int	-0.7572088
W244:	int	0.0735646
	int	-0.9972905
W500:	int	-0.9972905
	int	-0.0735646
W12:	int	0.9972905
	int	-0.0735646
W268:	int	-0.0735646
	int	-0.9972905
W140:	int	0.6531728
	int	-0.7572088
W396:	int	-0.7572088
	int	-0.6531728
W76:	int	0.8932243
	int	-0.4496113
W332:	int	-0.4496113
	int	-0.8932243
W204:	int	0.3136817
	int	-0.9495282
W460:	int	-0.9495282	/* cos (-pi/512 * 460)	*/
	int	-0.3136817	/* sin (-pi/512 * 460)	*/
W44:	int	0.9637761
	int	-0.2667128
W300:	int	-0.2667128
	int	-0.9637761
W172:	int	0.4928982
	int	-0.8700870
W428:	int	-0.8700870
	int	-0.4928982
W108:	int	0.7883464
	int	-0.6152316
W364:	int	-0.6152316
	int	-0.7883464
W236:	int	0.1224107
	int	-0.9924795
W492:	int	-0.9924795
	int	-0.1224107
W28:	int	0.9852776
	int	-0.1709619
W284:	int	-0.1709619
	int	-0.9852776
W156:	int	0.5758082
	int	-0.8175848
W412:	int	-0.8175848
	int	-0.5758082
W92:	int	0.8448536
	int	-0.5349976
W348:	int	-0.5349976
	int	-0.8448536
W220:	int	0.2191012
	int	-0.9757021
W476:	int	-0.9757021
	int	-0.2191012
W60:	int	0.9329928	/* cos (-pi/512 * 60)	*/
	int	-0.3598950	/* sin (-pi/512 * 60)	*/
W316:	int	-0.3598950
	int	-0.9329928
W188:	int	0.4052413
	int	-0.9142098
W444:	int	-0.9142098
	int	-0.4052413
W124:	int	0.7242471
	int	-0.6895405
W380:	int	-0.6895405
	int	-0.7242471
W252:	int	0.0245412
	int	-0.9996988
W508:	int	-0.9996988
	int	-0.0245412
W2:	int	0.999924701	/* cos (-pi/512 * 2)	*/
	int	-0.0122715	/* sin (-pi/512 * 2)	*/
W258:	int	-0.0122715
	int	-0.9999247
W130:	int	0.69837625
	int	-0.7157308
W386:	int	-0.7157308
	int	-0.69837625
W66:	int	0.91911385
	int	-0.39399204
W322:	int	-0.39399204
	int	-0.91911385
W194:	int	0.37131719
	int	-0.92850608
W450:	int	-0.92850608
	int	-0.37131719
W34:	int	0.97831737
	int	-0.20711138
W290:	int	-0.20711138
	int	-0.97831737
W162:	int	0.545324988
	int	-0.838224705
W418:	int	-0.838224705
	int	-0.545324988
W98:	int	0.824589302
	int	-0.56573181
W354:	int	-0.56573181
	int	-0.824589302
W226:	int	0.18303988
	int	-0.983105487
W482:	int	-0.983105487
	int	-0.183039888
W18:	int	0.99390697
	int	-0.110222207
W274:	int	-0.110222207
	int	-0.99390697
W146:	int	0.624859488
	int	-0.780737228
W402:	int	-0.780737228
	int	-0.624859488
W82:	int	0.876070094
	int	-0.482183772
W338:	int	-0.482183772
	int	-0.876070094
W210:	int	0.278519689
	int	-0.960430519
W466:	int	-0.960430519
	int	-0.278519689
W50:	int	0.95330604
	int	-0.302005949
W306:	int	-0.302005949
	int	-0.95330604
W178:	int	0.460538711	/* cos (-pi/512 * 178)	*/
	int	-0.88763962	/* sin (-pi/512 * 178)	*/
W434:	int	-0.88763962
	int	-0.460538711
W114:	int	0.765167265
	int	-0.643831542
W370:	int	-0.643831542
	int	-0.765167265
W242:	int	0.085797312
	int	-0.996312612
W498:	int	-0.996312612
	int	-0.085797312
W10:	int	0.998118112
	int	-0.061320736
W266:	int	-0.061320736
	int	-0.998118112
W138:	int	0.662415777
	int	-0.749136394
W394:	int	-0.749136394
	int	-0.662415777
W74:	int	0.898674465
	int	-0.438616238
W330:	int	-0.438616238
	int	-0.898674465
W202:	int	0.325310292
	int	-0.945607325
W458:	int	-0.945607325	/* cos (-pi/512 * 458)	*/
	int	-0.325310292	/* sin (-pi/512 * 458)	*/
W42:	int	0.966976471
	int	-0.254865659
W298:	int	-0.254865659
	int	-0.966976471
W170:	int	0.503538383
	int	-0.863972856
W426:	int	-0.863972856
	int	-0.503538383
W106:	int	0.795836904
	int	-0.605511041
W362:	int	-0.605511041
	int	-0.795836904
W234:	int	0.134580708
	int	-0.990902635
W490:	int	-0.990902635
	int	-0.134580708
W26:	int	0.987301418
	int	-0.158858143
W282:	int	-0.158858143
	int	-0.987301418
W154:	int	0.585797857
	int	-0.810457198
W410:	int	-0.810457198
	int	-0.585797857
W90:	int	0.851355193
	int	-0.524589682
W346:	int	-0.524589682
	int	-0.851355193
W218:	int	0.231058108
	int	-0.972939952
W474:	int	-0.972939952
	int	-0.231058108
W58:	int	0.937339011
	int	-0.34841868
W314:	int	-0.34841868
	int	-0.937339011
W186:	int	0.41642956
	int	-0.909167983
W442:	int	-0.909167983
	int	-0.41642956
W122:	int	0.732654271
	int	-0.680600997
W378:	int	-0.680600997
	int	-0.732654271
W250:	int	0.036807222
	int	-0.999322384
W506:	int	-0.999322384
	int	-0.036807222
W6:	int	0.999322384
	int	-0.036807222
W262:	int	-0.036807222
	int	-0.999322384
W134:	int	0.680600997
	int	-0.732654271
W390:	int	-0.732654271
	int	-0.680600997
W70:	int	0.909167983
	int	-0.41642956
W326:	int	-0.41642956
	int	-0.909167983
W198:	int	0.34841868
	int	-0.937339011
W454:	int	-0.937339011
	int	-0.34841868
W38:	int	0.972939952
	int	-0.231058108
W294:	int	-0.231058108
	int	-0.972939952
W166:	int	0.524589682
	int	-0.851355193
W422:	int	-0.851355193
	int	-0.524589682
W102:	int	0.810457198	/* cos (-pi/512 * 102)	*/
	int	-0.585797857	/* sin (-pi/512 * 102)	*/
W358:	int	-0.585797857
	int	-0.810457198
W230:	int	0.158858143
	int	-0.987301418
W486:	int	-0.987301418
	int	-0.158858143
W22:	int	0.990902635
	int	-0.134580708
W278:	int	-0.134580708
	int	-0.990902635
W150:	int	0.605511041
	int	-0.795836904
W406:	int	-0.795836904
	int	-0.605511041
W86:	int	0.863972856
	int	-0.503538383
W342:	int	-0.503538383
	int	-0.863972856
W214:	int	0.254865659
	int	-0.966976471
W470:	int	-0.966976471
	int	-0.254865659
W54:	int	0.945607325
	int	-0.325310292
W310:	int	-0.325310292
	int	-0.945607325
W182:	int	0.438616238
	int	-0.898674465
W438:	int	-0.898674465
	int	-0.438616238
W118:	int	0.749136394
	int	-0.662415777
W374:	int	-0.662415777
	int	-0.749136394
W246:	int	0.061320736
	int	-0.998118112
W502:	int	-0.998118112
	int	-0.061320736
W14:	int	0.996312612
	int	-0.085797312
W270:	int	-0.085797312
	int	-0.996312612
W142:	int	0.643831542
	int	-0.765167265
W398:	int	-0.765167265
	int	-0.643831542
W78:	int	0.88763962
	int	-0.460538711
W334:	int	-0.460538711
	int	-0.88763962
W206:	int	0.302005949
	int	-0.95330604
W462:	int	-0.95330604
	int	-0.302005949
W46:	int	0.960430519
	int	-0.278519689
W302:	int	-0.278519689
	int	-0.960430519
W174:	int	0.482183772
	int	-0.876070094
W430:	int	-0.876070094
	int	-0.482183772
W110:	int	0.780737228
	int	-0.624859488
W366:	int	-0.624859488
	int	-0.780737228
W238:	int	0.110222207
	int	-0.99390697
W494:	int	-0.99390697
	int	-0.110222207
W30:	int	0.983105487
	int	-0.183039888
W286:	int	-0.183039888
	int	-0.983105487
W158:	int	0.56573181
	int	-0.824589302
W414:	int	-0.824589302
	int	-0.56573181
W94:	int	0.838224705	/* cos (-pi/512 * 94)	*/
	int	-0.545324988	/* sin (-pi/512 * 94)	*/
W350:	int	-0.545324988
	int	-0.838224705
W222:	int	0.207111376
	int	-0.97831737
W478:	int	-0.97831737
	int	-0.207111376
W62:	int	0.92850608
	int	-0.371317194
W318:	int	-0.371317194
	int	-0.92850608
W190:	int	0.39399204
	int	-0.919113851
W446:	int	-0.919113851
	int	-0.39399204
W126:	int	0.715730825
	int	-0.698376249
W382:	int	-0.698376249
	int	-0.715730825
W254:	int	0.012271538
	int	-0.999924701
W510:	int	-0.999924701	/* cos (-pi/512 * 510)	*/
	int	-0.012271538	/* sin (-pi/512 * 510)	*/
	int	0.999981175
	int	-0.006135884
	int	-0.006135884
	int	-0.999981175
	int	0.702754744
	int	-0.711432195
	int	-0.711432195
	int	-0.702754744
	int	0.921514039
	int	-0.388345046
	int	-0.388345046
	int	-0.921514039
	int	0.37700741
	int	-0.926210242
	int	-0.926210242
	int	-0.37700741
	int	0.979569765
	int	-0.201104634
	int	-0.201104634
	int	-0.979569765
	int	0.550457972
	int	-0.834862875
	int	-0.834862875
	int	-0.550457972
	int	0.828045045	/* cos (-pi/512 * 97)	*/
	int	-0.560661576	/* sin (-pi/512 * 97)	*/
	int	-0.560661576
	int	-0.828045045
	int	0.189068664
	int	-0.981963869
	int	-0.981963869
	int	-0.189068664
	int	0.99456457
	int	-0.104121633
	int	-0.104121633
	int	-0.99456457
	int	0.629638238
	int	-0.776888465
	int	-0.776888465
	int	-0.629638238
	int	0.879012226
	int	-0.47679923
	int	-0.47679923
	int	-0.879012226
	int	0.284407537
	int	-0.958703474
	int	-0.958703474
	int	-0.284407537
	int	0.955141168
	int	-0.296150888
	int	-0.296150888
	int	-0.955141168
	int	0.465976495
	int	-0.884797098
	int	-0.884797098
	int	-0.465976495
	int	0.769103337
	int	-0.639124444
	int	-0.639124444
	int	-0.769103337
	int	0.091908956
	int	-0.995767414
	int	-0.995767414	/* cos (-pi/512 * 497)	*/
	int	-0.091908956	/* sin (-pi/512 * 497)	*/
	int	0.99847558
	int	-0.055195244
	int	-0.055195244
	int	-0.99847558
	int	0.666999922
	int	-0.745057785
	int	-0.745057785
	int	-0.666999922
	int	0.901348847
	int	-0.433093818
	int	-0.433093818
	int	-0.901348847
	int	0.331106305
	int	-0.943593458
	int	-0.943593458
	int	-0.331106305
	int	0.968522094
	int	-0.248927605
	int	-0.248927605
	int	-0.968522094
	int	0.508830142
	int	-0.860866938
	int	-0.860866938
	int	-0.508830142
	int	0.799537269
	int	-0.600616479
	int	-0.600616479
	int	-0.799537269
	int	0.140658239
	int	-0.99005821
	int	-0.99005821
	int	-0.140658239
	int	0.988257567
	int	-0.152797185
	int	-0.152797185
	int	-0.988257567
	int	0.590759701
	int	-0.806847553
	int	-0.806847553
	int	-0.590759701
	int	0.854557988
	int	-0.51935599
	int	-0.51935599
	int	-0.854557988
	int	0.237023606
	int	-0.971503891
	int	-0.971503891
	int	-0.237023606
	int	0.939459223
	int	-0.342660717
	int	-0.342660717
	int	-0.939459223
	int	0.42200027
	int	-0.906595704
	int	-0.906595704
	int	-0.42200027
	int	0.736816568
	int	-0.676092703
	int	-0.676092703
	int	-0.736816568
	int	0.042938256
	int	-0.999077727
	int	-0.999077727	/* cos (-pi/512 * 505)	*/
	int	-0.042938256	/* sin (-pi/512 * 505)	*/
	int	0.999529417
	int	-0.030674803
	int	-0.030674803
	int	-0.999529417
	int	0.685083667
	int	-0.72846439
	int	-0.72846439
	int	-0.685083667
	int	0.911706032
	int	-0.410843171
	int	-0.410843171
	int	-0.911706032
	int	0.354163525
	int	-0.935183509
	int	-0.935183509
	int	-0.354163525
	int	0.974339382
	int	-0.225083911
	int	-0.225083911
	int	-0.974339382
	int	0.529803624
	int	-0.848120344
	int	-0.848120344
	int	-0.529803624
	int	0.814036329
	int	-0.580813958
	int	-0.580813958
	int	-0.814036329
	int	0.16491312
	int	-0.986308097
	int	-0.986308097
	int	-0.16491312
	int	0.991709753
	int	-0.12849811
	int	-0.12849811
	int	-0.991709753
	int	0.610382806
	int	-0.792106577
	int	-0.792106577
	int	-0.610382806
	int	0.867046245
	int	-0.498227667
	int	-0.498227667
	int	-0.867046245
	int	0.260794117
	int	-0.965394441
	int	-0.965394441
	int	-0.260794117
	int	0.947585591
	int	-0.31950203
	int	-0.31950203
	int	-0.947585591
	int	0.444122144
	int	-0.895966249
	int	-0.895966249
	int	-0.444122144
	int	0.753186799
	int	-0.657806693
	int	-0.657806693
	int	-0.753186799
	int	0.067443919
	int	-0.997723066
	int	-0.997723066
	int	-0.067443919
	int	0.996820299
	int	-0.079682437
	int	-0.079682437
	int	-0.996820299
	int	0.648514401
	int	-0.761202385
	int	-0.761202385
	int	-0.648514401
	int	0.890448723
	int	-0.455083587
	int	-0.455083587
	int	-0.890448723
	int	0.30784964
	int	-0.951435021
	int	-0.951435021
	int	-0.30784964
	int	0.962121404
	int	-0.272621355
	int	-0.272621355
	int	-0.962121404
	int	0.48755016
	int	-0.873094978
	int	-0.873094978
	int	-0.48755016
	int	0.784556597
	int	-0.620057211
	int	-0.620057211
	int	-0.784556597
	int	0.11631863
	int	-0.993211949
	int	-0.993211949
	int	-0.11631863
	int	0.984210092
	int	-0.17700422
	int	-0.17700422
	int	-0.98421009
	int	0.570780745
	int	-0.821102515
	int	-0.821102515
	int	-0.570780745
	int	0.841554977
	int	-0.540171472
	int	-0.540171472
	int	-0.841554977
	int	0.213110319
	int	-0.977028142
	int	-0.977028142
	int	-0.213110319
	int	0.930766961
	int	-0.365612997
	int	-0.365612997	/* cos (-pi/512 * 317)	*/
	int	-0.930766961	/* sin (-pi/512 * 317)	*/
	int	0.399624199
	int	-0.916679059
	int	-0.916679059
	int	-0.399624199
	int	0.720002508
	int	-0.69397146
	int	-0.69397146
	int	-0.720002508
	int	0.018406729
	int	-0.999830581
	int	-0.999830581
	int	-0.018406729
	int	0.999830581
	int	-0.018406729
	int	-0.018406729
	int	-0.999830581
	int	0.69397146
	int	-0.720002508
	int	-0.720002508
	int	-0.69397146
	int	0.916679059
	int	-0.399624199
	int	-0.399624199
	int	-0.916679059
	int	0.365612997
	int	-0.930766961
	int	-0.930766961
	int	-0.365612997
	int	0.977028142
	int	-0.213110319
	int	-0.213110319
	int	-0.977028142
	int	0.540171472
	int	-0.841554977
	int	-0.841554977
	int	-0.540171472
	int	0.821102515
	int	-0.570780745
	int	-0.570780745
	int	-0.821102515
	int	0.17700422
	int	-0.984210092
	int	-0.984210092
	int	-0.17700422
	int	0.993211949	/* cos (-pi/512 * 19)	*/
	int	-0.11631863	/* sin (-pi/512 * 19)	*/
	int	-0.11631863
	int	-0.993211949
	int	0.620057211
	int	-0.784556597
	int	-0.784556597
	int	-0.620057211
	int	0.873094978
	int	-0.48755016
	int	-0.48755016
	int	-0.873094978
	int	0.272621355
	int	-0.962121404
	int	-0.962121404
	int	-0.272621355
	int	0.951435021
	int	-0.30784964
	int	-0.30784964
	int	-0.951435021
	int	0.455083587
	int	-0.890448723
	int	-0.890448723
	int	-0.455083587
	int	0.761202385
	int	-0.648514401
	int	-0.648514401
	int	-0.761202385
	int	0.079682437
	int	-0.996820299
	int	-0.996820299
	int	-0.079682437
	int	0.997723066
	int	-0.067443919
	int	-0.067443919
	int	-0.997723066
	int	0.657806693
	int	-0.753186799
	int	-0.753186799
	int	-0.657806693
	int	0.895966249
	int	-0.444122144
	int	-0.444122144
	int	-0.895966249
	int	0.31950203
	int	-0.947585591
	int	-0.947585591
	int	-0.31950203
	int	0.965394441
	int	-0.260794117
	int	-0.260794117
	int	-0.965394441
	int	0.498227667
	int	-0.867046245
	int	-0.867046245
	int	-0.498227667
	int	0.792106577
	int	-0.610382806
	int	-0.610382806
	int	-0.792106577
	int	0.12849811
	int	-0.991709753
	int	-0.991709753
	int	-0.12849811
	int	0.986308097
	int	-0.16491312
	int	-0.16491312
	int	-0.986308097
	int	0.580813958
	int	-0.814036329
	int	-0.814036329	/* cos (-pi/512 * 411)	*/
	int	-0.580813958	/* sin (-pi/512 * 411)	*/
	int	0.848120344
	int	-0.529803624
	int	-0.529803624
	int	-0.848120344
	int	0.225083911
	int	-0.974339382
	int	-0.974339382
	int	-0.225083911
	int	0.935183509
	int	-0.354163525
	int	-0.354163525
	int	-0.935183509
	int	0.410843171
	int	-0.911706032
	int	-0.911706032
	int	-0.410843171
	int	0.72846439
	int	-0.685083667
	int	-0.685083667
	int	-0.72846439
	int	0.030674803
	int	-0.999529417
	int	-0.999529417
	int	-0.030674803
	int	0.999077727
	int	-0.042938256
	int	-0.042938256
	int	-0.999077727
	int	0.676092703
	int	-0.736816568
	int	-0.736816568
	int	-0.676092703
	int	0.906595704
	int	-0.42200027
	int	-0.42200027
	int	-0.906595704
	int	0.342660717
	int	-0.939459223
	int	-0.939459223
	int	-0.342660717
	int	0.971503891
	int	-0.237023606
	int	-0.237023606
	int	-0.971503891
	int	0.51935599
	int	-0.854557988
	int	-0.854557988
	int	-0.51935599
	int	0.806847553
	int	-0.590759701
	int	-0.590759701
	int	-0.806847553
	int	0.152797185
	int	-0.988257567
	int	-0.988257567
	int	-0.152797185
	int	0.99005821
	int	-0.140658239
	int	-0.140658239
	int	-0.99005821
	int	0.600616479
	int	-0.799537269
	int	-0.799537269
	int	-0.600616479
	int	0.860866938
	int	-0.508830142
	int	-0.508830142
	int	-0.860866938
	int	0.248927605
	int	-0.968522094
	int	-0.968522094
	int	-0.248927605
	int	0.943593458	/* cos (-pi/512 * 55)	*/
	int	-0.331106305	/* sin (-pi/512 * 55)	*/
	int	-0.331106305
	int	-0.943593458
	int	0.433093818
	int	-0.901348847
	int	-0.901348847
	int	-0.433093818
	int	0.745057785
	int	-0.666999922
	int	-0.666999922
	int	-0.745057785
	int	0.055195244
	int	-0.99847558
	int	-0.99847558
	int	-0.055195244
	int	0.995767414
	int	-0.091908956
	int	-0.091908956
	int	-0.995767414
	int	0.639124444
	int	-0.769103337
	int	-0.769103337
	int	-0.639124444
	int	0.884797098
	int	-0.465976495
	int	-0.465976495
	int	-0.884797098
	int	0.296150888
	int	-0.955141168
	int	-0.955141168
	int	-0.296150888
	int	0.958703474
	int	-0.284407537
	int	-0.284407537
	int	-0.958703474
	int	0.47679923
	int	-0.879012226
	int	-0.879012226
	int	-0.47679923
	int	0.776888465
	int	-0.629638238
	int	-0.629638238
	int	-0.776888465
	int	0.104121633
	int	-0.99456457
	int	-0.99456457
	int	-0.104121633
	int	0.981963869
	int	-0.189068664
	int	-0.189068664
	int	-0.981963869
	int	0.560661576
	int	-0.828045045
	int	-0.828045045
	int	-0.560661576
	int	0.834862875
	int	-0.550457972
	int	-0.550457972	/* cos (-pi/512 * 351)	*/
	int	-0.834862875	/* sin (-pi/512 * 351)	*/
	int	0.201104634
	int	-0.979569765
	int	-0.979569765
	int	-0.201104634
	int	0.926210242
	int	-0.37700741
	int	-0.37700741
	int	-0.926210242
	int	0.388345046
	int	-0.921514039
	int	-0.921514039
	int	-0.388345046
	int	0.711432195
	int	-0.702754744
	int	-0.702754744
	int	-0.711432195
	int	0.006135884
	int	-0.999981175
	int	-0.999981175	/* cos (-pi/512 * 511)	*/
	int	-0.006135884	/* sin (-pi/512 * 511)	*/

/* Bit reversal table for 1024 point fft	*/

bitrev:	int	0x2
	int	0x400
	int	0x4
	int	0x200
	int	0x6
	int	0x600
	int	0x8
	int	0x100
	int	0xa
	int	0x500
	int	0xc
	int	0x300
	int	0xe
	int	0x700
	int	0x10
	int	0x80
	int	0x12
	int	0x480
	int	0x14
	int	0x280
	int	0x16
	int	0x680
	int	0x18
	int	0x180
	int	0x1a
	int	0x580
	int	0x1c
	int	0x380
	int	0x1e
	int	0x780
	int	0x20
	int	0x40
	int	0x22
	int	0x440
	int	0x24
	int	0x240
	int	0x26
	int	0x640
	int	0x28
	int	0x140
	int	0x2a
	int	0x540
	int	0x2c
	int	0x340
	int	0x2e
	int	0x740
	int	0x30
	int	0xc0
	int	0x32
	int	0x4c0
	int	0x34
	int	0x2c0
	int	0x36
	int	0x6c0
	int	0x38
	int	0x1c0
	int	0x3a
	int	0x5c0
	int	0x3c
	int	0x3c0
	int	0x3e
	int	0x7c0
	int	0x42
	int	0x420
	int	0x44
	int	0x220
	int	0x46
	int	0x620
	int	0x48
	int	0x120
	int	0x4a
	int	0x520
	int	0x4c
	int	0x320
	int	0x4e
	int	0x720
	int	0x50
	int	0xa0
	int	0x52
	int	0x4a0
	int	0x54
	int	0x2a0
	int	0x56
	int	0x6a0
	int	0x58
	int	0x1a0
	int	0x5a
	int	0x5a0
	int	0x5c
	int	0x3a0
	int	0x5e
	int	0x7a0
	int	0x62
	int	0x460
	int	0x64
	int	0x260
	int	0x66
	int	0x660
	int	0x68
	int	0x160
	int	0x6a
	int	0x560
	int	0x6c
	int	0x360
	int	0x6e
	int	0x760
	int	0x70
	int	0xe0
	int	0x72
	int	0x4e0
	int	0x74
	int	0x2e0
	int	0x76
	int	0x6e0
	int	0x78
	int	0x1e0
	int	0x7a
	int	0x5e0
	int	0x7c
	int	0x3e0
	int	0x7e
	int	0x7e0
	int	0x82
	int	0x410
	int	0x84
	int	0x210
	int	0x86
	int	0x610
	int	0x88
	int	0x110
	int	0x8a
	int	0x510
	int	0x8c
	int	0x310
	int	0x8e
	int	0x710
	int	0x92
	int	0x490
	int	0x94
	int	0x290
	int	0x96
	int	0x690
	int	0x98
	int	0x190
	int	0x9a
	int	0x590
	int	0x9c
	int	0x390
	int	0x9e
	int	0x790
	int	0xa2
	int	0x450
	int	0xa4
	int	0x250
	int	0xa6
	int	0x650
	int	0xa8
	int	0x150
	int	0xaa
	int	0x550
	int	0xac
	int	0x350
	int	0xae
	int	0x750
	int	0xb0
	int	0xd0
	int	0xb2
	int	0x4d0
	int	0xb4
	int	0x2d0
	int	0xb6
	int	0x6d0
	int	0xb8
	int	0x1d0
	int	0xba
	int	0x5d0
	int	0xbc
	int	0x3d0
	int	0xbe
	int	0x7d0
	int	0xc2
	int	0x430
	int	0xc4
	int	0x230
	int	0xc6
	int	0x630
	int	0xc8
	int	0x130
	int	0xca
	int	0x530
	int	0xcc
	int	0x330
	int	0xce
	int	0x730
	int	0xd2
	int	0x4b0
	int	0xd4
	int	0x2b0
	int	0xd6
	int	0x6b0
	int	0xd8
	int	0x1b0
	int	0xda
	int	0x5b0
	int	0xdc
	int	0x3b0
	int	0xde
	int	0x7b0
	int	0xe2
	int	0x470
	int	0xe4
	int	0x270
	int	0xe6
	int	0x670
	int	0xe8
	int	0x170
	int	0xea
	int	0x570
	int	0xec
	int	0x370
	int	0xee
	int	0x770
	int	0xf2
	int	0x4f0
	int	0xf4
	int	0x2f0
	int	0xf6
	int	0x6f0
	int	0xf8
	int	0x1f0
	int	0xfa
	int	0x5f0
	int	0xfc
	int	0x3f0
	int	0xfe
	int	0x7f0
	int	0x102
	int	0x408
	int	0x104
	int	0x208
	int	0x106
	int	0x608
	int	0x10a
	int	0x508
	int	0x10c
	int	0x308
	int	0x10e
	int	0x708
	int	0x112
	int	0x488
	int	0x114
	int	0x288
	int	0x116
	int	0x688
	int	0x118
	int	0x188
	int	0x11a
	int	0x588
	int	0x11c
	int	0x388
	int	0x11e
	int	0x788
	int	0x122
	int	0x448
	int	0x124
	int	0x248
	int	0x126
	int	0x648
	int	0x128
	int	0x148
	int	0x12a
	int	0x548
	int	0x12c
	int	0x348
	int	0x12e
	int	0x748
	int	0x132
	int	0x4c8
	int	0x134
	int	0x2c8
	int	0x136
	int	0x6c8
	int	0x138
	int	0x1c8
	int	0x13a
	int	0x5c8
	int	0x13c
	int	0x3c8
	int	0x13e
	int	0x7c8
	int	0x142
	int	0x428
	int	0x144
	int	0x228
	int	0x146
	int	0x628
	int	0x14a
	int	0x528
	int	0x14c
	int	0x328
	int	0x14e
	int	0x728
	int	0x152
	int	0x4a8
	int	0x154
	int	0x2a8
	int	0x156
	int	0x6a8
	int	0x158
	int	0x1a8
	int	0x15a
	int	0x5a8
	int	0x15c
	int	0x3a8
	int	0x15e
	int	0x7a8
	int	0x162
	int	0x468
	int	0x164
	int	0x268
	int	0x166
	int	0x668
	int	0x16a
	int	0x568
	int	0x16c
	int	0x368
	int	0x16e
	int	0x768
	int	0x172
	int	0x4e8
	int	0x174
	int	0x2e8
	int	0x176
	int	0x6e8
	int	0x178
	int	0x1e8
	int	0x17a
	int	0x5e8
	int	0x17c
	int	0x3e8
	int	0x17e
	int	0x7e8
	int	0x182
	int	0x418
	int	0x184
	int	0x218
	int	0x186
	int	0x618
	int	0x18a
	int	0x518
	int	0x18c
	int	0x318
	int	0x18e
	int	0x718
	int	0x192
	int	0x498
	int	0x194
	int	0x298
	int	0x196
	int	0x698
	int	0x19a
	int	0x598
	int	0x19c
	int	0x398
	int	0x19e
	int	0x798
	int	0x1a2
	int	0x458
	int	0x1a4
	int	0x258
	int	0x1a6
	int	0x658
	int	0x1aa
	int	0x558
	int	0x1ac
	int	0x358
	int	0x1ae
	int	0x758
	int	0x1b2
	int	0x4d8
	int	0x1b4
	int	0x2d8
	int	0x1b6
	int	0x6d8
	int	0x1b8
	int	0x1d8
	int	0x1ba
	int	0x5d8
	int	0x1bc
	int	0x3d8
	int	0x1be
	int	0x7d8
	int	0x1c2
	int	0x438
	int	0x1c4
	int	0x238
	int	0x1c6
	int	0x638
	int	0x1ca
	int	0x538
	int	0x1cc
	int	0x338
	int	0x1ce
	int	0x738
	int	0x1d2
	int	0x4b8
	int	0x1d4
	int	0x2b8
	int	0x1d6
	int	0x6b8
	int	0x1da
	int	0x5b8
	int	0x1dc
	int	0x3b8
	int	0x1de
	int	0x7b8
	int	0x1e2
	int	0x478
	int	0x1e4
	int	0x278
	int	0x1e6
	int	0x678
	int	0x1ea
	int	0x578
	int	0x1ec
	int	0x378
	int	0x1ee
	int	0x778
	int	0x1f2
	int	0x4f8
	int	0x1f4
	int	0x2f8
	int	0x1f6
	int	0x6f8
	int	0x1fa
	int	0x5f8
	int	0x1fc
	int	0x3f8
	int	0x1fe
	int	0x7f8
	int	0x202
	int	0x404
	int	0x206
	int	0x604
	int	0x20a
	int	0x504
	int	0x20c
	int	0x304
	int	0x20e
	int	0x704
	int	0x212
	int	0x484
	int	0x214
	int	0x284
	int	0x216
	int	0x684
	int	0x21a
	int	0x584
	int	0x21c
	int	0x384
	int	0x21e
	int	0x784
	int	0x222
	int	0x444
	int	0x224
	int	0x244
	int	0x226
	int	0x644
	int	0x22a
	int	0x544
	int	0x22c
	int	0x344
	int	0x22e
	int	0x744
	int	0x232
	int	0x4c4
	int	0x234
	int	0x2c4
	int	0x236
	int	0x6c4
	int	0x23a
	int	0x5c4
	int	0x23c
	int	0x3c4
	int	0x23e
	int	0x7c4
	int	0x242
	int	0x424
	int	0x246
	int	0x624
	int	0x24a
	int	0x524
	int	0x24c
	int	0x324
	int	0x24e
	int	0x724
	int	0x252
	int	0x4a4
	int	0x254
	int	0x2a4
	int	0x256
	int	0x6a4
	int	0x25a
	int	0x5a4
	int	0x25c
	int	0x3a4
	int	0x25e
	int	0x7a4
	int	0x262
	int	0x464
	int	0x266
	int	0x664
	int	0x26a
	int	0x564
	int	0x26c
	int	0x364
	int	0x26e
	int	0x764
	int	0x272
	int	0x4e4
	int	0x274
	int	0x2e4
	int	0x276
	int	0x6e4
	int	0x27a
	int	0x5e4
	int	0x27c
	int	0x3e4
	int	0x27e
	int	0x7e4
	int	0x282
	int	0x414
	int	0x286
	int	0x614
	int	0x28a
	int	0x514
	int	0x28c
	int	0x314
	int	0x28e
	int	0x714
	int	0x292
	int	0x494
	int	0x296
	int	0x694
	int	0x29a
	int	0x594
	int	0x29c
	int	0x394
	int	0x29e
	int	0x794
	int	0x2a2
	int	0x454
	int	0x2a6
	int	0x654
	int	0x2aa
	int	0x554
	int	0x2ac
	int	0x354
	int	0x2ae
	int	0x754
	int	0x2b2
	int	0x4d4
	int	0x2b4
	int	0x2d4
	int	0x2b6
	int	0x6d4
	int	0x2ba
	int	0x5d4
	int	0x2bc
	int	0x3d4
	int	0x2be
	int	0x7d4
	int	0x2c2
	int	0x434
	int	0x2c6
	int	0x634
	int	0x2ca
	int	0x534
	int	0x2cc
	int	0x334
	int	0x2ce
	int	0x734
	int	0x2d2
	int	0x4b4
	int	0x2d6
	int	0x6b4
	int	0x2da
	int	0x5b4
	int	0x2dc
	int	0x3b4
	int	0x2de
	int	0x7b4
	int	0x2e2
	int	0x474
	int	0x2e6
	int	0x674
	int	0x2ea
	int	0x574
	int	0x2ec
	int	0x374
	int	0x2ee
	int	0x774
	int	0x2f2
	int	0x4f4
	int	0x2f6
	int	0x6f4
	int	0x2fa
	int	0x5f4
	int	0x2fc
	int	0x3f4
	int	0x2fe
	int	0x7f4
	int	0x302
	int	0x40c
	int	0x306
	int	0x60c
	int	0x30a
	int	0x50c
	int	0x30e
	int	0x70c
	int	0x312
	int	0x48c
	int	0x316
	int	0x68c
	int	0x31a
	int	0x58c
	int	0x31c
	int	0x38c
	int	0x31e
	int	0x78c
	int	0x322
	int	0x44c
	int	0x326
	int	0x64c
	int	0x32a
	int	0x54c
	int	0x32c
	int	0x34c
	int	0x32e
	int	0x74c
	int	0x332
	int	0x4cc
	int	0x336
	int	0x6cc
	int	0x33a
	int	0x5cc
	int	0x33c
	int	0x3cc
	int	0x33e
	int	0x7cc
	int	0x342
	int	0x42c
	int	0x346
	int	0x62c
	int	0x34a
	int	0x52c
	int	0x34e
	int	0x72c
	int	0x352
	int	0x4ac
	int	0x356
	int	0x6ac
	int	0x35a
	int	0x5ac
	int	0x35c
	int	0x3ac
	int	0x35e
	int	0x7ac
	int	0x362
	int	0x46c
	int	0x366
	int	0x66c
	int	0x36a
	int	0x56c
	int	0x36e
	int	0x76c
	int	0x372
	int	0x4ec
	int	0x376
	int	0x6ec
	int	0x37a
	int	0x5ec
	int	0x37c
	int	0x3ec
	int	0x37e
	int	0x7ec
	int	0x382
	int	0x41c
	int	0x386
	int	0x61c
	int	0x38a
	int	0x51c
	int	0x38e
	int	0x71c
	int	0x392
	int	0x49c
	int	0x396
	int	0x69c
	int	0x39a
	int	0x59c
	int	0x39e
	int	0x79c
	int	0x3a2
	int	0x45c
	int	0x3a6
	int	0x65c
	int	0x3aa
	int	0x55c
	int	0x3ae
	int	0x75c
	int	0x3b2
	int	0x4dc
	int	0x3b6
	int	0x6dc
	int	0x3ba
	int	0x5dc
	int	0x3bc
	int	0x3dc
	int	0x3be
	int	0x7dc
	int	0x3c2
	int	0x43c
	int	0x3c6
	int	0x63c
	int	0x3ca
	int	0x53c
	int	0x3ce
	int	0x73c
	int	0x3d2
	int	0x4bc
	int	0x3d6
	int	0x6bc
	int	0x3da
	int	0x5bc
	int	0x3de
	int	0x7bc
	int	0x3e2
	int	0x47c
	int	0x3e6
	int	0x67c
	int	0x3ea
	int	0x57c
	int	0x3ee
	int	0x77c
	int	0x3f2
	int	0x4fc
	int	0x3f6
	int	0x6fc
	int	0x3fa
	int	0x5fc
	int	0x3fe
	int	0x7fc
	int	0x406
	int	0x602
	int	0x40a
	int	0x502
	int	0x40e
	int	0x702
	int	0x412
	int	0x482
	int	0x416
	int	0x682
	int	0x41a
	int	0x582
	int	0x41e
	int	0x782
	int	0x422
	int	0x442
	int	0x426
	int	0x642
	int	0x42a
	int	0x542
	int	0x42e
	int	0x742
	int	0x432
	int	0x4c2
	int	0x436
	int	0x6c2
	int	0x43a
	int	0x5c2
	int	0x43e
	int	0x7c2
	int	0x446
	int	0x622
	int	0x44a
	int	0x522
	int	0x44e
	int	0x722
	int	0x452
	int	0x4a2
	int	0x456
	int	0x6a2
	int	0x45a
	int	0x5a2
	int	0x45e
	int	0x7a2
	int	0x466
	int	0x662
	int	0x46a
	int	0x562
	int	0x46e
	int	0x762
	int	0x472
	int	0x4e2
	int	0x476
	int	0x6e2
	int	0x47a
	int	0x5e2
	int	0x47e
	int	0x7e2
	int	0x486
	int	0x612
	int	0x48a
	int	0x512
	int	0x48e
	int	0x712
	int	0x496
	int	0x692
	int	0x49a
	int	0x592
	int	0x49e
	int	0x792
	int	0x4a6
	int	0x652
	int	0x4aa
	int	0x552
	int	0x4ae
	int	0x752
	int	0x4b2
	int	0x4d2
	int	0x4b6
	int	0x6d2
	int	0x4ba
	int	0x5d2
	int	0x4be
	int	0x7d2
	int	0x4c6
	int	0x632
	int	0x4ca
	int	0x532
	int	0x4ce
	int	0x732
	int	0x4d6
	int	0x6b2
	int	0x4da
	int	0x5b2
	int	0x4de
	int	0x7b2
	int	0x4e6
	int	0x672
	int	0x4ea
	int	0x572
	int	0x4ee
	int	0x772
	int	0x4f6
	int	0x6f2
	int	0x4fa
	int	0x5f2
	int	0x4fe
	int	0x7f2
	int	0x506
	int	0x60a
	int	0x50e
	int	0x70a
	int	0x516
	int	0x68a
	int	0x51a
	int	0x58a
	int	0x51e
	int	0x78a
	int	0x526
	int	0x64a
	int	0x52a
	int	0x54a
	int	0x52e
	int	0x74a
	int	0x536
	int	0x6ca
	int	0x53a
	int	0x5ca
	int	0x53e
	int	0x7ca
	int	0x546
	int	0x62a
	int	0x54e
	int	0x72a
	int	0x556
	int	0x6aa
	int	0x55a
	int	0x5aa
	int	0x55e
	int	0x7aa
	int	0x566
	int	0x66a
	int	0x56e
	int	0x76a
	int	0x576
	int	0x6ea
	int	0x57a
	int	0x5ea
	int	0x57e
	int	0x7ea
	int	0x586
	int	0x61a
	int	0x58e
	int	0x71a
	int	0x596
	int	0x69a
	int	0x59e
	int	0x79a
	int	0x5a6
	int	0x65a
	int	0x5ae
	int	0x75a
	int	0x5b6
	int	0x6da
	int	0x5ba
	int	0x5da
	int	0x5be
	int	0x7da
	int	0x5c6
	int	0x63a
	int	0x5ce
	int	0x73a
	int	0x5d6
	int	0x6ba
	int	0x5de
	int	0x7ba
	int	0x5e6
	int	0x67a
	int	0x5ee
	int	0x77a
	int	0x5f6
	int	0x6fa
	int	0x5fe
	int	0x7fa
	int	0x60e
	int	0x706
	int	0x616
	int	0x686
	int	0x61e
	int	0x786
	int	0x626
	int	0x646
	int	0x62e
	int	0x746
	int	0x636
	int	0x6c6
	int	0x63e
	int	0x7c6
	int	0x64e
	int	0x726
	int	0x656
	int	0x6a6
	int	0x65e
	int	0x7a6
	int	0x66e
	int	0x766
	int	0x676
	int	0x6e6
	int	0x67e
	int	0x7e6
	int	0x68e
	int	0x716
	int	0x69e
	int	0x796
	int	0x6ae
	int	0x756
	int	0x6b6
	int	0x6d6
	int	0x6be
	int	0x7d6
	int	0x6ce
	int	0x736
	int	0x6de
	int	0x7b6
	int	0x6ee
	int	0x776
	int	0x6fe
	int	0x7f6
	int	0x71e
	int	0x78e
	int	0x72e
	int	0x74e
	int	0x73e
	int	0x7ce
	int	0x75e
	int	0x7ae
	int	0x77e
	int	0x7ee
	int	0x7be
endprm:	int	0x7de

.ram
A:	2048*int
.endram

