/* AT&T DSP16, 256 point FFT          jkf  Oct 14, 1988 */
/*							*/
/* This is a 256-point fft program with                 */
/*  dynamic scaling for each butterfly process.		*/
/* The input data is <real0>,<imag0>;<real1>,<imag1>;   */
/*  .... with the start address in A, and the amplitude	*/
/*  of input data (Q14) will be limited in (-2.0, 2.0).	*/
/* After running this program, the input data will by	*/
/*  replaced by the output values.			*/
/* This program uses 1835 words of ROM and 512 words	*/
/*  of RAM.						*/
/* The execution time is 23695 instruction cycles.	*/
/* June 1, 1988						*/

start:	auc=0x2
	i=-1

/* un-comment following line to include input		*/
/* from parallel port (routine follows label "stop.")	*/
/*	call 256io	*/

level0:	r0=0x0
	r1=0x100
	r2=0xff
	pt=W0
	a0=*r0++		/* a0=A(0)r		*/
	a1=*r2			/* a1=A(n/2-1)i		*/
	x=*pt++ y=*r1++		/* x=Ur; y=A(n/2)r	*/
	do 64 {
	p=x*y x=*pt++i y=*r1--	/* p=Ur*A(k+n/2)r, x=Ui, y=A(k+n/2)i	*/
	a1=a0-p *r2++=a1	/* a1=A(k)r-Ur*A(k+n/2)r	*/
	a0=a0+p	p=x*y		/* a0=A(k)r+Ur*A(k+n/2)r,p=Ui*A(k+n/2)i	*/
	a0=a0-p y=*r1++		/* a0=A(k)r+Ur*A(k+n/2)r-Ui*A(k+n/2)i	*/
	a0=a0>>1		/* a0=a0/2, y=A(k+n/2)r		*/
	a1=a1+p p=x*y *r0m2:a0	/* a1=A(k)r-Ur*A(k+n/2)r+Ui*A(k+n/2)i	*/
	x=*pt++ y=*r1++		/* p=Ui*A(k+n/2)r,x=Ur,y=A(k+n/2)i	*/
	a1=a1>>1		/* a1=a1/2, x=Ur, y=A(k+n/2)i	*/
	a1=a0-p *r2++=a1	/* a1=A(k)i-Ui*A(k+n/2)r	*/
	a0=a0+p p=x*y		/* a0=A(k)i+Ui*A(k+n/2)r,p=Ur*A(k+n/2)i	*/
	a0=a0+p y=*r1++		/* a0=A(k)i+Ui*A(k+n/2)r+Ur*A(k+n/2)i	*/
	a0=a0>>1		/* a0=a0/2, y=A(k+1+n/2)r	*/
	a1=a1-p *r0m2:a0 	/* a1=A(k)i-Ui*A(k+n/2)r-Ur*A(k+n/2)i	*/
	a1=a1>>1		/* a1=a1/2, x=Ur		*/
	}
	redo 64
	*r2=a1

level1:	r0=0x0
	r1=128
	r2=127
	pt=W0
	a0=*r0++		/* a0=A(0)r		*/
	a1=*r2			/* a1=A(n/2-1)i		*/
	x=*pt++ y=*r1++		/* x=Ur; y=A(n/2)r	*/
	redo 64
	*r2=a1
	r0=256
	r1=384
	r2=383
	pt=W64
	a0=*r0++		/* a0=A(0)r		*/
	a1=*r2			/* a1=A(n/2-1)i		*/
	x=*pt++ y=*r1++		/* x=Ur; y=A(n/2)r	*/
	redo 64
	*r2=a1

level2:	r0=0x0
	r1=64
	r2=63
	pt=W0
	a0=*r0++		/* a0=A(0)r		*/
	a1=*r2			/* a1=A(n/2-1)i		*/
	x=*pt++ y=*r1++		/* x=Ur; y=A(n/2)r	*/
	redo 32
	*r2=a1
	r0=128
	r1=192
	r2=191
	pt=W64
	a0=*r0++		/* a0=A(0)r		*/
	a1=*r2			/* a1=A(n/2-1)i		*/
	x=*pt++ y=*r1++		/* x=Ur; y=A(n/2)r	*/
	redo 32
	*r2=a1
	r0=256
	r1=320
	r2=319
	pt=W32
	a0=*r0++		/* a0=A(0)r		*/
	a1=*r2			/* a1=A(n/2-1)i		*/
	x=*pt++ y=*r1++		/* x=Ur; y=A(n/2)r	*/
	redo 32
	*r2=a1
	r0=384
	r1=448
	r2=447
	pt=W96
	a0=*r0++		/* a0=A(0)r		*/
	a1=*r2			/* a1=A(n/2-1)i		*/
	x=*pt++ y=*r1++		/* x=Ur; y=A(n/2)r	*/
	redo 32
	*r2=a1

level3:	r0=0x0
	r1=32
	r2=31
	pt=W0
	a0=*r0++		/* a0=A(0)r		*/
	a1=*r2			/* a1=A(n/2-1)i		*/
	x=*pt++ y=*r1++		/* x=Ur; y=A(n/2)r	*/
	redo 16
	*r2=a1
	r0=64
	r1=96
	r2=95
	pt=W64
	a0=*r0++		/* a0=A(0)r		*/
	a1=*r2			/* a1=A(n/2-1)i		*/
	x=*pt++ y=*r1++		/* x=Ur; y=A(n/2)r	*/
	redo 16
	*r2=a1
	r0=128
	r1=160
	r2=159
	pt=W32
	a0=*r0++		/* a0=A(0)r		*/
	a1=*r2			/* a1=A(n/2-1)i		*/
	x=*pt++ y=*r1++		/* x=Ur; y=A(n/2)r	*/
	redo 16
	*r2=a1
	r0=192
	r1=224
	r2=223
	pt=W96
	a0=*r0++		/* a0=A(0)r		*/
	a1=*r2			/* a1=A(n/2-1)i		*/
	x=*pt++ y=*r1++		/* x=Ur; y=A(n/2)r	*/
	redo 16
	*r2=a1
	r0=256
	r1=288
	r2=287
	pt=W16
	a0=*r0++		/* a0=A(0)r		*/
	a1=*r2			/* a1=A(n/2-1)i		*/
	x=*pt++ y=*r1++		/* x=Ur; y=A(n/2)r	*/
	redo 16
	*r2=a1
	r0=320
	r1=352
	r2=351
	pt=W80
	a0=*r0++		/* a0=A(0)r		*/
	a1=*r2			/* a1=A(n/2-1)i		*/
	x=*pt++ y=*r1++		/* x=Ur; y=A(n/2)r	*/
	redo 16
	*r2=a1
	r0=384
	r1=416
	r2=415
	pt=W48
	a0=*r0++		/* a0=A(0)r		*/
	a1=*r2			/* a1=A(n/2-1)i		*/
	x=*pt++ y=*r1++		/* x=Ur; y=A(n/2)r	*/
	redo 16
	*r2=a1
	r0=448
	r1=480
	r2=479
	pt=W112
	a0=*r0++		/* a0=A(0)r		*/
	a1=*r2			/* a1=A(n/2-1)i		*/
	x=*pt++ y=*r1++		/* x=Ur; y=A(n/2)r	*/
	redo 16
	*r2=a1

level4:	r0=0x0
	r1=16
	r2=15
	pt=W0
	a0=*r0++		/* a0=A(0)r		*/
	a1=*r2			/* a1=A(n/2-1)i		*/
	x=*pt++ y=*r1++		/* x=Ur; y=A(n/2)r	*/
	redo 8
	*r2=a1
	r0=32
	r1=48
	r2=47
	pt=W64
	a0=*r0++		/* a0=A(0)r		*/
	a1=*r2			/* a1=A(n/2-1)i		*/
	x=*pt++ y=*r1++		/* x=Ur; y=A(n/2)r	*/
	redo 8
	*r2=a1
	r0=64
	r1=80
	r2=79
	pt=W32
	a0=*r0++		/* a0=A(0)r		*/
	a1=*r2			/* a1=A(n/2-1)i		*/
	x=*pt++ y=*r1++		/* x=Ur; y=A(n/2)r	*/
	redo 8
	*r2=a1
	r0=96
	r1=112
	r2=111
	pt=W96
	a0=*r0++		/* a0=A(0)r		*/
	a1=*r2			/* a1=A(n/2-1)i		*/
	x=*pt++ y=*r1++		/* x=Ur; y=A(n/2)r	*/
	redo 8
	*r2=a1
	r0=128
	r1=144
	r2=143
	pt=W16
	a0=*r0++		/* a0=A(0)r		*/
	a1=*r2			/* a1=A(n/2-1)i		*/
	x=*pt++ y=*r1++		/* x=Ur; y=A(n/2)r	*/
	redo 8
	*r2=a1
	r0=160
	r1=176
	r2=175
	pt=W80
	a0=*r0++		/* a0=A(0)r		*/
	a1=*r2			/* a1=A(n/2-1)i		*/
	x=*pt++ y=*r1++		/* x=Ur; y=A(n/2)r	*/
	redo 8
	*r2=a1
	r0=192
	r1=208
	r2=207
	pt=W48
	a0=*r0++		/* a0=A(0)r		*/
	a1=*r2			/* a1=A(n/2-1)i		*/
	x=*pt++ y=*r1++		/* x=Ur; y=A(n/2)r	*/
	redo 8
	*r2=a1
	r0=224
	r1=240
	r2=239
	pt=W112
	a0=*r0++		/* a0=A(0)r		*/
	a1=*r2			/* a1=A(n/2-1)i		*/
	x=*pt++ y=*r1++		/* x=Ur; y=A(n/2)r	*/
	redo 8
	*r2=a1
	r0=256
	r1=272
	r2=271
	pt=W8
	a0=*r0++		/* a0=A(0)r		*/
	a1=*r2			/* a1=A(n/2-1)i		*/
	x=*pt++ y=*r1++		/* x=Ur; y=A(n/2)r	*/
	redo 8
	*r2=a1
	r0=288
	r1=304
	r2=303
	pt=W72
	a0=*r0++		/* a0=A(0)r		*/
	a1=*r2			/* a1=A(n/2-1)i		*/
	x=*pt++ y=*r1++		/* x=Ur; y=A(n/2)r	*/
	redo 8
	*r2=a1
	r0=320
	r1=336
	r2=335
	pt=W40
	a0=*r0++		/* a0=A(0)r		*/
	a1=*r2			/* a1=A(n/2-1)i		*/
	x=*pt++ y=*r1++		/* x=Ur; y=A(n/2)r	*/
	redo 8
	*r2=a1
	r0=352
	r1=368
	r2=367
	pt=W104
	a0=*r0++		/* a0=A(0)r		*/
	a1=*r2			/* a1=A(n/2-1)i		*/
	x=*pt++ y=*r1++		/* x=Ur; y=A(n/2)r	*/
	redo 8
	*r2=a1
	r0=384
	r1=400
	r2=399
	pt=W24
	a0=*r0++		/* a0=A(0)r		*/
	a1=*r2			/* a1=A(n/2-1)i		*/
	x=*pt++ y=*r1++		/* x=Ur; y=A(n/2)r	*/
	redo 8
	*r2=a1
	r0=416
	r1=432
	r2=431
	pt=W88
	a0=*r0++		/* a0=A(0)r		*/
	a1=*r2			/* a1=A(n/2-1)i		*/
	x=*pt++ y=*r1++		/* x=Ur; y=A(n/2)r	*/
	redo 8
	*r2=a1
	r0=448
	r1=464
	r2=463
	pt=W56
	a0=*r0++		/* a0=A(0)r		*/
	a1=*r2			/* a1=A(n/2-1)i		*/
	x=*pt++ y=*r1++		/* x=Ur; y=A(n/2)r	*/
	redo 8
	*r2=a1
	r0=480
	r1=496
	r2=495
	pt=W120
	a0=*r0++		/* a0=A(0)r		*/
	a1=*r2			/* a1=A(n/2-1)i		*/
	x=*pt++ y=*r1++		/* x=Ur; y=A(n/2)r	*/
	redo 8
	*r2=a1

level5:	r0=0x0
	r1=8
	r2=7
	pt=W0
	a0=*r0++		/* a0=A(0)r		*/
	a1=*r2			/* a1=A(n/2-1)i		*/
	x=*pt++ y=*r1++		/* x=Ur; y=A(n/2)r	*/
	redo 4
	*r2=a1
	r0=16
	r1=24
	r2=23
	pt=W64
	a0=*r0++		/* a0=A(0)r		*/
	a1=*r2			/* a1=A(n/2-1)i		*/
	x=*pt++ y=*r1++		/* x=Ur; y=A(n/2)r	*/
	redo 4
	*r2=a1
	r0=32
	r1=40
	r2=39
	pt=W32
	a0=*r0++		/* a0=A(0)r		*/
	a1=*r2			/* a1=A(n/2-1)i		*/
	x=*pt++ y=*r1++		/* x=Ur; y=A(n/2)r	*/
	redo 4
	*r2=a1
	r0=48
	r1=56
	r2=55
	pt=W96
	a0=*r0++		/* a0=A(0)r		*/
	a1=*r2			/* a1=A(n/2-1)i		*/
	x=*pt++ y=*r1++		/* x=Ur; y=A(n/2)r	*/
	redo 4
	*r2=a1
	r0=64
	r1=72
	r2=71
	pt=W16
	a0=*r0++		/* a0=A(0)r		*/
	a1=*r2			/* a1=A(n/2-1)i		*/
	x=*pt++ y=*r1++		/* x=Ur; y=A(n/2)r	*/
	redo 4
	*r2=a1
	r0=80
	r1=88
	r2=87
	pt=W80
	a0=*r0++		/* a0=A(0)r		*/
	a1=*r2			/* a1=A(n/2-1)i		*/
	x=*pt++ y=*r1++		/* x=Ur; y=A(n/2)r	*/
	redo 4
	*r2=a1
	r0=96
	r1=104
	r2=103
	pt=W48
	a0=*r0++		/* a0=A(0)r		*/
	a1=*r2			/* a1=A(n/2-1)i		*/
	x=*pt++ y=*r1++		/* x=Ur; y=A(n/2)r	*/
	redo 4
	*r2=a1
	r0=112
	r1=120
	r2=119
	pt=W112
	a0=*r0++		/* a0=A(0)r		*/
	a1=*r2			/* a1=A(n/2-1)i		*/
	x=*pt++ y=*r1++		/* x=Ur; y=A(n/2)r	*/
	redo 4
	*r2=a1
	r0=128
	r1=136
	r2=135
	pt=W8
	a0=*r0++		/* a0=A(0)r		*/
	a1=*r2			/* a1=A(n/2-1)i		*/
	x=*pt++ y=*r1++		/* x=Ur; y=A(n/2)r	*/
	redo 4
	*r2=a1
	r0=144
	r1=152
	r2=151
	pt=W72
	a0=*r0++		/* a0=A(0)r		*/
	a1=*r2			/* a1=A(n/2-1)i		*/
	x=*pt++ y=*r1++		/* x=Ur; y=A(n/2)r	*/
	redo 4
	*r2=a1
	r0=160
	r1=168
	r2=167
	pt=W40
	a0=*r0++		/* a0=A(0)r		*/
	a1=*r2			/* a1=A(n/2-1)i		*/
	x=*pt++ y=*r1++		/* x=Ur; y=A(n/2)r	*/
	redo 4
	*r2=a1
	r0=176
	r1=184
	r2=183
	pt=W104
	a0=*r0++		/* a0=A(0)r		*/
	a1=*r2			/* a1=A(n/2-1)i		*/
	x=*pt++ y=*r1++		/* x=Ur; y=A(n/2)r	*/
	redo 4
	*r2=a1
	r0=192
	r1=200
	r2=199
	pt=W24
	a0=*r0++		/* a0=A(0)r		*/
	a1=*r2			/* a1=A(n/2-1)i		*/
	x=*pt++ y=*r1++		/* x=Ur; y=A(n/2)r	*/
	redo 4
	*r2=a1
	r0=208
	r1=216
	r2=215
	pt=W88
	a0=*r0++		/* a0=A(0)r		*/
	a1=*r2			/* a1=A(n/2-1)i		*/
	x=*pt++ y=*r1++		/* x=Ur; y=A(n/2)r	*/
	redo 4
	*r2=a1
	r0=224
	r1=232
	r2=231
	pt=W56
	a0=*r0++		/* a0=A(0)r		*/
	a1=*r2			/* a1=A(n/2-1)i		*/
	x=*pt++ y=*r1++		/* x=Ur; y=A(n/2)r	*/
	redo 4
	*r2=a1
	r0=240
	r1=248
	r2=247
	pt=W120
	a0=*r0++		/* a0=A(0)r		*/
	a1=*r2			/* a1=A(n/2-1)i		*/
	x=*pt++ y=*r1++		/* x=Ur; y=A(n/2)r	*/
	redo 4
	*r2=a1
	r0=256
	r1=264
	r2=263
	pt=W4
	a0=*r0++		/* a0=A(0)r		*/
	a1=*r2			/* a1=A(n/2-1)i		*/
	x=*pt++ y=*r1++		/* x=Ur; y=A(n/2)r	*/
	redo 4
	*r2=a1
	r0=272
	r1=280
	r2=279
	pt=W68
	a0=*r0++		/* a0=A(0)r		*/
	a1=*r2			/* a1=A(n/2-1)i		*/
	x=*pt++ y=*r1++		/* x=Ur; y=A(n/2)r	*/
	redo 4
	*r2=a1
	r0=288
	r1=296
	r2=295
	pt=W36
	a0=*r0++		/* a0=A(0)r		*/
	a1=*r2			/* a1=A(n/2-1)i		*/
	x=*pt++ y=*r1++		/* x=Ur; y=A(n/2)r	*/
	redo 4
	*r2=a1
	r0=304
	r1=312
	r2=311
	pt=W100
	a0=*r0++		/* a0=A(0)r		*/
	a1=*r2			/* a1=A(n/2-1)i		*/
	x=*pt++ y=*r1++		/* x=Ur; y=A(n/2)r	*/
	redo 4
	*r2=a1
	r0=320
	r1=328
	r2=327
	pt=W20
	a0=*r0++		/* a0=A(0)r		*/
	a1=*r2			/* a1=A(n/2-1)i		*/
	x=*pt++ y=*r1++		/* x=Ur; y=A(n/2)r	*/
	redo 4
	*r2=a1
	r0=336
	r1=344
	r2=343
	pt=W84
	a0=*r0++		/* a0=A(0)r		*/
	a1=*r2			/* a1=A(n/2-1)i		*/
	x=*pt++ y=*r1++		/* x=Ur; y=A(n/2)r	*/
	redo 4
	*r2=a1
	r0=352
	r1=360
	r2=359
	pt=W52
	a0=*r0++		/* a0=A(0)r		*/
	a1=*r2			/* a1=A(n/2-1)i		*/
	x=*pt++ y=*r1++		/* x=Ur; y=A(n/2)r	*/
	redo 4
	*r2=a1
	r0=368
	r1=376
	r2=375
	pt=W116
	a0=*r0++		/* a0=A(0)r		*/
	a1=*r2			/* a1=A(n/2-1)i		*/
	x=*pt++ y=*r1++		/* x=Ur; y=A(n/2)r	*/
	redo 4
	*r2=a1
	r0=384
	r1=392
	r2=391
	pt=W12
	a0=*r0++		/* a0=A(0)r		*/
	a1=*r2			/* a1=A(n/2-1)i		*/
	x=*pt++ y=*r1++		/* x=Ur; y=A(n/2)r	*/
	redo 4
	*r2=a1
	r0=400
	r1=408
	r2=407
	pt=W76
	a0=*r0++		/* a0=A(0)r		*/
	a1=*r2			/* a1=A(n/2-1)i		*/
	x=*pt++ y=*r1++		/* x=Ur; y=A(n/2)r	*/
	redo 4
	*r2=a1
	r0=416
	r1=424
	r2=423
	pt=W44
	a0=*r0++		/* a0=A(0)r		*/
	a1=*r2			/* a1=A(n/2-1)i		*/
	x=*pt++ y=*r1++		/* x=Ur; y=A(n/2)r	*/
	redo 4
	*r2=a1
	r0=432
	r1=440
	r2=439
	pt=W108
	a0=*r0++		/* a0=A(0)r		*/
	a1=*r2			/* a1=A(n/2-1)i		*/
	x=*pt++ y=*r1++		/* x=Ur; y=A(n/2)r	*/
	redo 4
	*r2=a1
	r0=448
	r1=456
	r2=455
	pt=W28
	a0=*r0++		/* a0=A(0)r		*/
	a1=*r2			/* a1=A(n/2-1)i		*/
	x=*pt++ y=*r1++		/* x=Ur; y=A(n/2)r	*/
	redo 4
	*r2=a1
	r0=464
	r1=472
	r2=471
	pt=W92
	a0=*r0++		/* a0=A(0)r		*/
	a1=*r2			/* a1=A(n/2-1)i		*/
	x=*pt++ y=*r1++		/* x=Ur; y=A(n/2)r	*/
	redo 4
	*r2=a1
	r0=480
	r1=488
	r2=487
	pt=W60
	a0=*r0++		/* a0=A(0)r		*/
	a1=*r2			/* a1=A(n/2-1)i		*/
	x=*pt++ y=*r1++		/* x=Ur; y=A(n/2)r	*/
	redo 4
	*r2=a1
	r0=496
	r1=504
	r2=503
	pt=W124
	a0=*r0++		/* a0=A(0)r		*/
	a1=*r2			/* a1=A(n/2-1)i		*/
	x=*pt++ y=*r1++		/* x=Ur; y=A(n/2)r	*/
	redo 4
	*r2=a1

level6:	r0=0x0
	r1=4
	r2=3
	pt=W0
	a0=*r0++		/* a0=A(0)r		*/
	a1=*r2			/* a1=A(n/2-1)i		*/
	x=*pt++ y=*r1++		/* x=Ur; y=A(n/2)r	*/
	redo 2
	*r2=a1
	r0=8
	r1=12
	r2=11
	pt=W64
	a0=*r0++		/* a0=A(0)r		*/
	a1=*r2			/* a1=A(n/2-1)i		*/
	x=*pt++ y=*r1++		/* x=Ur; y=A(n/2)r	*/
	redo 2
	*r2=a1
	r0=16
	r1=20
	r2=19
	pt=W32
	a0=*r0++		/* a0=A(0)r		*/
	a1=*r2			/* a1=A(n/2-1)i		*/
	x=*pt++ y=*r1++		/* x=Ur; y=A(n/2)r	*/
	redo 2
	*r2=a1
	r0=24
	r1=28
	r2=27
	pt=W96
	a0=*r0++		/* a0=A(0)r		*/
	a1=*r2			/* a1=A(n/2-1)i		*/
	x=*pt++ y=*r1++		/* x=Ur; y=A(n/2)r	*/
	redo 2
	*r2=a1
	r0=32
	r1=36
	r2=35
	pt=W16
	a0=*r0++		/* a0=A(0)r		*/
	a1=*r2			/* a1=A(n/2-1)i		*/
	x=*pt++ y=*r1++		/* x=Ur; y=A(n/2)r	*/
	redo 2
	*r2=a1
	r0=40
	r1=44
	r2=43
	pt=W80
	a0=*r0++		/* a0=A(0)r		*/
	a1=*r2			/* a1=A(n/2-1)i		*/
	x=*pt++ y=*r1++		/* x=Ur; y=A(n/2)r	*/
	redo 2
	*r2=a1
	r0=48
	r1=52
	r2=51
	pt=W48
	a0=*r0++		/* a0=A(0)r		*/
	a1=*r2			/* a1=A(n/2-1)i		*/
	x=*pt++ y=*r1++		/* x=Ur; y=A(n/2)r	*/
	redo 2
	*r2=a1
	r0=56
	r1=60
	r2=59
	pt=W112
	a0=*r0++		/* a0=A(0)r		*/
	a1=*r2			/* a1=A(n/2-1)i		*/
	x=*pt++ y=*r1++		/* x=Ur; y=A(n/2)r	*/
	redo 2
	*r2=a1
	r0=64
	r1=68
	r2=67
	pt=W8
	a0=*r0++		/* a0=A(0)r		*/
	a1=*r2			/* a1=A(n/2-1)i		*/
	x=*pt++ y=*r1++		/* x=Ur; y=A(n/2)r	*/
	redo 2
	*r2=a1
	r0=72
	r1=76
	r2=75
	pt=W72
	a0=*r0++		/* a0=A(0)r		*/
	a1=*r2			/* a1=A(n/2-1)i		*/
	x=*pt++ y=*r1++		/* x=Ur; y=A(n/2)r	*/
	redo 2
	*r2=a1
	r0=80
	r1=84
	r2=83
	pt=W40
	a0=*r0++		/* a0=A(0)r		*/
	a1=*r2			/* a1=A(n/2-1)i		*/
	x=*pt++ y=*r1++		/* x=Ur; y=A(n/2)r	*/
	redo 2
	*r2=a1
	r0=88
	r1=92
	r2=91
	pt=W104
	a0=*r0++		/* a0=A(0)r		*/
	a1=*r2			/* a1=A(n/2-1)i		*/
	x=*pt++ y=*r1++		/* x=Ur; y=A(n/2)r	*/
	redo 2
	*r2=a1
	r0=96
	r1=100
	r2=99
	pt=W24
	a0=*r0++		/* a0=A(0)r		*/
	a1=*r2			/* a1=A(n/2-1)i		*/
	x=*pt++ y=*r1++		/* x=Ur; y=A(n/2)r	*/
	redo 2
	*r2=a1
	r0=104
	r1=108
	r2=107
	pt=W88
	a0=*r0++		/* a0=A(0)r		*/
	a1=*r2			/* a1=A(n/2-1)i		*/
	x=*pt++ y=*r1++		/* x=Ur; y=A(n/2)r	*/
	redo 2
	*r2=a1
	r0=112
	r1=116
	r2=115
	pt=W56
	a0=*r0++		/* a0=A(0)r		*/
	a1=*r2			/* a1=A(n/2-1)i		*/
	x=*pt++ y=*r1++		/* x=Ur; y=A(n/2)r	*/
	redo 2
	*r2=a1
	r0=120
	r1=124
	r2=123
	pt=W120
	a0=*r0++		/* a0=A(0)r		*/
	a1=*r2			/* a1=A(n/2-1)i		*/
	x=*pt++ y=*r1++		/* x=Ur; y=A(n/2)r	*/
	redo 2
	*r2=a1
	r0=128
	r1=132
	r2=131
	pt=W4
	a0=*r0++		/* a0=A(0)r		*/
	a1=*r2			/* a1=A(n/2-1)i		*/
	x=*pt++ y=*r1++		/* x=Ur; y=A(n/2)r	*/
	redo 2
	*r2=a1
	r0=136
	r1=140
	r2=139
	pt=W68
	a0=*r0++		/* a0=A(0)r		*/
	a1=*r2			/* a1=A(n/2-1)i		*/
	x=*pt++ y=*r1++		/* x=Ur; y=A(n/2)r	*/
	redo 2
	*r2=a1
	r0=144
	r1=148
	r2=147
	pt=W36
	a0=*r0++		/* a0=A(0)r		*/
	a1=*r2			/* a1=A(n/2-1)i		*/
	x=*pt++ y=*r1++		/* x=Ur; y=A(n/2)r	*/
	redo 2
	*r2=a1
	r0=152
	r1=156
	r2=155
	pt=W100
	a0=*r0++		/* a0=A(0)r		*/
	a1=*r2			/* a1=A(n/2-1)i		*/
	x=*pt++ y=*r1++		/* x=Ur; y=A(n/2)r	*/
	redo 2
	*r2=a1
	r0=160
	r1=164
	r2=163
	pt=W20
	a0=*r0++		/* a0=A(0)r		*/
	a1=*r2			/* a1=A(n/2-1)i		*/
	x=*pt++ y=*r1++		/* x=Ur; y=A(n/2)r	*/
	redo 2
	*r2=a1
	r0=168
	r1=172
	r2=171
	pt=W84
	a0=*r0++		/* a0=A(0)r		*/
	a1=*r2			/* a1=A(n/2-1)i		*/
	x=*pt++ y=*r1++		/* x=Ur; y=A(n/2)r	*/
	redo 2
	*r2=a1
	r0=176
	r1=180
	r2=179
	pt=W52
	a0=*r0++		/* a0=A(0)r		*/
	a1=*r2			/* a1=A(n/2-1)i		*/
	x=*pt++ y=*r1++		/* x=Ur; y=A(n/2)r	*/
	redo 2
	*r2=a1
	r0=184
	r1=188
	r2=187
	pt=W116
	a0=*r0++		/* a0=A(0)r		*/
	a1=*r2			/* a1=A(n/2-1)i		*/
	x=*pt++ y=*r1++		/* x=Ur; y=A(n/2)r	*/
	redo 2
	*r2=a1
	r0=192
	r1=196
	r2=195
	pt=W12
	a0=*r0++		/* a0=A(0)r		*/
	a1=*r2			/* a1=A(n/2-1)i		*/
	x=*pt++ y=*r1++		/* x=Ur; y=A(n/2)r	*/
	redo 2
	*r2=a1
	r0=200
	r1=204
	r2=203
	pt=W76
	a0=*r0++		/* a0=A(0)r		*/
	a1=*r2			/* a1=A(n/2-1)i		*/
	x=*pt++ y=*r1++		/* x=Ur; y=A(n/2)r	*/
	redo 2
	*r2=a1
	r0=208
	r1=212
	r2=211
	pt=W44
	a0=*r0++		/* a0=A(0)r		*/
	a1=*r2			/* a1=A(n/2-1)i		*/
	x=*pt++ y=*r1++		/* x=Ur; y=A(n/2)r	*/
	redo 2
	*r2=a1
	r0=216
	r1=220
	r2=219
	pt=W108
	a0=*r0++		/* a0=A(0)r		*/
	a1=*r2			/* a1=A(n/2-1)i		*/
	x=*pt++ y=*r1++		/* x=Ur; y=A(n/2)r	*/
	redo 2
	*r2=a1
	r0=224
	r1=228
	r2=227
	pt=W28
	a0=*r0++		/* a0=A(0)r		*/
	a1=*r2			/* a1=A(n/2-1)i		*/
	x=*pt++ y=*r1++		/* x=Ur; y=A(n/2)r	*/
	redo 2
	*r2=a1
	r0=232
	r1=236
	r2=235
	pt=W92
	a0=*r0++		/* a0=A(0)r		*/
	a1=*r2			/* a1=A(n/2-1)i		*/
	x=*pt++ y=*r1++		/* x=Ur; y=A(n/2)r	*/
	redo 2
	*r2=a1
	r0=240
	r1=244
	r2=243
	pt=W60
	a0=*r0++		/* a0=A(0)r		*/
	a1=*r2			/* a1=A(n/2-1)i		*/
	x=*pt++ y=*r1++		/* x=Ur; y=A(n/2)r	*/
	redo 2
	*r2=a1
	r0=248
	r1=252
	r2=251
	pt=W124
	a0=*r0++		/* a0=A(0)r		*/
	a1=*r2			/* a1=A(n/2-1)i		*/
	x=*pt++ y=*r1++		/* x=Ur; y=A(n/2)r	*/
	redo 2
	*r2=a1
	r0=256
	r1=260
	r2=259
	pt=W2
	a0=*r0++		/* a0=A(0)r		*/
	a1=*r2			/* a1=A(n/2-1)i		*/
	x=*pt++ y=*r1++		/* x=Ur; y=A(n/2)r	*/
	redo 2
	*r2=a1
	r0=264
	r1=268
	r2=267
	pt=W66
	a0=*r0++		/* a0=A(0)r		*/
	a1=*r2			/* a1=A(n/2-1)i		*/
	x=*pt++ y=*r1++		/* x=Ur; y=A(n/2)r	*/
	redo 2
	*r2=a1
	r0=272
	r1=276
	r2=275
	pt=W34
	a0=*r0++		/* a0=A(0)r		*/
	a1=*r2			/* a1=A(n/2-1)i		*/
	x=*pt++ y=*r1++		/* x=Ur; y=A(n/2)r	*/
	redo 2
	*r2=a1
	r0=280
	r1=284
	r2=283
	pt=W98
	a0=*r0++		/* a0=A(0)r		*/
	a1=*r2			/* a1=A(n/2-1)i		*/
	x=*pt++ y=*r1++		/* x=Ur; y=A(n/2)r	*/
	redo 2
	*r2=a1
	r0=288
	r1=292
	r2=291
	pt=W18
	a0=*r0++		/* a0=A(0)r		*/
	a1=*r2			/* a1=A(n/2-1)i		*/
	x=*pt++ y=*r1++		/* x=Ur; y=A(n/2)r	*/
	redo 2
	*r2=a1
	r0=296
	r1=300
	r2=299
	pt=W82
	a0=*r0++		/* a0=A(0)r		*/
	a1=*r2			/* a1=A(n/2-1)i		*/
	x=*pt++ y=*r1++		/* x=Ur; y=A(n/2)r	*/
	redo 2
	*r2=a1
	r0=304
	r1=308
	r2=307
	pt=W50
	a0=*r0++		/* a0=A(0)r		*/
	a1=*r2			/* a1=A(n/2-1)i		*/
	x=*pt++ y=*r1++		/* x=Ur; y=A(n/2)r	*/
	redo 2
	*r2=a1
	r0=312
	r1=316
	r2=315
	pt=W114
	a0=*r0++		/* a0=A(0)r		*/
	a1=*r2			/* a1=A(n/2-1)i		*/
	x=*pt++ y=*r1++		/* x=Ur; y=A(n/2)r	*/
	redo 2
	*r2=a1
	r0=320
	r1=324
	r2=323
	pt=W10
	a0=*r0++		/* a0=A(0)r		*/
	a1=*r2			/* a1=A(n/2-1)i		*/
	x=*pt++ y=*r1++		/* x=Ur; y=A(n/2)r	*/
	redo 2
	*r2=a1
	r0=328
	r1=332
	r2=331
	pt=W74
	a0=*r0++		/* a0=A(0)r		*/
	a1=*r2			/* a1=A(n/2-1)i		*/
	x=*pt++ y=*r1++		/* x=Ur; y=A(n/2)r	*/
	redo 2
	*r2=a1
	r0=336
	r1=340
	r2=339
	pt=W42
	a0=*r0++		/* a0=A(0)r		*/
	a1=*r2			/* a1=A(n/2-1)i		*/
	x=*pt++ y=*r1++		/* x=Ur; y=A(n/2)r	*/
	redo 2
	*r2=a1
	r0=344
	r1=348
	r2=347
	pt=W106
	a0=*r0++		/* a0=A(0)r		*/
	a1=*r2			/* a1=A(n/2-1)i		*/
	x=*pt++ y=*r1++		/* x=Ur; y=A(n/2)r	*/
	redo 2
	*r2=a1
	r0=352
	r1=356
	r2=355
	pt=W26
	a0=*r0++		/* a0=A(0)r		*/
	a1=*r2			/* a1=A(n/2-1)i		*/
	x=*pt++ y=*r1++		/* x=Ur; y=A(n/2)r	*/
	redo 2
	*r2=a1
	r0=360
	r1=364
	r2=363
	pt=W90
	a0=*r0++		/* a0=A(0)r		*/
	a1=*r2			/* a1=A(n/2-1)i		*/
	x=*pt++ y=*r1++		/* x=Ur; y=A(n/2)r	*/
	redo 2
	*r2=a1
	r0=368
	r1=372
	r2=371
	pt=W58
	a0=*r0++		/* a0=A(0)r		*/
	a1=*r2			/* a1=A(n/2-1)i		*/
	x=*pt++ y=*r1++		/* x=Ur; y=A(n/2)r	*/
	redo 2
	*r2=a1
	r0=376
	r1=380
	r2=379
	pt=W122
	a0=*r0++		/* a0=A(0)r		*/
	a1=*r2			/* a1=A(n/2-1)i		*/
	x=*pt++ y=*r1++		/* x=Ur; y=A(n/2)r	*/
	redo 2
	*r2=a1
	r0=384
	r1=388
	r2=387
	pt=W6
	a0=*r0++		/* a0=A(0)r		*/
	a1=*r2			/* a1=A(n/2-1)i		*/
	x=*pt++ y=*r1++		/* x=Ur; y=A(n/2)r	*/
	redo 2
	*r2=a1
	r0=392
	r1=396
	r2=395
	pt=W70
	a0=*r0++		/* a0=A(0)r		*/
	a1=*r2			/* a1=A(n/2-1)i		*/
	x=*pt++ y=*r1++		/* x=Ur; y=A(n/2)r	*/
	redo 2
	*r2=a1
	r0=400
	r1=404
	r2=403
	pt=W38
	a0=*r0++		/* a0=A(0)r		*/
	a1=*r2			/* a1=A(n/2-1)i		*/
	x=*pt++ y=*r1++		/* x=Ur; y=A(n/2)r	*/
	redo 2
	*r2=a1
	r0=408
	r1=412
	r2=411
	pt=W102
	a0=*r0++		/* a0=A(0)r		*/
	a1=*r2			/* a1=A(n/2-1)i		*/
	x=*pt++ y=*r1++		/* x=Ur; y=A(n/2)r	*/
	redo 2
	*r2=a1
	r0=416
	r1=420
	r2=419
	pt=W22
	a0=*r0++		/* a0=A(0)r		*/
	a1=*r2			/* a1=A(n/2-1)i		*/
	x=*pt++ y=*r1++		/* x=Ur; y=A(n/2)r	*/
	redo 2
	*r2=a1
	r0=424
	r1=428
	r2=427
	pt=W86
	a0=*r0++		/* a0=A(0)r		*/
	a1=*r2			/* a1=A(n/2-1)i		*/
	x=*pt++ y=*r1++		/* x=Ur; y=A(n/2)r	*/
	redo 2
	*r2=a1
	r0=432
	r1=436
	r2=435
	pt=W54
	a0=*r0++		/* a0=A(0)r		*/
	a1=*r2			/* a1=A(n/2-1)i		*/
	x=*pt++ y=*r1++		/* x=Ur; y=A(n/2)r	*/
	redo 2
	*r2=a1
	r0=440
	r1=444
	r2=443
	pt=W118
	a0=*r0++		/* a0=A(0)r		*/
	a1=*r2			/* a1=A(n/2-1)i		*/
	x=*pt++ y=*r1++		/* x=Ur; y=A(n/2)r	*/
	redo 2
	*r2=a1
	r0=448
	r1=452
	r2=451
	pt=W14
	a0=*r0++		/* a0=A(0)r		*/
	a1=*r2			/* a1=A(n/2-1)i		*/
	x=*pt++ y=*r1++		/* x=Ur; y=A(n/2)r	*/
	redo 2
	*r2=a1
	r0=456
	r1=460
	r2=459
	pt=W78
	a0=*r0++		/* a0=A(0)r		*/
	a1=*r2			/* a1=A(n/2-1)i		*/
	x=*pt++ y=*r1++		/* x=Ur; y=A(n/2)r	*/
	redo 2
	*r2=a1
	r0=464
	r1=468
	r2=467
	pt=W46
	a0=*r0++		/* a0=A(0)r		*/
	a1=*r2			/* a1=A(n/2-1)i		*/
	x=*pt++ y=*r1++		/* x=Ur; y=A(n/2)r	*/
	redo 2
	*r2=a1
	r0=472
	r1=476
	r2=475
	pt=W110
	a0=*r0++		/* a0=A(0)r		*/
	a1=*r2			/* a1=A(n/2-1)i		*/
	x=*pt++ y=*r1++		/* x=Ur; y=A(n/2)r	*/
	redo 2
	*r2=a1
	r0=480
	r1=484
	r2=483
	pt=W30
	a0=*r0++		/* a0=A(0)r		*/
	a1=*r2			/* a1=A(n/2-1)i		*/
	x=*pt++ y=*r1++		/* x=Ur; y=A(n/2)r	*/
	redo 2
	*r2=a1
	r0=488
	r1=492
	r2=491
	pt=W94
	a0=*r0++		/* a0=A(0)r		*/
	a1=*r2			/* a1=A(n/2-1)i		*/
	x=*pt++ y=*r1++		/* x=Ur; y=A(n/2)r	*/
	redo 2
	*r2=a1
	r0=496
	r1=500
	r2=499
	pt=W62
	a0=*r0++		/* a0=A(0)r		*/
	a1=*r2			/* a1=A(n/2-1)i		*/
	x=*pt++ y=*r1++		/* x=Ur; y=A(n/2)r	*/
	redo 2
	*r2=a1
	r0=504
	r1=508
	r2=507
	pt=W126
	a0=*r0++		/* a0=A(0)r		*/
	a1=*r2			/* a1=A(n/2-1)i		*/
	x=*pt++ y=*r1++		/* x=Ur; y=A(n/2)r	*/
	redo 2
	*r2=a1

divid:	r0=0x0		/* Divide all the data by 2	*/
	a0=*r0++
	do 100 {
	a0=a0>>1
	*r0m2:a0
	}
	redo 100
	redo 100
	redo 100
	redo 112

level7:	r0=0x0
	r1=0x2
	r2=0x2
	pt=W0
	a0=*r0			/* a0=A(k)r		*/
	x=*pt++ y=*r1++		/* x=Ur, y=A(k+1)r		*/
	p=x*y y=*r1-- x=*pt++i	/* p=Ur*A(k+1)r,x=Ui,y=A(k+1)i	*/
	j=3
	do 64 {
	a1=a0-p		/* a1=A(k)r-Ur*A(k+1)r		*/
	a0=a0+p p=x*y	/* a0=A(k)r+Ur*A(k+1)r,p=Ui*A(k+1)i	*/
	a0=a0-p y=*r1++	/* a0=A(k)r+Ur*A(k+1)r-Ui*A(k+1)i,y=A(k+1)r	*/
	a1=a1+p p=x*y *r0++=a0	/* p=Ui*A(k+1)r		*/
	x=*pt++ y=*r1++j		/* x=Ur, y=A(k+1)i	*/
	a0=*r0			/* a0=A(k)i		*/
	a1=a0-p *r2++=a1	/* a1=a(k)i-Ui*A(k+1)r	*/
	a0=a0+p p=x*y y=*r1 x=*pt++	/* p=Ur*A(k+1)i,x=Ui,y=A(k+2)r	*/
	a0=a0+p y=*r1++ x=*pt++	/* x=Ur', y=A(k+3)r	*/
	a1=a1-p p=x*y *r0++j=a0	/* p=Ur'*A(k+3)r	*/
	y=*r1-- x=*pt++i	/* x=Ui', y=A(k+3)i	*/
	a0=*r0			/* a0=A(k+2)r		*/
	*r2++j=a1
	}
	redo 64

/* Bit reverse		*/

	pt=bitrev
	y=a0 x=*pt++
	a0=x
	y=a0 x=*pt++
	do 120 {
	r0=a0
	a1=x
	r1=a1
	y=*r0++ x=*pt++
	a0=x
	a1=*r0--
	*r1zp:y x=*pt++
	*r1zp:a1
	*r0++=y
	*r0=a1
	}

stop:	;
	goto stop

/* Subroutine to perform I/O for DSP16 256pt complex FFT.	*/
/* Subroutine requires 13 words of memory and executes in	*/
/* 1027 instruction cycles.					*/

256io:	r0=0
	y=0
	do 64	{
		*r0++=pdx0
		*r0++=y
		*r0++=pdx0
		*r0++=y
		*r0++=pdx0
		*r0++=y
		*r0++=pdx0
		*r0++=y
		}
	return

W0:	int	1.0
	int	0.0
W64:	int	0.0
	int	-1.0
W32:	int	0.7071068
	int	-0.7071068
W96:	int	-0.7071068
	int	-0.7071068
W16:	int	0.9238795	/* cos (-pi/128 * 16)	*/
	int	-0.3826834	/* sin (-pi/128 * 16)	*/
W80:	int	-0.3826834	/* cos (-pi/128 * 80)	*/
	int	-0.9238795	/* sin (-pi/128 * 80)	*/
W48:	int	0.3826834
	int	-0.9238795
W112:	int	-0.9238795
	int	-0.3826834
W8:	int	0.9807853
	int	-0.1950903
W72:	int	-0.1950903
	int	-0.9807853
W40:	int	0.5555702
	int	-0.8314696
W104:	int	-0.8314696
	int	-0.5555702
W24:	int	0.8314696
	int	-0.5555702
W88:	int	-0.5555702
	int	-0.8314696
W56:	int	0.1950903	/* cos (-pi/128 * 56)	*/
	int	-0.9807853	/* sin (-pi/128 * 56)	*/
W120:	int	-0.9807853
	int	-0.1950903
W4:	int	0.9951847
	int	-0.0980171
W68:	int	-0.0980171
	int	-0.9951847
W36:	int	0.6343933
	int	-0.7730105
W100:	int	-0.7730105
	int	-0.6343933
W20:	int	0.8819213
	int	-0.4713967
W84:	int	-0.4713967
	int	-0.8819213
W52:	int	0.2902847	/* cos (-pi/128 * 52)	*/
	int	-0.9569403	/* sin (-pi/128 * 52)	*/
W116:	int	-0.9569403
	int	-0.2902846
W12:	int	0.9569403
	int	-0.2902847
W76:	int	-0.2902847
	int	-0.9569403
W44:	int	0.4713967
	int	-0.8819213
W108:	int	-0.8819213
	int	-0.4713967
W28:	int	0.7730105
	int	-0.6343933
W92:	int	-0.6343933
	int	-0.7730105
W60:	int	0.0980171	/* cos (-pi/128 * 60)	*/
	int	-0.9951847	/* sin (-pi/128 * 60)	*/
W124:	int	-0.9951847
	int	-0.0980171
W2:	int	0.9987955
	int	-0.0490677
W66:	int	-0.0490677
	int	-0.9987955
W34:	int	0.6715590
	int	-0.7409511
W98:	int	-0.7409511
	int	-0.6715590
W18:	int	0.9039893
	int	-0.4275551
W82:	int	-0.4275551
	int	-0.9030893
W50:	int	0.3368899
	int	-0.9415441
W114:	int	-0.9415441
	int	-0.3368899
W10:	int	0.9700313
	int	-0.2429802
W74:	int	-0.2429802
	int	-0.9700313
W42:	int	0.5141027
	int	-0.8577286
W106:	int	-0.8577286
	int	-0.5141027
W26:	int	0.8032075	/* cos (-pi/128 * 26)	*/
	int	-0.5956993	/* sin (-pi/128 * 26)	*/
W90:	int	-0.5956993
	int	-0.8032075
W58:	int	0.1467305
	int	-0.9891765
W122:	int	-0.9891765
	int	-0.1467305
W6:	int	0.9891765
	int	-0.1467305
W70:	int	-0.1467305
	int	-0.9891765
W38:	int	0.5956993
	int	-0.8032075
W102:	int	-0.8032075
	int	-0.5956993
W22:	int	0.8577286
	int	-0.5141027
W86:	int	-0.5141027
	int	-0.8577286
W54:	int	0.2429802
	int	-0.9700313
W118:	int	-0.9700313
	int	-0.2429802
W14:	int	0.9415441	/* cos (-pi/128 * 14)	*/
	int	-0.3368899	/* sin (-pi/128 * 14)	*/
W78:	int	-0.3368899
	int	-0.9415441
W46:	int	0.4275551
	int	-0.9039893
W110:	int	-0.9039893
	int	-0.4275551
W30:	int	0.7409511
	int	-0.6715590
W94:	int	-0.6715590
	int	-0.7409511
W62:	int	0.0490677
	int	-0.9987955
W126:	int	-0.9987955
	int	-0.0490677
	int	0.9996988
	int	-0.0245412
	int	-0.0245412
	int	-0.9996988
	int	0.6895405	/* cos (-pi/128 * 33)	*/
	int	-0.7242471	/* sin (-pi/128 * 33)	*/
	int	-0.7242471
	int	-0.6895405
	int	0.9142098
	int	-0.4052413
	int	-0.4052413
	int	-0.9142098
	int	0.3598950
	int	-0.9329928
	int	-0.9329928
	int	-0.3598950
	int	0.9757021
	int	-0.2191012
	int	-0.2191012
	int	-0.9757021
	int	0.5349976
	int	-0.8448536
	int	-0.8448536
	int	-0.5349976
	int	0.8175848
	int	-0.5758082
	int	-0.5758082	/* cos (-pi/128 * 89)	*/
	int	-0.8175848	/* sin (-pi/128 * 89)	*/
	int	0.1709619
	int	-0.9852776
	int	-0.9852776
	int	-0.1709619
	int	0.9924795
	int	-0.1224107
	int	-0.1224107
	int	-0.9924795
	int	0.6152316
	int	-0.7883464
	int	-0.7883464
	int	-0.6152316
	int	0.8700870
	int	-0.4928982
	int	-0.4928982
	int	-0.8700870
	int	0.2667128
	int	-0.9637761
	int	-0.9637761
	int	-0.2667128
	int	0.9495282
	int	-0.3136827
	int	-0.3136827	/* cos (-pi/128 * 77)	*/
	int	-0.9495282	/* sin (-pi/128 * 77)	*/
	int	0.44961133
	int	-0.8932243
	int	-0.8932243
	int	-0.4496113
	int	0.7572088
	int	-0.6531728
	int	-0.6531728
	int	-0.7572088
	int	0.0735646
	int	-0.9972905
	int	-0.9972905
	int	-0.0735646
	int	0.9972905
	int	-0.0735646
	int	-0.0735646
	int	-0.9972905
	int	0.6531728
	int	-0.7572088
	int	-0.7572088
	int	-0.6531728
	int	0.8932243
	int	-0.4496113
	int	-0.4496113
	int	-0.8932243
	int	0.3136817
	int	-0.9495282
	int	-0.9495282	/* cos (-pi/128 * 115)	*/
	int	-0.3136817	/* sin (-pi/128 * 115)	*/
	int	0.9637761
	int	-0.2667128
	int	-0.2667128
	int	-0.9637761
	int	0.4928982
	int	-0.8700870
	int	-0.8700870
	int	-0.4928982
	int	0.7883464
	int	-0.6152316
	int	-0.6152316
	int	-0.7883464
	int	0.1224107
	int	-0.9924795
	int	-0.9924795
	int	-0.1224107
	int	0.9852776
	int	-0.1709619
	int	-0.1709619
	int	-0.9852776
	int	0.5758082
	int	-0.8175848
	int	-0.8175848
	int	-0.5758082
	int	0.8448536
	int	-0.5349976
	int	-0.5349976
	int	-0.8448536
	int	0.2191012
	int	-0.9757021
	int	-0.9757021
	int	-0.2191012
	int	0.9329928	/* cos (-pi/128 * 15)	*/
	int	-0.3598950	/* sin (-pi/128 * 15)	*/
	int	-0.3598950
	int	-0.9329928
	int	0.4052413
	int	-0.9142098
	int	-0.9142098
	int	-0.4052413
	int	0.7242471
	int	-0.6895405
	int	-0.6895405
	int	-0.7242471
	int	0.0245412
	int	-0.9996988
	int	-0.9996988
	int	-0.0245412

/* Bit reversal table for 256 points fft	*/

bitrev:	int	0x2
	int	0x100
	int	0x4
	int	0x80
	int	0x6
	int	0x180
	int	0x8
	int	0x40
	int	0xa
	int	0x140
	int	0xc
	int	0xc0
	int	0xe
	int	0x1c0
	int	0x10
	int	0x20
	int	0x12
	int	0x120
	int	0x14
	int	0xa0
	int	0x16
	int	0x1a0
	int	0x18
	int	0x60
	int	0x1a
	int	0x160
	int	0x1c
	int	0xe0
	int	0x1e
	int	0x1e0
	int	0x22
	int	0x110
	int	0x24
	int	0x90
	int	0x26
	int	0x190
	int	0x28
	int	0x50
	int	0x2a
	int	0x150
	int	0x2c
	int	0xd0
	int	0x2e
	int	0x1d0
	int	0x32
	int	0x130
	int	0x34
	int	0xb0
	int	0x36
	int	0x1b0
	int	0x38
	int	0x70
	int	0x3a
	int	0x170
	int	0x3c
	int	0xf0
	int	0x3e
	int	0x1f0
	int	0x42
	int	0x108
	int	0x44
	int	0x88
	int	0x46
	int	0x188
	int	0x4a
	int	0x148
	int	0x4c
	int	0xc8
	int	0x4e
	int	0x1c8
	int	0x52
	int	0x128
	int	0x54
	int	0xa8
	int	0x56
	int	0x1a8
	int	0x58
	int	0x68
	int	0x5a
	int	0x168
	int	0x5c
	int	0xe8
	int	0x5e
	int	0x1e8
	int	0x62
	int	0x118
	int	0x64
	int	0x98
	int	0x66
	int	0x198
	int	0x6a
	int	0x158
	int	0x6c
	int	0xd8
	int	0x6e
	int	0x1d8
	int	0x72
	int	0x138
	int	0x74
	int	0xb8
	int	0x76
	int	0x1b8
	int	0x7a
	int	0x178
	int	0x7c
	int	0xf8
	int	0x7e
	int	0x1f8
	int	0x82
	int	0x104
	int	0x86
	int	0x184
	int	0x8a
	int	0x144
	int	0x8c
	int	0xc4
	int	0x8e
	int	0x1c4
	int	0x92
	int	0x124
	int	0x94
	int	0xa4
	int	0x96
	int	0x1a4
	int	0x9a
	int	0x164
	int	0x9c
	int	0xe4
	int	0x9e
	int	0x1e4
	int	0xa2
	int	0x114
	int	0xa6
	int	0x194
	int	0xaa
	int	0x154
	int	0xac
	int	0xd4
	int	0xae
	int	0x1d4
	int	0xb2
	int	0x134
	int	0xb6
	int	0x1b4
	int	0xba
	int	0x174
	int	0xbc
	int	0xf4
	int	0xbe
	int	0x1f4
	int	0xc2
	int	0x10c
	int	0xc6
	int	0x18c
	int	0xca
	int	0x14c
	int	0xce
	int	0x1cc
	int	0xd2
	int	0x12c
	int	0xd6
	int	0x1ac
	int	0xda
	int	0x16c
	int	0xdc
	int	0xec
	int	0xde
	int	0x1ec
	int	0xe2
	int	0x11c
	int	0xe6
	int	0x19c
	int	0xea
	int	0x15c
	int	0xee
	int	0x1dc
	int	0xf2
	int	0x13c
	int	0xf6
	int	0x1bc
	int	0xfa
	int	0x17c
	int	0xfe
	int	0x1fc
	int	0x106
	int	0x182
	int	0x10a
	int	0x142
	int	0x10e
	int	0x1c2
	int	0x112
	int	0x122
	int	0x116
	int	0x1a2
	int	0x11a
	int	0x162
	int	0x11e
	int	0x1e2
	int	0x126
	int	0x192
	int	0x12a
	int	0x152
	int	0x12e
	int	0x1d2
	int	0x136
	int	0x1b2
	int	0x13a
	int	0x172
	int	0x13e
	int	0x1f2
	int	0x146
	int	0x18a
	int	0x14e
	int	0x1ca
	int	0x156
	int	0x1aa
	int	0x15a
	int	0x16a
	int	0x15e
	int	0x1ea
	int	0x166
	int	0x19a
	int	0x16e
	int	0x1da
	int	0x176
	int	0x1ba
	int	0x17e
	int	0x1fa
	int	0x18e
	int	0x1c6
	int	0x196
	int	0x1a6
	int	0x19e
	int	0x1e6
	int	0x1ae
	int	0x1d6
	int	0x1be
	int	0x1f6
	int	0x1de
endprm:	int	0x1ee

.ram
A:	512*int
.endram

