/* AT&T DSP16, 64 point FFT           jkf  Oct 14, 1988 */
/*							*/
/* This is a 64-point fft program with 			*/
/*  dynamic scaling for each butterfly process.		*/
/* The input data is <real0>,<imag0>;<real2>,<imag1>;   */
/*  .... with the start address in A, and the amplitude	*/
/*  of input data (Q14) will be limited in (-2.0, 2.0).	*/
/* After running this program, the input data will be	*/
/*  replaced by the output values.			*/
/* The execution time is 4749 instruction cycles.	*/
/* The program needs 494 words of ROM and 128 words of	*/
/*  RAM.						*/
/* May 31, 1988						*/

start:	auc=0x2
	i=-1

/* un-comment following line to include input		*/
/* from parallel port (routine follows label "stop.")	*/
/*	call 64io	*/

level0:	r0=0x0
	r1=0x40
	r2=0x3f
	pt=W0
	a0=*r0++		/* a0=A(0)r		*/
	a1=*r2			/* a1=A(n/2-1)i		*/
	x=*pt++ y=*r1++		/* x=Ur; y=A(n/2)r	*/
	do 32 {
	p=x*y x=*pt++i y=*r1--	/* p=Ur*A(k+n/2)r, x=Ui, y=A(k+n/2)i	*/
	a1=a0-p *r2++=a1	/* a1=A(k)r-Ur*A(k+n/2)r	*/
	a0=a0+p	p=x*y		/* a0=A(k)r+Ur*A(k+n/2)r,p=Ui*A(k+n/2)i	*/
	a0=a0-p y=*r1++		/* a0=A(k)r+Ur*A(k+n/2)r-Ui*A(k+n/2)i	*/
	a0=a0>>1		/* a0=a0/2, y=A(k+n/2)r		*/
	a1=a1+p p=x*y *r0m2:a0	/* a1=A(k)r-Ur*A(k+n/2)r+Ui*A(k+n/2)i	*/
	x=*pt++ y=*r1++		/* p=Ui*A(k+n/2)r,x=Ur,y=A(k+n/2)i	*/
	a1=a1>>1		/* a1=a1/2, x=Ur, y=A(k+n/2)i	*/
	a1=a0-p *r2++=a1	/* a1=A(k)i-Ui*A(k+n/2)r	*/
	a0=a0+p p=x*y		/* a0=A(k)i+Ui*A(k+n/2)r,p=Ur*A(k+n/2)i	*/
	a0=a0+p y=*r1++		/* a0=A(k)i+Ui*A(k+n/2)r+Ur*A(k+n/2)i	*/
	a0=a0>>1		/* a0=a0/2, y=A(k+1+n/2)r	*/
	a1=a1-p *r0m2:a0 	/* a1=A(k)i-Ui*A(k+n/2)r-Ur*A(k+n/2)i	*/
	a1=a1>>1		/* a1=a1/2, x=Ur		*/
	}
	*r2=a1

level1:	r0=0x00
	r1=0x20
	r2=0x1f
	pt=W0
	a0=*r0++
	a1=*r2
	x=*pt++ y=*r1++		/* x=Ur; y=A(n/2)r	*/
	redo 16
	*r2=a1
	r0=0x40
	r1=0x60
	r2=0x5f
	pt=W16
	a0=*r0++
	a1=*r2
	x=*pt++ y=*r1++		/* x=Ur; y=A(n/2)r	*/
	redo 16
	*r2=a1

level2:	r0=0x00
	r1=0x10
	r2=0x0f
	pt=W0
	a0=*r0++
	a1=*r2
	x=*pt++ y=*r1++		/* x=Ur; y=A(n/2)r	*/
	redo 8
	*r2=a1
	r0=0x20
	r1=0x30
	r2=0x2f
	pt=W16
	a0=*r0++
	a1=*r2
	x=*pt++ y=*r1++		/* x=Ur; y=A(n/2)r	*/
	redo 8
	*r2=a1
	r0=0x40
	r1=0x50
	r2=0x4f
	pt=W8
	a0=*r0++
	a1=*r2
	x=*pt++ y=*r1++		/* x=Ur; y=A(n/2)r	*/
	redo 8
	*r2=a1
	r0=0x60
	r1=0x70
	r2=0x6f
	pt=W24
	a0=*r0++
	a1=*r2
	x=*pt++ y=*r1++		/* x=Ur; y=A(n/2)r	*/
	redo 8
	*r2=a1

level3:	r0=0x00
	r1=0x08
	r2=0x07
	pt=W0
	a0=*r0++
	a1=*r2
	x=*pt++ y=*r1++		/* x=Ur; y=A(n/2)r	*/
	redo 4
	*r2=a1
	r0=0x10
	r1=0x18
	r2=0x17
	pt=W16
	a0=*r0++
	a1=*r2
	x=*pt++ y=*r1++		/* x=Ur; y=A(n/2)r	*/
	redo 4
	*r2=a1
	r0=32
	r1=40
	r2=39
	pt=W8
	a0=*r0++
	a1=*r2
	x=*pt++ y=*r1++		/* x=Ur; y=A(n/2)r	*/
	redo 4
	*r2=a1
	r0=48
	r1=56
	r2=55
	pt=W24
	a0=*r0++
	a1=*r2
	x=*pt++ y=*r1++		/* x=Ur; y=A(n/2)r	*/
	redo 4
	*r2=a1
	r0=64
	r1=72
	r2=71
	pt=W4
	a0=*r0++
	a1=*r2
	x=*pt++ y=*r1++		/* x=Ur; y=A(n/2)r	*/
	redo 4
	*r2=a1
	r0=80
	r1=88
	r2=87
	pt=W20
	a0=*r0++
	a1=*r2
	x=*pt++ y=*r1++		/* x=Ur; y=A(n/2)r	*/
	redo 4
	*r2=a1
	r0=96
	r1=104
	r2=103
	pt=W12
	a0=*r0++
	a1=*r2
	x=*pt++ y=*r1++		/* x=Ur; y=A(n/2)r	*/
	redo 4
	*r2=a1
	r0=112
	r1=120
	r2=119
	pt=W28
	a0=*r0++
	a1=*r2
	x=*pt++ y=*r1++		/* x=Ur; y=A(n/2)r	*/
	redo 4
	*r2=a1

level4:	r0=0x00
	r1=0x04
	r2=0x03
	pt=W0
	a0=*r0++
	a1=*r2
	x=*pt++ y=*r1++		/* x=Ur; y=A(n/2)r	*/
	redo 2
	*r2=a1
	r0=0x08
	r1=12
	r2=11
	pt=W16
	a0=*r0++
	a1=*r2
	x=*pt++ y=*r1++		/* x=Ur; y=A(n/2)r	*/
	redo 2
	*r2=a1
	r0=16
	r1=20
	r2=19
	pt=W8
	a0=*r0++
	a1=*r2
	x=*pt++ y=*r1++		/* x=Ur; y=A(n/2)r	*/
	redo 2
	*r2=a1
	r0=24
	r1=28
	r2=27
	pt=W24
	a0=*r0++
	a1=*r2
	x=*pt++ y=*r1++		/* x=Ur; y=A(n/2)r	*/
	redo 2
	*r2=a1
	r0=32
	r1=36
	r2=35
	pt=W4
	a0=*r0++
	a1=*r2
	x=*pt++ y=*r1++		/* x=Ur; y=A(n/2)r	*/
	redo 2
	*r2=a1
	r0=40
	r1=44
	r2=43
	pt=W20
	a0=*r0++
	a1=*r2
	x=*pt++ y=*r1++		/* x=Ur; y=A(n/2)r	*/
	redo 2
	*r2=a1
	r0=48
	r1=52
	r2=51
	pt=W12
	a0=*r0++
	a1=*r2
	x=*pt++ y=*r1++		/* x=Ur; y=A(n/2)r	*/
	redo 2
	*r2=a1
	r0=56
	r1=60
	r2=59
	pt=W28
	a0=*r0++
	a1=*r2
	x=*pt++ y=*r1++		/* x=Ur; y=A(n/2)r	*/
	redo 2
	*r2=a1
	r0=64
	r1=68
	r2=67
	pt=W2
	a0=*r0++
	a1=*r2
	x=*pt++ y=*r1++		/* x=Ur; y=A(n/2)r	*/
	redo 2
	*r2=a1
	r0=72
	r1=76
	r2=75
	pt=W18
	a0=*r0++
	a1=*r2
	x=*pt++ y=*r1++		/* x=Ur; y=A(n/2)r	*/
	redo 2
	*r2=a1
	r0=80
	r1=84
	r2=83
	pt=W10
	a0=*r0++
	a1=*r2
	x=*pt++ y=*r1++		/* x=Ur; y=A(n/2)r	*/
	redo 2
	*r2=a1
	r0=88
	r1=92
	r2=91
	pt=W26
	a0=*r0++
	a1=*r2
	x=*pt++ y=*r1++		/* x=Ur; y=A(n/2)r	*/
	redo 2
	*r2=a1
	r0=96
	r1=100
	r2=99
	pt=W6
	a0=*r0++
	a1=*r2
	x=*pt++ y=*r1++		/* x=Ur; y=A(n/2)r	*/
	redo 2
	*r2=a1
	r0=104
	r1=108
	r2=107
	pt=W22
	a0=*r0++
	a1=*r2
	x=*pt++ y=*r1++		/* x=Ur; y=A(n/2)r	*/
	redo 2
	*r2=a1
	r0=112
	r1=116
	r2=115
	pt=W14
	a0=*r0++
	a1=*r2
	x=*pt++ y=*r1++		/* x=Ur; y=A(n/2)r	*/
	redo 2
	*r2=a1
	r0=120
	r1=124
	r2=123
	pt=W30
	a0=*r0++
	a1=*r2
	x=*pt++ y=*r1++		/* x=Ur; y=A(n/2)r	*/
	redo 2
	*r2=a1

divid:	r0=0x0		/* Divide all the data by 2	*/
	a0=*r0++
	do 64 {
	a0=a0>>1
	*r0m2:a0
	}
	redo 64

level5:	r0=0x0
	r1=0x2
	r2=0x2
	pt=W0
	a0=*r0			/* a0=A(k)r		*/
	x=*pt++ y=*r1++		/* x=Ur, y=A(k+1)r		*/
	p=x*y y=*r1-- x=*pt++i	/* p=Ur*A(k+1)r,x=Ui,y=A(k+1)i	*/
	j=3
	do 32 {
	a1=a0-p		/* a1=A(k)r-Ur*A(k+1)r		*/
	a0=a0+p p=x*y	/* a0=A(k)r+Ur*A(k+1)r,p=Ui*A(k+1)i	*/
	a0=a0-p y=*r1++	/* a0=A(k)r+Ur*A(k+1)r-Ui*A(k+1)i,y=A(k+1)r	*/
	a1=a1+p p=x*y *r0++=a0	/* p=Ui*A(k+1)r		*/
	x=*pt++ y=*r1++j		/* x=Ur, y=A(k+1)i	*/
	a0=*r0			/* a0=A(k)i		*/
	a1=a0-p *r2++=a1	/* a1=a(k)i-Ui*A(k+1)r	*/
	a0=a0+p p=x*y y=*r1 x=*pt++	/* p=Ur*A(k+1)i,x=Ui,y=A(k+2)r	*/
	a0=a0+p y=*r1++ x=*pt++	/* x=Ur', y=A(k+3)r	*/
	a1=a1-p p=x*y *r0++j=a0	/* p=Ur'*A(k+3)r	*/
	y=*r1-- x=*pt++i	/* x=Ui', y=A(k+3)i	*/
	a0=*r0			/* a0=A(k+2)r		*/
	*r2++j=a1
	}

/* Bit reverse		*/

	pt=bitrev
	y=a0 x=*pt++
	a0=x
	y=a0 x=*pt++
	do 28 {
	r0=a0
	a1=x
	r1=a1
	y=*r0++ x=*pt++
	a0=x
	a1=*r0--
	*r1zp:y x=*pt++
	*r1zp:a1
	*r0++=y
	*r0=a1
	}

stop:	;
	goto stop

/* Subroutine to perform I/O for DSP16 64pt complex FFT		*/
/* Subroutine requires 7 words of memory and executes in	*/
/* 259 instruction cycles.					*/

64io:	r0=0
	y=0
	do 64	{
		*r0++=pdx0
		*r0++=y
		}
	return

W0:	int	1.0		/* cos (-pi/32 * 0)	*/
	int	0.0		/* sin (-pi/32 * 0)	*/
W16:	int	0.0
	int	-1.0
W8:	int	0.707106781
	int	-0.707106781
W24:	int	-0.707106781
	int	-0.707106781
W4:	int	0.923879532
	int	-0.382683432
W20:	int	-0.382683432
	int	-0.923879532
W12:	int	0.382683432
	int	-0.923879532
W28:	int	-0.923879532
	int	-0.382683432
W2:	int	0.98078528
	int	-0.195090322
W18:	int	-0.195090322
	int	-0.98078528
W10:	int	0.555570233
	int	-0.831469612
W26:	int	-0.831469612
	int	-0.555570233
W6:	int	0.831469612
	int	-0.555570233
W22:	int	-0.555570233
	int	-0.831469612
W14:	int	0.195090322
	int	-0.98078528
W30:	int	-0.98078528
	int	-0.195090322
	int	0.995184726
	int	-0.09801714
	int	-0.09801714
	int	-0.995184726
	int	0.634393284
	int	-0.773010453
	int	-0.773010453
	int	-0.634393284
	int	0.881921264
	int	-0.471396736
	int	-0.471396736	/* cos (-pi/32 * 21)	*/
	int	-0.881921264	/* sin (-pi/32 * 21)	*/
	int	0.290284677
	int	-0.956940335
	int	-0.956940335
	int	-0.290284677
	int	0.956940335
	int	-0.290284677
	int	-0.290284677
	int	-0.956940335
	int	0.471396736
	int	-0.881921264
	int	-0.881921264
	int	-0.471396736
	int	0.773010453
	int	-0.634393284
	int	-0.634393284
	int	-0.773010453
	int	0.09801714
	int	-0.995184726
	int	-0.995184726	/* cos (-pi/32 * 31)	*/
	int	-0.09801714	/* sin (-pi/32 * 31)	*/

/* Bit reversal table for 64 points fft		*/
bitrev:	int	0x2
	int	0x40
	int	0x4
	int	0x20
	int	0x6
	int	0x60
	int	0x8
	int	0x10
	int	0xa
	int	0x50
	int	0xc
	int	0x30
	int	0xe
	int	0x70
	int	0x12
	int	0x48
	int	0x14
	int	0x28
	int	0x16
	int	0x68
	int	0x1a
	int	0x58
	int	0x1c
	int	0x38
	int	0x1e
	int	0x78
	int	0x22
	int	0x44
	int	0x26
	int	0x64
	int	0x2a
	int	0x54
	int	0x2c
	int	0x34
	int	0x2e
	int	0x74
	int	0x32
	int	0x4c
	int	0x36
	int	0x6c
	int	0x3a
	int	0x5c
	int	0x3e
	int	0x7c
	int	0x46
	int	0x62
	int	0x4a
	int	0x52
	int	0x4e
	int	0x72
	int	0x56
	int	0x6a
	int	0x5e
	int	0x7a
	int	0x6e
endprm:	int	0x76

.ram
A:	128*int
.endram

