   'LISTING 1 FIR.BAS
   'Finite Impulse Response filter program
   DIM X(256),H(15),Y(256),F1(256),F2(256)
   PI = 3.14159265
   DEFINT I,N
   LENGTH = 15  'number of taps in digital filter
   SCREEN 9,0   'IBM XT EGA Mode 640x350 with 16 colors
   CLS
   INPUT" SELECT H)ighpass or L)owpass filter: ",B$
   IF B$ = "L" OR B$ = "l" THEN
'***************************************************************
   ' FINITE IMPULSE RESPONSE FILTER COEFFICIENTS
   ' THESE COEFFICIENTS FORM A LOWPASS FILTER WHOSE CORNER
   ' FREQUENCY IS AT .03125*Fs (or 312.5 Hz for an 10kHz Fs)
'***************************************************************
  h( 1 ) =-8.996965363621712E-003
  h( 2 ) = 7.864067330956459E-003
  h( 3 ) = 3.349926695227623E-002
  h( 4 ) = 6.534869968891144E-002
  h( 5 ) = 9.889715164899826E-002
  h( 6 ) = .1285655647516251
  h( 7 ) = .1489759534597397
  h( 8 ) = .15625
  h( 9 ) = .1489759534597397
  h( 10 ) = .1285655647516251
  h( 11 ) = 9.889715164899826E-002
  h( 12 ) = 6.534869968891144E-002
  h( 13 ) = 3.349926695227623E-002
  h( 14 ) = 7.864067330956459E-003
  h( 15 ) =-8.996965363621712E-003
ELSE
'***************************************************************
   ' FINITE IMPULSE RESPONSE FILTER COEFFICIENTS
   ' THESE COEFFICIENTS FORM A HIGHPASS FILTER WHOSE CORNER
   ' FREQUENCY IS AT .1250*Fs (or 1250 Hz for an 10kHz Fs)
'***************************************************************
  h( 1 ) = 8.996965363621712E-003
  h( 2 ) =-7.864067330956459E-003
  h( 3 ) =-3.349926695227623E-002
  h( 4 ) =-6.534869968891144E-002
  h( 5 ) =-9.889715164899826E-002
  h( 6 ) =-.1285655647516251
  h( 7 ) =-.1489759534597397
  h( 8 ) = .84375
  h( 9 ) =-.1489759534597397
  h( 10 ) =-.1285655647516251
  h( 11 ) =-9.889715164899826E-002
  h( 12 ) =-6.534869968891144E-002
  h( 13 ) =-3.349926695227623E-002
  h( 14 ) =-7.864067330956459E-003
  h( 15 ) = 8.996965363621712E-003
END IF
   ' BUILD WAVEFORM TO FEED INTO FILTER
   ' This waveform will consist of a 312.5 Hz + 1250 Hz sine waves.
   ' To provide a series of discrete values at the sampling
   ' rate (Fs), which is 10000 Hz for this example, we determine
   ' the number points per cycle associated with each sine wave.
   ' For example, we know that at .5 Fs, it takes 2 points/cycle.
   ' So, for 312.5 Hz, we have 10000/312.5 or 32 points/cycle,
   ' and at 1250 Hz, we have 10000/1250 or 8 points/cycle.

   FOR i = 0 TO 255
     ' generate 312.5 Hz signal
     F1(i+1) = SIN(2*PI*I/32)
     ' generate 1250 Hz signal
     F2(i+1) =SIN(2*PI*I/8)
     ' mix the two together, place in input array x(i)
     x(i+1)=F1(i+1)+F2(i+1)
   NEXT

    CLS
    ' PLOT WAVEFORM
    FOR I = 1 TO 256
      LINE(50+I*2,75-25*X(I))-(50+I*2+1,75-25*X(I+1)),14
    NEXT
    LOCATE 6,2:PRINT"In";
    LOCATE 15,2:PRINT"Out";

    LINE(0,0)-(639,349),3,B
    ' SHOW ZERO VOLTAGE LINE
    LINE(50,75)-(499+50,75),3,,&H8888
    LINE(50,200)-(499+50,200),3,,&H8888
    LINE(50,200)-(50,200),14

    'PERFORM FIR FILTER FUNCTION
    FOR N = 1 TO 256
      FOR I = 1 TO LENGTH
        Y(N) = Y(N) + H(I) * X(N-I)
      NEXT
      LINE-(N*2+59,200-25*Y(N)),14
    NEXT

100 A$=INKEY$:IF A$="" THEN 100
stop

