/* AT&T DSP32, 20 tap FIR FILTER			  Sep 29, 1988  */
/*									*/
/* 20 tap DSP32 FIR filter.		fir20.s				*/
/* Execution requires 23 cycles per sample including I/0:		*/
/*									*/
/*	DSP32 (160ns) = 23 x 160ns = 3.68us;  271.7 kHz sample rate	*/
/*	DSP32C (80ns) = 23 x 80ns = 1.84us;  543.5 kHz sample rate	*/
/*	     (see separate DSP32C program using do loop: fir20c.s)	*/
/* Memory requirements:							*/
/*	Program:  28 words						*/
/*	Data:	  39 words (19 state variables + 20 coefficients)	*/
/* All instructions are single-cycle. Each line is a a single		*/
/*     assembly language instruction.					*/



init:	r1 = data		/* Initialize pointers to data and	*/
	r3 = data		/* coefficients.			*/
	r2 = coef
	r15 = -72		/* r15 and r16 are used as post-	*/
	r16 = -76		/* modification registers to 		*/
				/* re-initialize within the loop.	*/

loop:	a1  =  float(ibuf)	/* Input new sample and convert to 32b.	*/
	a0 = *r1++ * *r2++		/* Tap X(n-19) x coef b19.	*/
	a0 = a0 + (*r3++=*r1++) * *r2++	/* X(n-18) x b18; update X(n-19)*/
	a0 = a0 + (*r3++=*r1++) * *r2++
	a0 = a0 + (*r3++=*r1++) * *r2++
	a0 = a0 + (*r3++=*r1++) * *r2++
	a0 = a0 + (*r3++=*r1++) * *r2++
	a0 = a0 + (*r3++=*r1++) * *r2++
	a0 = a0 + (*r3++=*r1++) * *r2++
	a0 = a0 + (*r3++=*r1++) * *r2++
	a0 = a0 + (*r3++=*r1++) * *r2++
	a0 = a0 + (*r3++=*r1++) * *r2++
	a0 = a0 + (*r3++=*r1++) * *r2++
	a0 = a0 + (*r3++=*r1++) * *r2++
	a0 = a0 + (*r3++=*r1++) * *r2++
	a0 = a0 + (*r3++=*r1++) * *r2++
	a0 = a0 + (*r3++=*r1++) * *r2++
	a0 = a0 + (*r3++=*r1++) * *r2++
	a0 = a0 + (*r3++=*r1++) * *r2++	/* X(n-2) x b2; update X(n-3).	*/
	a0 = a0 + (*r3++=*r1++r15) * *r2++	/* X(n-1) x b1; init r1.*/
	a0 = a0 + (*r3++r15=a1) * *r2++r16	/* X(n-0) x input; init */
						/* r3 and r2.		*/
	goto loop
	obuf = a0 = int(a0)	/* Latent instruction; convert to 16b	*/
				/* and output value to parallel port.	*/

		/* Coefficients stored from b19 to b0 */

coef:	float	1.234872, 0.1794321e-2, -2.183211e-4

		/* remaining coefficients entered here	*/

.rsect ".hi_ram"	/* Assembler directive.				*/

data:	19*float 0.0	/* All state variables are initialized to 0.	*/

