/* AT&T DSP32C,  64 tap FIR Filter			  Jan 24, 1989  */
/*									*/
/* 64 tap DSP32C FIR filter.		fir64c.s			*/
/* Execution requires 68 cycles per sample including I/0:		*/
/*									*/
/*	DSP32C (80ns) = 68 x 80ns = 5.44us;  183.8 kHz sample rate	*/
/*		(do loop instruction requires DSP32C)			*/
/* Memory requirements:							*/
/*									*/
/*	Program:  13 words						*/
/*	Data:	 127 words (63 state variables + 64 coefficients)	*/
/* All instructions are single-cycle. Each line is a a single		*/
/*     assembly language instruction.					*/



init:	r1 = data		/* Initialize pointers to data and	*/
	r3 = data		/* coefficients.			*/
	r2 = coef
	r15 = -248		/* r15 and r16 are used as post-	*/
	r16 = -252		/* modification registers to 		*/
				/* re-initialize within the loop.	*/

loop:	a1  =  float(ibuf)	/* Input new sample and convert to 32b.	*/
	a0 = *r1++ * *r2++	/* Tap X(n-63) x coef b63.		*/

	do 0,60			/* Do next 0+1 instructions 60+1 times.	*/
	a0 = a0 + (*r3++=*r1++) * *r2++

	a0 = a0 + (*r3++=*r1++r15) * *r2++	/* X(n-1) x b1; init r1.*/
	a0 = a0 + (*r3++r15=a1) * *r2++r16	/* X(n-0) x input; init */
						/* r15 and r2.		*/
	goto loop
	obuf = a0 = int(a0)	/* Latent instruction; convert to 16b	*/
				/* and output value to parallel port.	*/

		/* Coefficients stored from b63 to b0 */

coef:	float	1.234872, 0.1794321e-2, -2.183211e-4, -1.25, 3.4432
	float	2.321842, -1.223, 4.76832e-2, 9.87432e-4, -3.245

		/* remaining coefficients entered here	*/

.rsect ".hi_ram"		/* Assembler directive.			*/

data:	63*float 0.0	/* All state variables are initialized to 0.	*/

