/* AT&T DSP32C,  67 tap FIR Filter			  Jan 24, 1989  */
/*									*/
/* 67 tap DSP32C FIR filter.		fir67c.s			*/
/* Execution requires 71 cycles per sample including I/0:		*/
/*									*/
/*	DSP32C (80ns) = 71 x 80ns = 5.68us;  176.0 kHz sample rate	*/
/*		(do loop instruction requires DSP32C)			*/
/* Memory requirements:							*/
/*	Program:  13 words						*/
/*	Data:	 133 words (66 state variables + 67 coefficients)	*/
/* All instructions are single-cycle. Each line is a a single		*/
/*     assembly language instruction.					*/


init:	r1 = data		/* Initialize pointers to data and	*/
	r3 = data		/* coefficients.			*/
	r2 = coef
	r15 = -260		/* r15 and r16 are used as post-	*/
	r16 = -264		/* modification registers to 		*/
				/* re-initialize within the loop.	*/

loop:	a1  =  float(ibuf)	/* Input new sample and convert to 32b.	*/
	a0 = *r1++ * *r2++	/* Tap X(n-66) x coef b66.		*/

	do 0,63			/* Do next 0+1 instructions 63+1 times.	*/
	a0 = a0 + (*r3++=*r1++) * *r2++

	a0 = a0 + (*r3++=*r1++r15) * *r2++	/* X(n-1) x b1; init r1.*/
	a0 = a0 + (*r3++r15=a1) * *r2++r16	/* X(n-0) x input; init */
						/* r3 and r2.		*/
	goto loop
	obuf = a0 = int(a0)	/* Latent instruction; convert to 16b	*/
				/* and output value.			*/

		/* Coefficients stored from b66 to b0 */

coef:	float	1.234872, 0.1794321e-2, -2.183211e-4, 1.3294323e-5, 2.3
	float	6.694837e-1, -8.39283e-6, 2.39843, 3.222231e-4, 3.94231

		/* remaining coefficients entered here	*/

.rsect ".hi_ram"	/* Assembler directive.				*/

data:	66*float 0.0	/* All state variables are initialized to 0.	*/

