.MODULE cvt_ieee_float_to_two_word_float; 
 
{ 
        Convert 32-bit IEEE 754 floating-point to two word floating 
  
        Calling Parameters 
                MR1 = MSW of IEEE 754 floating point number 
                MR0 = LSW of IEEE 754 floating point number 
  
        Return Values 
                SE  = Exponent of two word float 
                SR1 = Mantissa of two word float 
  
        Altered Registers 
                AX0,AX1,AY0,AY1,AF,AR,MX0,MX1 
 
        Computation Time 
		30 cycles (max)                
 
} 
  
.ENTRY  ieeetwo; 
  
ieeetwo:AY0=H#00FF;                      {mask to extract exp, lo_bit check} 
        SR1=H#0000;                      {clear mantissa result} 
        SE =H#0000;                      {clear exponent} 
        AX1=H#0000;                      {clear UNDER/OVERFLOW flag} 
  
zero:   SR=LSHIFT MR1 BY 0 (LO);         {check for flt_num = 0} 
        SR=SR OR LSHIFT MR0 BY 0 (LO); 
        AR=PASS SR0; 
        IF EQ RTS; 
  
negone: AF=PASS MR0;                     {check for flt_num = -1} 
        IF NE JUMP convert; 
        AF=PASS MR1; 
        AX0=H#BF80; 
        AR=AX0-AF; 
        IF NE JUMP convert; 
        SR0=H#8000; 
        SE =H#0000; 
        RTS; 
  
convert:SR=LSHIFT MR1 BY -7 (LO);        {set up exponent field to mask} 
        AF=SR0 AND AY0;                  {extract exponent field by AND} 
        AX0=H#007E;                      {exponent bias -- 126 decimal} 
        AR=AF-AX0;                       {subtract bias from exponent} 
        SE=AR;                           {unbiased expo into SE register} 
        SR=LSHIFT MR1 BY 8 (HI);         {paste hi mantissa word} 
        SR=SR OR LSHIFT MR0 BY 8 (LO);   {paste lo mantissa word} 
        AY1=H#8000;                      {hidden "1" bit} 
        AR=SR1 OR AY1;                   {paste hidden "1" bit} 
        SR=LSHIFT AR BY -1 (HI);         {shift mantissa w/ hidden bit} 
        AF=PASS MR1;                     {set sign bit if orig. was neg.} 
        AR=SR1;                          {use only 16 MSBs of result} 
        IF LT AR=-SR1;                   {if neg. orig. do twos complement} 
        SR=LSHIFT AR BY 0 (HI); 
        RTS; 
 
.ENDMOD; 
 
