/*-----------------------------------------------------------------------
  DSP16A-V32 Modem Host Code                   Feb 24, 1991

   General Purpose Modem Host Code V3.13

	modem.c

	Set up core for any of the modem standards

	Author: James K. Flynn

-----------------------------------------------------------------------*/

#include <stdio.h>
#include <string.h>
#include "define.h"
#include "c:\tc\getopt.c"
#define VERSION "3.13"
#define WAIT_FOR_DIALER	 \
while((regread(1,0x0a)&DIALING_NOT_READY)==DIALING_NOT_READY) 	\
		if((dialdot++)%200==0) printf(".");
#define BAUDDELAY 10000
#define DASHDELAY 10000
#define OFF 0
#define L2400 0x1
#define L1200 0x2
#define L600 0x4
#define L300 0x20
#define LV23 0x80
#define F9600 0x100
#define F7200 0x200
#define F4800 0x400
#define F2400 0x800
#define F300 0x1000
#define FTX 0x20
#define FRX 0x40
#define SSYNCH 0x88
#define SSYNCL 0x80
#define SBIS  0x10
#define S4800 0x20
#define S9600 0x40
#define SC 0x1
#define S7200 0x2
#define S12000 0x4
#define S14400 0x10
#define ANSWER 0
#define ORIGINATE 1
#define FAR_ON 1
#define FAR_OFF 0
#define DIALING_NOT_READY 0x10


unsigned board=0;
int dialdot=0;
bit08 lratel=0, lrateh=0;

main(argc,argv)
int argc;
char *argv[];
{
	bit08 chip,reg,value, delay_low, delay_high, m_r11;
	int opt,mode;
	char *optionS="abd:fhk:l:m:ocprs:t:";
	short delay;
	bit08 stohex();
	void regwrite(),setboard();
	long int i;
	printf("Modem Set-up Program Version %s\n", VERSION);
	init();
	m_r11=0;
	while((opt=getopt(argc, argv, optionS)) !=EOF){

	switch(opt){
case 'r':
	reset();
	break;
case 'h':
	Hangup();
	break;
case 'p':
	EnablePowerSave();
	break;
case 'f':
	far_end_echo(FAR_ON);
	break;
case 'c':
	CheckSum();
	break;
case 'b':
	printf("Setting board B\n");
	setboard(1);
	if(regread(1,0x12) !=0x80){
		printf("modem board b not found\n");
		exit(1);
	}
	V32rate(OFF);
	WriteDspRam(0x3a, 0, 0x3c);
	break;
case 'a':
	printf("Setting board A\n");
	setboard(0);
	if(regread(1,0x12) !=0x80){
		printf("modem board a not found\n");
		exit(1);
	}
	V32rate(OFF);
	WriteDspRam(0x3a, 0, 0x3c);
	break;
case 'o':		/* turn on sync to async overspeed */
	m_r11=m_r11|0x80;
	regwrite(0, STA_ADD, m_r11);
	break;
case 'k':
	switch(optarg[0])
	{
	case '8':
		m_r11=m_r11|0x44;
		break;
	case '9':
		m_r11=m_r11|0x55;
		break;
	case '1':
		switch(optarg[1])
		{
		case '0':
		  m_r11=m_r11|0x66;
		  break;
		case '1':
		  m_r11=m_r11|0x77;
		  break;
		default:
		  printf("unsupported character length, assuming 10 bits\n");
		  m_r11=m_r11|0x66;
		}
		break;

	default:
		printf("unsupported character length, assuming 10 bits\n");
		m_r11=m_r11|0x66;
	}
	regwrite(0, STA_ADD, m_r11);
	break;
case 't':
	i=atoi(optarg);
	printf("setting transmit level to: %d\n", i);
	transmitlevel(i);
	break;
case 'd':
	connect();
	for(i=0; i<100000; i++);
	i=0;
	while (optarg[i]!=NULL)
	{
		dial(optarg[i++]);
	}
	break;

case 's':
	switch(optarg[0])
	{
	case '9':
		V32rate(SC);
		break;
	case 'u':
		V32rate(S9600);
		break;
	case '4':
		V32rate(S4800);
		break;
	case '7':
		V32rate(S7200);
		break;
	case '1':
		if(optarg[1]=='4')
		{
		  V32rate(S14400);
		}
		else if(optarg[1]=='2')
		{
		  V32rate(S12000);
		}
		break;
	default:
		printf("unknown rate sequence:  assuming 9600 coded\n");
		V32rate(SC);
	}
	break;
case 'l':
	switch(optarg[0])
	{
	case '2':
	   printf("Setting up low speed rate selection for V.22bis 2400 bps\n");
	   lowrate(L2400);
	   break;
	case '1':
	   printf("Setting up low speed rate selection for V.22 1200 bps\n");
	   lowrate(L1200);
	   break;
	case '6':
	   printf("Setting up low speed rate selection for V.22 600 bps\n");
	   lowrate(L600);
	   break;
	case '3':
	   printf("Setting up low speed rate selection for V.21 300 bps\n");
	   lowrate(L300);
	   break;
	case 'v':
	   printf("Setting up low speed rate selection for V.23 1200 bps\n");
	   printf("transmission if answer modem,  1200 bps receiver if\n");
	   printf("originate modem.  Back channel is always 75 bps\n");
	   lowrate(LV23);
	   break;
	case 'f':
	  switch(optarg[1])
	  {
	  case '9':
	   printf("Setting up low speed rate selection for V.29 9600 bps\n");
	   lowrate(F9600);
	   break;
	  case '7':
	   printf("Setting up low speed rate selection for V.29 7200 bps\n");
	   lowrate(F7200);
	   break;
	  case '4':
	   printf("Setting up low speed rate selection for V.27ter 4800 bps\n");
	   lowrate(F4800);
	   break;
	  case '2':
	   printf("Setting up low speed rate selection for V.27ter 2400 bps\n");
	   lowrate(F2400);
	   break;
	  case '3':
	   printf("Setting up low speed rate selection for V.21 300 bps FAX\n");
	   lowrate(F300);
	   break;
	  default:
	      printf("Unknown low speed rate sequence");
	       exit(1);
	}
	break;
	default:
	   printf("Unknown low speed rate sequence");
	   exit(1);
	}
	break;
case 'm':
	switch (optarg[0]) {
	case 'a':
		printf("starting up in answer mode\n");
		mode=ANSWER;
		WaitForRing();
		connect();
		startup(mode);
		break;
	case 'o':
		printf("starting up in originate mode\n");
		mode=ORIGINATE;
		connect();
		startup(mode);
		break;
	case 'l':
		printf("starting up in local-loop mode\n");
		LocalLoop();
		break;
	case 't':
		printf("starting up in Fax Transmit mode\n");
		FaxTransmit();
		connect();
		startup(1);
		break;
	case 'r':
		printf("starting up in Fax Receive mode\n");
		FaxReceive();
		connect();
		startup(0);
		break;
	default:
		printf("illegal mode\n");
		exit(1);
	}
	break;
case '?':
default:
	usage();
}
}
}

startup(int mode)
{

	WAIT_FOR_DIALER;
	wait_for_core_read();
	regwrite(1,0x8,mode);
	regwrite(1,0x9,0xe);		/* DO startup.			*/
}

V32rate(int rate)
{
	int i;
	wait_for_core_read();
	switch(rate){
	case OFF:
		printf("V32 rate is OFF\n");
		regwrite(1,0x4,0x00);		/* Set v32_rate_seq for 9600. */
		regwrite(1,0x5,0x00);
		break;
	case S14400:
		printf("V32 rate is 14400\n");
		regwrite(1,0x4,SSYNCL|SBIS|S4800|S9600);
		regwrite(1,0x5,SSYNCH|S14400|S12000|S7200|SC);
		break;
	case S12000:
		printf("V32 rate is 12000\n");
		regwrite(1,0x4,SSYNCL|SBIS|S4800|S9600);
		regwrite(1,0x5,SSYNCH|S12000|S7200|SC);
		break;
	case S7200:
		printf("V32 rate is 7200\n");
		regwrite(1,0x4,SSYNCL|SBIS|S4800);
		regwrite(1,0x5,SSYNCH|S7200);
		break;
	case S9600:
		printf("V32 rate is 9600 uncoded\n");
		regwrite(1,0x4,SSYNCL|S4800|S9600);
		regwrite(1,0x5,SSYNCH);
		break;
	case SC:
		printf("V32 rate is 9600 coded\n");
		regwrite(1,0x4,SSYNCL|S4800|S9600);
		regwrite(1,0x5,SSYNCH|SC);
		break;
	case S4800:
		printf("V32 rate is 4800\n");
		regwrite(1,0x4,SSYNCL|S4800);
		regwrite(1,0x5,SSYNCH);
		break;
	default:
		printf("V32 rate is 9600\n");
		regwrite(1,0x4,SSYNCL|SBIS|S4800|S9600);
		regwrite(1,0x5,SSYNCH|S7200|SC);
	}
	regwrite(1,0x6,0x1);
	regwrite(1,0x7,0x0);
	regwrite(1,0x8,0x0);
	regwrite(1,0x9,0x1);
}

lowrate(int rate)
{
	int i;
	printf("setting lowrate sequence\n");
	wait_for_core_read();
	switch(rate)
	{
	case L2400:
		lratel=lratel|L2400;
		break;
	case L1200:
		lratel=lratel|L1200;
		break;
	case L600:
		lratel=lratel|L600;
		break;
	case L300:
		lratel=lratel|L300;
		break;
	case LV23:
		lratel=lratel|LV23;
		break;
	case F9600:
		lrateh=lrateh|((F9600&0xff00)>>8);
		break;
	case F7200:
		lrateh=lrateh|((F7200&0xff00)>>8);
		break;
	case F4800:
		lrateh=lrateh|((F4800&0xff00)>>8);
		break;
	case F2400:
		lrateh=lrateh|((F2400&0xff00)>>8);
		break;
	case F300:
		lrateh=lrateh|((F300&0xff00)>>8);
		break;
	default:
		break;
	}

	regwrite(1,0x4,lratel);
	regwrite(1,0x5,lrateh);
	regwrite(1,0x6,0x2);
	regwrite(1,0x7,0x0);
	regwrite(1,0x8,0x0);
	regwrite(1,0x9,0x1);
}

connect()
{
	int i;
	printf("Modem is now Off-hook\n");
	wait_for_core_read();
	regwrite(1,0x9,0x11);
}

reset()
{
	int i;
	printf("Reseting both boards\n");

	OUTPORT(0x300,0xff);
	for (i=0; i<10000; i++);
	OUTPORT(0x300,0x00);
	for (i=0; i<10000; i++);
	OUTPORT(0x300,0xff);
	for (i=0; i<10000; i++);
	OUTPORT(0x300,0x00);
	for (i=0; i<10000; i++);
	OUTPORT(0x300,0xff);
	for (i=0; i<10000; i++);
	OUTPORT(0x300,0x00);
}


far_end_echo(int flag)
{
	int i;
	int low, high;
	if (flag==FAR_ON)
		printf("Turning the Far Echo Canceller ON\n");
	if (flag==FAR_OFF)
		printf("Turning the Far Echo Canceller OFF\n");
	low = ReadDspRam(0x38)&0x00ff;
	high = ((ReadDspRam(0x38)&0xff00)>>8)|flag;
	WriteDspRam( low,high, 0x38);


}


dial(char digit)	/* The dialer is not yet complete */
{

	int i;
	i=0;
	switch (digit)
	{
	case '0':
	case '1':
	case '2':
	case '3':
	case '4':
	case '5':
	case '6':
	case '7':
	case '8':
	case '9':
		printf("%c",digit);
		WAIT_FOR_DIALER;
		wait_for_core_read();
		regwrite(1,0x8,digit-'0');
		regwrite(1,0x9,0xa);
	break;
	case '*':
		printf("%c",digit);
		WAIT_FOR_DIALER;
		wait_for_core_read();
		regwrite(1,0x8,0xa);
		regwrite(1,0x9,0xa);
	break;
	case '#':
		printf("%c",digit);
		WAIT_FOR_DIALER;
		wait_for_core_read();
		regwrite(1,0x8,0xb);
		regwrite(1,0x9,0xa);
	break;

	case '-':
		for (i=0; i < DASHDELAY; i++);
		break;
	default:
		printf("digit must be between 0 and 9\n");
		exit();
	}
}

wait_for_core_read()
{
	while((regread(0, 0x10)&CRBNKI)!=CRBNKI)kbhit();
	/*printf("Out\n");*/
	regwrite(0, 0xf, CRBNKI);
}

wait_for_core_write()
{
	while((regread(0, 0x10)&CWBNKI)!=CWBNKI)kbhit();
	/*printf("Out\n");*/
	regwrite(0, 0xf, CWBNKI);
}

Hangup()
{
	wait_for_core_read();
	regwrite(1, 0x9, 0x12);
}

CheckSum()
{
	regwrite(1, 0x9, 0x14);	/* Dummy write to init mail boxes. */
	while(regread(1, 0xf) != 0x3)kbhit();
	printf("Checksum = %x\n", ReadDspRam(0x49));
}

init()
{
	setboard(0);
	regwrite(0, 0xf, 0xff);		/* clear status bits */
	regread(1,0xf);		/* Dummy read to init. mail boxes.*/
	regwrite(1, 0x9, 0x14);	/* Dummy write to init mail boxes. */

	setboard(1);
	regwrite(0, 0xf, 0xff);		/* clear status bits */
	regread(1,0xf);		/* Dummy read to init. mail boxes.*/
	regwrite(1, 0x9, 0x14);	/* Dummy write to init mail boxes. */

}

transmitlevel(int level)
{
	WriteDspRam(level, 0, 3);
}
LocalLoop()
{
	wait_for_core_read();
	regwrite(1, 0x9, 0xc);
}

WriteDspRam(int lvalue, int hvalue, int address)
{
	wait_for_core_read();
	regwrite(1, 0x4, lvalue);
	regwrite(1, 0x5, hvalue);
	regwrite(1, 0x6, address);
	regwrite(1, 0x7, 0);
	regwrite(1, 0x8, 0);
	regwrite(1, 0x9, 1);
}

ReadDspRam(int address)
{
	wait_for_core_read();
	regwrite(1, 0x6, address);
	regwrite(1, 0x7, 0);
	regwrite(1, 0x8, 0);
	regwrite(1, 0x9, 4);
	wait_for_core_write();
	return(regread(1,0xd)| (regread(1,0xe)<<8));
}

FaxTransmit()
{
	unsigned int low, high;
	low = ReadDspRam(0x02);
	low = low & 0x00ff;
	printf("Writing %x to low half of V.22 rate sequence\n", low);
	high = ((ReadDspRam(0x02)&0xff00)>>8);
	printf("Read %x from high half of V.22 rate sequence\n", high);
	high = high|FTX;
	printf("Writing %x to high half of V.22 rate sequence\n", high);
	WriteDspRam( low,high, 0x02);
}

FaxReceive()
{
	unsigned int low, high;
	low = ReadDspRam(0x02);
	low = low & 0x00ff;
	printf("Writing %x to low half of V.22 rate sequence\n", low);
	high = ((ReadDspRam(0x02)&0xff00)>>8);
	printf("Read %x from high half of V.22 rate sequence\n", high);
	high = high|FRX;
	printf("Writing %x to high half of V.22 rate sequence\n", high);
	WriteDspRam( low,high, 0x02);
}

WaitForRing()
{
	printf("I am waiting for the calling modem to ring\n");
	printf("If you want to fall through hit a key\n");
	while((regread(1,0xa)&0x20)!=0x20)
	{
		if(kbhit())
		{
			printf("Skipping Ring\n");
			getch();
			break;
		}
	}
	printf("Ring!!!\n");
	while((regread(1,0xa)&0x20)==0x20);
}

EnablePowerSave()
{
	int low, high;
	low = ReadDspRam(0x38)&0x00ff;
	high = ((ReadDspRam(0x38)&0xff00)>>8)|0x2;
	WriteDspRam( low,high, 0x38);
}
usage()
{
	printf("modem [/r] /[a|b] [/s v32speed] [/l low speed] [/m a|o|l]\n");
	printf("/r - resets all advice cards that are in PC\n");
	printf("/a - selects board A\n");
	printf("/b - selects board B\n");
	printf("The remaining option should always be after /a or /b option on the command line\n");
	printf("/s v32speed  - selects v32 speed\n");
	printf("	v32speed\n");
	printf("	4800  - 4800 bps\n");
	/*printf("	7200  - 7200 bps TC reserved for future V.32bis pump\n");*/
	printf("	9600  - 9600 bps TC\n");
	printf("	u     - 9600 bps uncoded\n");
	/*printf("	12000 - 12000 bps TC reserved for future V.32bis pump\n");*/
	/*printf("	14400 - 14400 bps TC reserved for future V.32bis pump\n");*/
	printf("/l lowspeed  - selects low speed\n");
	printf("	lowspeed\n");
	printf("	2400  - 2400 bps (V.22bis)\n");
	printf("	1200 - 1200 bps (V.22)\n");
	printf("	300 - 0-300 bps (V.21)\n");
	printf("/c - performs a checksum on the DSP's ROM code\n");
	printf("/t value - adjust the modem's trnasmit level\n");
}


