.MODULE/boot=0 optimized_biquad_sub; 
{ 
        Optimized Cascaded Biquad IIR Filter Subroutine (Direct Form I) 
 
        Calling Parameters 
                SR1 = input sample 
                I0 --> delay line buffer in data memory 
                       x(n-2),x(n-1),y(n-2),y(n-1) order 
                L0 = delay line length = 2N+2 (N = # biquads) 
                I4 --> scaled coefficients in program memory 
                       b2,b1,b0,a2,a1 order 
                L4 = 2.5 * filter order --or-- 5 * number of biquad sections 
                M0 = 0 
                M1,M4 = 1 
                M3,M5 = -1 
                CNTR = number of biquad sections 
                SE = shift count (must be same for all biquad sections) 
 
        Return Values 
                SR1 = output sample 
                I0 --> new delay line buffer start address 
                I4 --> top of coefficients 
 
        Altered Registers 
                MX0,MY0,MR,SR 
 
        Computation Time 
                6 * number of biquad sections + 5 cycles 
 
        All coefficients and data values are assumed to be in 1.15 format. 
} 
 
.ENTRY  optbiq; 
 
optbiq: 
 
         MX0=DM(I0,M1), MY0=PM(I4,M4); {x=x(n-2), y=b2} 
         DO sections UNTIL CE; 
            MR=MX0*MY0(SS), MX0=DM(I0,M1), MY0=PM(I4,M4); 
                                       {mult, x=x(n-1), y=b1} 
            MR=MR+MX0*MY0(SS), MY0=PM(I4,M4); 
                                       {mac, y=b0} 
            MR=MR+SR1*MY0(SS), MX0=DM(I0,M1), MY0=PM(I4,M4); 
                                       {mac, x=y(n-2), y=a2} 
            MR=MR+MX0*MY0(SS), MX0=DM(I0,M3), MY0=PM(I4,M4); 
                                       {mac, x=y(n-1), y=a1} 
            MR=MR+MX0*MY0(RND), MX0=DM(I0,M0), MY0=PM(I4,M4); 
                                       {mac, x=next x(n-2), y=next b2} 
sections:   DM(I0,M1)=SR1, SR=ASHIFT MR1 (HI); 
                                       {x(n)->new x(n-1), scale result} 
         MX0=DM(I0,M1), MY0=PM(I4,M5); 
         DM(I0,M1)=SR1;                {store last result into delay line} 
                                       {must return new I0} 
         RTS; 
 
.ENDMOD;                                                                                                                     