/* fir.s -- A 5-tap FIR filter  -- Passband 0 to 1 kHz
	Stopband begins at 2.5 kHz, Loss > 18 dB	*/

/* ----------------------------------------------------------*/

.global sample, end, coef, data

	ioc = 0x0987	/* precision codec using DSP32 clock */

sample:	if (ibe) goto sample
	r1 = data
	r3 = data
	r2 = coef

	a1 = float (ibuf)	/* input a sample, convert to float */

	a0 = *r1++ * *r2++	/* 5-tap FIR filter  */
	a0 = a0 + (*r3++ = *r1++) * *r2++
	a0 = a0 + (*r3++ = *r1++) * *r2++
	a0 = a0 + (*r3++ = *r1++) * *r2++
	a0 = a0 + (*r3++ = a1)  *   *r2++

	goto sample
end:	obuf = a0 = int(a0)	/* output */

coef:	float .0609004, .312186, .437500, .312186, .0609004

data:	4*float 0.0

