/* Example 3 -- Input block oriented processing using SIO input DMA */

#define input1  = 0xf800	/* user defined assembly-time variables  */
#define end_in1 = 0xfbfc	/*   this example reserves two 256-word  */
#define input2  = 0xfc00	/*     buffers in RAM2 (on-chip RAM)     */
#define end_in2 = 0xfffc

	r1 = input1		/* initialize buffer 1 start address     */
	r2 = end_in1		/* initialize buffer 1  end  address     */
	r3 = input2		/* initialize buffer 2 start address     */
	r4 = end_in2		/* initialize buffer 2  end  address     */
	pin = r1		/* initialize buffer 1 DMA pointer       */
	ioc = 0x2987		/* enables DMA on serial input           */

buffer1:pin - r2		/* waits for buffer 1 full, note pin */
	if (le) goto buffer1	/* autoincrements by 4 after each DMA */
	r5 = r1			/* process algorithm uses r5 as data pointer */

buffer2:pin - r4		/* waits for buffer2 full */
	if (le) goto buffer2
	r5 = r3
	call process (r13)
	pin = r1
	goto buffer1
	nop

process: /* put the block oriented signal processing algorithm here;         */
	 /* process time must be less than the total time to fill the buffer */

	return (r13)
end:	nop
