/* Example 3  -  DMA input with block processing */

.global in1, in2, algor
#define input1  = 0xf800	/* user defined variables  */
#define end_in1 = 0xfafc	/* reserves 128 32-bit locations */
#define input2  = 0xfb00
#define end_in2 = 0xfdff

	r1=input1		/* input buffer 1 starting address */
	r2=end_in1		/* input buffer 1 ending  address  */
	r3=input2		/* input buffer 2 starting address */
	r4=end_in2		/* input buffer 2 ending  address  */

	pin=r1			/* initialize buffer 1 DMA pointer */
	ioc=0x2986		/* enables DMA on serial input/output */
in1:	pin-r2			/* waits until input buffer 1 full */
	if(le) goto in1		/* autoincrements by 4 each DMA cycle */
	r5=r1			/* user algorithm uses r5 as pointer */
	call algor(r13)		/* calls user block process routine */
	pin=r3
in2:	pin-r4			/* waits for buffer2 to fill */
	if(le) goto in2
	r5=r3
	call algor(r13)
	pin=r1
	goto in1
	nop
algor:	/* user block processing algorithm goes here; process */
	/*   time must be less than time to fill the buffer   */

