/* TERM.H Include File */

#define     NULL	' '
#define     TERM	0
#define     HOST	1
#define     IN		0
#define     OUT		1

/*
 * flag structure for tty interpretation & control
 */

struct	{
  unsigned rbreak : 1;		/* line status ( 1=break)	*/
  unsigned iraw : 1;		/* input processing		*/
  unsigned oraw : 1;		/* output processing		*/
  unsigned echo : 1;		/* echo input chars		*/
  unsigned rcr2nl : 1;		/* turn rx'd carrets to nl's	*/
  unsigned rcr2null : 1;	/* turn rx'd carrets to nulls	*/ 
  unsigned tnl2crnl : 1;	/* turn tx'd newlines to cr-nl	*/
  unsigned crt : 1;
  unsigned xoff: 1;		/* ^S without matching ^Q	*/
  unsigned txirq : 1;		/* 1 if interrupts on, 0 if off	*/
  char abort;			/* abort key, default ^C	*/
  int speed;
  int lines;			/* number of lines seen		*/
  char *catstr;			/* "CAT" for UNIX (srload.s)	*/
  char erase;			/* erase char, default ^H	*/
  char kill;			/* kill char, default ^U	*/
} typedef  DFLAGS;

/*
 *  default initialization for DFLAG structures
 */

#define   DEF_SPEED	600
#define   DEF_ERASE	8
#define   DEF_KILL	21	/* ^U */
#define   DEF_ABRT	3	/* ^C */

/*
 *  other definitions
 */

#define   NEWLINE	'\n'
#define   CARRET	'^'
#define   XON		021
#define   XOFF		023
#define   ESCAPE	033
#define   HEX		0
#define   DEC		1
#define   IOCGETP	1
#define   IOCSETP	2

