/* Demonstrate DMA operations using serial port for multiprocessor app. */
/* Program master.s  */

.global  loop1,Zsin,waitdma,wait2,finish,delay1,delay2,done
.global  table1,end1,table2,end2,table3,end3,table4,end4

#define num 10

/* Start sending table1 and wait until the entire table has been sent. */

	r5 = table1
obuf = a0 = *r5

	ioc = 0x0dc6		/* Let OCK clear the olsr. */
	r7 = 13
loop1:	if (r7-- >0) goto loop1
	pout = table1+4		/* Set pointer. */
	ioc = 0x4fc6		/* Enable output DMA. */

	r1 = end1
waitdma:pout - r1
	if (le) goto waitdma
	nop

/* Send table2 and receive table4.  Operate on the data in table2 at
   the same time and place the output at table3.   */

	pout = tabe2		/* Set pointer to output table2. */
	pin = table4		/* Prepare to input table4. */
	ioc = 0x6fc6		/* Enable output and input DMA. */
	r6 = table2
	r7 = table3
	r8 = num-2

/*  This routine computes the sine of the argument pointed to by
    r6 and stores the computed value in the table pointed to by r7. */

Zsin:	r2 = ZsinA		/* r2 points to coefficient */
	a2 = *r6 * *r6		/* a2 = x**2 */
	a0 = *r6		/* a0 = x */
	nop
	a3 = a2 * *r6++		/* a3 = x**3 */
	a2 = *r2++ + a2 * *r2++  /* c3 + c4*x**2 */
	a1 = *r2++ + a2 * *r2++  /* c1 + c2*x**2 */
	a3 = a3 * a0		/* a3 =x**4 */
	a2 = a2 * a3		/* c3*x**3 + c4*x**5 */
	a1 = a0 + a1 * a3	/* x + c1*x**3 + c2*x**5 */
	nop
	a0 = a1 + a2 * a3	/* x + c1*x**3 + c2*x**5 + c3*x**7 + c4*x**9 */
*r7++ = a0=round(a0)


	if (r8-- >0) goto Zsin
	nop

	r1 = end2+8		/* Two words past the last word. */
finish: pout - r1		/* Wait until everything is out. */
	if (lt) goto finish
	nop

	ioc = 0x2dc6		/* Stop all output, keep OCK running. */

/*  Stop DMA output to demonstarte how to turn the output on and off. */

	r6 = 64
delay2: r5 = 32767		/* Wait a few seconds. */
delay1: if (r5-- >0) goto delay1
	nop

	if (r6-- >0) goto delay2
	nop

/*  Send out table 3. */

	r5 = table3
 obuf = a0 = *r5		/* Place the first word in obuf. */
	pout = table3+4
	ioc = 0x4fc6		/* Enable output DMA */
	r1 = end3 + 12
wait2:	pout - r1
	if (lt) goto wait2
	nop

	ioc = 0xcc6		/* Stop all DMA operation. */

done:	goto done
	nop

table1: float 1.0,2.0,3.0,4.0,5.0,6.0,7.0,8.0,9.0
end1:	float 10.0

/*  coefficients:  c4               c3             c2               c1       */
ZsinA:	float 0.2601903036e-5,-0.198074182e-3,0.8333025139e-2,-0.1666665668

table2: float 1.57076,0.7853982,0.0,-0.7853982,-1.570796,1.570796,0.7853982
	float 0.0,-0.7853982
end2:	float -1.570796

table3: num-1*float 0.0
end3:	float 0.0

table4: 14*int 0
end4:	int 0
