/* Demonstrate DMA operations using serial port for multiprocessor app. */
/* Program slave.s  */

.global  loop1,loop2,wait1,waitdma,wait2,done
.global  indata1,last1,indata2,last2,odata,end,indata3,last3,

#define num 10

/* Wait for a block of input data of length num. */

	pin = indata1
	r1 = last1
	ioc = 0x2cc6		/* Enable input DMA operation. */

loop1:	pin - r1
	if (le) goto loop1	/* Check if all input is complete */
	nop

/* Prepare to input data and send out data. */

	pin = indata2		/* Move pointer to receive table2 */
	r5 = odata
obuf = a0 = *r5

	ioc = 0x2dc6		/* Enable OCK. */
	r7 = 13
loop2:	if (r7-- >0) goto loop2
	pout = odata+4		/* Prepare to output data (latent). */
	ioc = 0x6fc6		/* Enable input and output DMA. */

	r1 = end+12
waitdma:pout - r1		/* Output will finish first. */
	if (lt) goto waitdma
	nop

	ioc = 0x2cc6		/* Turn off the output. */

	r1 = last2
wait1:	pin - r1
	if (le) goto wait1	/* Check if all input is complete. */
	nop

/* Receive a block of data after the wait loop. */

	pin = indata3		/* Move pointer to receive table2. */

	r1 = last3
wait2:	pin - r1
	if (le) goto wait2	/* Check if all input is complete. */
	nop

	ioc = 0xcc6		/* Stop everything now! */

done:	goto done
	nop

indata1: num-1*float 0.0
last1:	 float 0.0

indata2: num-1*float 0.0
last2:	 float 0.0

odata:	 int 0x1111,0x2222,0x3333,0x4444,0x5555,0x6666,0x7777,0x8888
	 int 0x9999,0xaaaa,0xbbbb,0xcccc,0xdddd,0xeeee
end:	 int 0xffff

.align 4
indata3: num-1*float 0.0
last3:	 float 0.0

