.module/boot=1/boot=2        pre_emphasize_speech; 

{ PREEMP.DSP - pre-emphasizes a frame of speech. (filters it)
  
  INPUT:
     i0 -> speech frame to be filtered
     l0 =  0
      Frame is altered!!
  
  OUTPUT:     frame of speech is emphasized

  FUNCTIONS CALLED:
     None

  DESCRIPTION:
     Filters the speech using   H(z) = 1 - 0.9375*z-1
}

{Include constant definitions}
#include "lpc.h"

.entry    pre_emph;

.external overflow;

.var/dm/ram   delay;

pre_emph:
  
  {preemphasize}
  mx0 = 0x8801;            {b1 = -0.9375}
  cntr = FRAME_LENGTH;
  do filt_speech until ce;
    mr  = 0;
    my0 = dm(delay);         {x(n-1)}
    mr1 = dm(i0,m0);         {x(n)}
    dm(delay) = mr1;         {update delay with x(n)}
    mr  = mr + mx0*my0 (ss); {x(n) + b1*x(n-1)} 
      if mv call overflow;
  filt_speech: dm(i0,m1) = mr1; {store filtered sample}
rts;
  
.endmod;