.module/boot=0/abs=0      talk_through;

{  TLK_THR.DSP - talk through shell
}
  { include constant definitions }
#include "lpc.h";

.var/dm/ram/circ  analys_buf[FRAME_LENGTH];
.var/dm/ram/circ  receive_buf[FRAME_LENGTH];
.var/dm/ram/circ  synth_buf[FRAME_LENGTH];
.var/dm/ram/circ  transmit_buf[FRAME_LENGTH];

{load interrupt vectors}
  jump start_test; nop; nop; nop;   {restart interrupt}
  jump change_demo; rti; nop; nop;
  call trns_ir; rti; nop; nop;  {sport0 transmit}
  call rcv_ir; rti; nop; nop;   {sport0 receive}
  rti; nop; nop; nop;
  rti; nop; nop; nop;
  rti; nop; nop; nop;

change_demo:
  icntl = b#00111;
  ax0 = dm(0x3fff);
  ay0 = 0xfc3f; {clear bootpage settings}
  ar  = ax0 and ay0;
  ay0 = 0x0040;  {set new bootpage = 1}
  ar  = ar or ay0;
  ay0 = 0x0200;  {set bootforce bit}
  ar  = ar or ay0;
  dm(0x3fff) = ar;
rts;


start_test:

  {configure sports etc.}
  ax0 = 0x0000;
  dm(0x3ffe) = ax0;  {dm waits = 0}
  ax0 = 0x6927;
  dm(0x3ff6) = ax0;  {set sport0 control reg}
  ax0 = 2;
  dm(0x3ff5) = ax0;  {set sclkdiv to 64 khz}
  ax0 = 255;
  dm(0x3ff4) = ax0;  {set rclkdiv to 64 khz}
  ax0 = 0x00e7;      
  dm(0x3ff3) = ax0;  {tireg = i0, tmreg = m1, tbuf enable}
                     {rireg = i6, rmreg = m5, rbuf enable} 
                     
  {dedicated registers}
  m0 = 0;  m4 = 0;
  m1 = 1;  m5 = 1;
  i0 = ^transmit_buf;   l0 = %transmit_buf; 
  i2 = ^synth_buf;      l2 = %synth_buf;
  i6 = ^receive_buf;    l6 = %receive_buf; 
  i7 = ^analys_buf;     l7 = %analys_buf;
  
  cntr = FRAME_LENGTH;
  ax0 = 0;
  do buf_clr until ce;
    dm(i0,m1) = ax0;
    dm(i2,m1) = ax0;
    dm(i6,m5) = ax0;
  buf_clr: dm(i7,m5) = ax0;


{enable sport0 and interrupts}
  ax0 = 0x1038;
  dm(0x3fff) = ax0; 

  ax0 = 0;
  tx0 = ax0;
    
  nop;
  icntl = b#10111;
  imask = b#111000;

          
wait: idle;
  jump wait;

{End of main routine}

{Autobuffering interrupt routines}

trns_ir:

{switch pointers}
  ax0 = i0;        
  ax1 = i2;
  i0 = ax1;
  i2 = ax0;

  rts;


rcv_ir:

{switch pointers}
  ay0 = i6;        
  ay1 = i0;
  i6 = ay1;
  i0 = ay0;


  cntr = FRAME_LENGTH;
  do frame_copy until ce;
    ay0 = dm(i7,m5);
  frame_copy: dm(i2,m1) = ay0; 

  rts;


.endmod;


